#include <string.h>

#include "d88.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cD88::cD88( void )
{
	PRINTD( D88_LOG, "[D88][cD88]\n" )
	
	ZeroMemory( &d88, sizeof( D88INFO ) );
	
	Protected = FALSE;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cD88::~cD88( void )
{
	if( d88.fp ) fclose( d88.fp );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cD88::Init( char *fname )
{
	PRINTD1( D88_LOG, "[D88][Init] %s\n", fname )
	
	strncpy( FileName, fname, PATH_MAX );
	
	// ե򳫤
	// ɤ߽񤭤ǳ
	if( !( d88.fp=fopen( FileName, "rb+" ) ) ){
		// ʤɤ߼Ѥǳ
		if( !( d88.fp=fopen( FileName, "rb" ) ) ){
			*FileName = 0;
			return FALSE;
		}else
			Protected = TRUE;	// ץƥȥ뤢
	}
	
	ReadHeader88();	// D88 إåɹ
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// D88 إåɹ
////////////////////////////////////////////////////////////////
void cD88::ReadHeader88( void )
{
	PRINTD( D88_LOG, "[D88][ReadHeader88]\n" )
	
	if( d88.fp ){
		// DISK̾
		fread( d88.name, sizeof(BYTE), 17, d88.fp );
		d88.name[16] = '\0';
		
		// ꥶֶɤ
		fread( d88.reserve, sizeof(BYTE), 9, d88.fp );
		
		// 饤ȥץƥ
		d88.protect = fgetc( d88.fp );
		if( d88.protect ) Protected = TRUE;
		else if( Protected ) d88.protect = 0x10;
		
		// DISKμ
		d88.type = fgetc( d88.fp );
		
		// DISKΥ
		d88.size = GETDWORD( d88.fp );
		
		// ȥåΥեåȥơ֥
		for( int i=0; i<164; i++ )
			d88.table[i] = GETDWORD( d88.fp );
		
		PRINTD1( D88_LOG, " FileName : %s\n", d88.name )
		PRINTD1( D88_LOG, " Protect  : %s\n", d88.protect ? "ON" : "OFF" )
		PRINTD1( D88_LOG, " Format   : %d\n", d88.type )
		PRINTD1( D88_LOG, " Size     : %d\n", (int)d88.size )
	}
}


////////////////////////////////////////////////////////////////
// D88 ɹ
////////////////////////////////////////////////////////////////
void cD88::ReadSector88( void )
{
//	PRINTD( D88_LOG, "[D88][ReadSector88]\n" );
	
	if( d88.fp ){
		d88.secinfo.c = fgetc( d88.fp );			// ID  C (No ̤ξ=ȥåNo)
		d88.secinfo.h = fgetc( d88.fp );			// ID  H (إåɥ쥹 ̤ξ=0)
		d88.secinfo.r = fgetc( d88.fp );			// ID  R (ȥåΥNo)
		d88.secinfo.n = fgetc( d88.fp );			// ID  N ( 0:256 1:256 2:512 3:1024)
		d88.secinfo.sec_nr  = GETWORD( d88.fp );	// Υȥå¸ߤ륻ο
		d88.secinfo.density = fgetc( d88.fp );		// Ͽ̩     0x00:̩   0x40:ñ̩
		d88.secinfo.deleted = fgetc( d88.fp );		// DELETED MARK 0x00:Ρޥ 0x10:DELETED
		d88.secinfo.status  = fgetc( d88.fp );		// ơ
		fread( d88.secinfo.reserve, sizeof(BYTE), 5, d88.fp );	// ꥶֶɤ
		d88.secinfo.size   = GETWORD( d88.fp );		// ΥΥǡ
		d88.secinfo.data   = ftell( d88.fp );		// ǡؤΥեå
		d88.secinfo.offset = 0;						// ɹǡΥƬΥեå
		
//		PRINTD1( D88_LOG, " C      : %d\n", d88.secinfo.c )
//		PRINTD1( D88_LOG, " H      : %d\n", d88.secinfo.h )
//		PRINTD1( D88_LOG, " R      : %d\n", d88.secinfo.r )
//		PRINTD1( D88_LOG, " N      : %d\n", d88.secinfo.n )
//		PRINTD1( D88_LOG, " SectNum: %d\n", d88.secinfo.sec_nr )
//		PRINTD1( D88_LOG, " Density: %s\n", d88.secinfo.density&0x40 ? "D" : "DD" )
//		PRINTD1( D88_LOG, " Del    : %s\n", d88.secinfo.deleted&0x10 ? "DELETED" : "NORMAL" )
//		PRINTD1( D88_LOG, " Stat   : %02X\n", d88.secinfo.status )
//		PRINTD1( D88_LOG, " Size   : %d\n", d88.secinfo.size )
//		PRINTD1( D88_LOG, " Offset : %d\n", (int)d88.secinfo.data )
	}
}


////////////////////////////////////////////////////////////////
// 1byte ɹ
////////////////////////////////////////////////////////////////
BYTE cD88::Getc88( void )
{
	PRINTD( D88_LOG, "[D88][Getc88] -> " )
	
	if( d88.fp ){
		BYTE dat = fgetc( d88.fp );
		d88.secinfo.offset++;
		
		PRINTD1( D88_LOG, "%02X\n", dat );
		
		// νã鼡Υ򥷡
		// (ۤ?Ʊȥå˸ꤷȤۤ?)
		if( d88.secinfo.offset >= d88.secinfo.size ) ReadSector88();
		
		return dat;
	}
	PRINTD( D88_LOG, "FALSE(0xff)\n" );
	
	return 0xff;
}


////////////////////////////////////////////////////////////////
// 1byte 
////////////////////////////////////////////////////////////////
BOOL cD88::Putc88( BYTE dat )
{
	PRINTD5( D88_LOG, "[D88][Putc88] -> %02X(%02d:%02d:%02d:%02d)", dat, d88.secinfo.c, d88.secinfo.h, d88.secinfo.r, d88.secinfo.n );
	
	if( d88.fp && !d88.protect ){
		fseek( d88.fp, 0, SEEK_CUR );	// ޤäݤ
		fputc( dat, d88.fp );
		fseek( d88.fp, 0, SEEK_CUR );	// 
		d88.secinfo.offset++;
		
		// νã鼡Υ򥷡
		// (ۤ?Ʊȥå˸ꤷȤۤ?)
		if( d88.secinfo.offset >= d88.secinfo.size ) ReadSector88();
		
		PRINTD( D88_LOG, " ->OK\n" );
		
		return TRUE;
	}
	PRINTD( D88_LOG, " ->NG\n" );
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cD88::Seek88( int trackno, int sectno )
{
	PRINTD2( D88_LOG, "[D88][Seek88] Track : %d Sector : %d", trackno, sectno );
	
	if( d88.fp ){
		// ȥå̵ʤ饨顼
		if( !d88.table[trackno] ) return FALSE;
		PRINTD1( D88_LOG, " -> Track:%d\n", trackno );
		
		// ȥåƬ򥷡
		fseek( d88.fp, d88.table[trackno], SEEK_SET );
		
		// ǽΥɹ
		ReadSector88();
		if( d88.secinfo.sec_nr < sectno ) return FALSE;	// ֹͭ?
		PRINTD1( D88_LOG, " -> Sector:%d", sectno );
		
		// ŪΥޤǶɤ
		int TryCnt = 2;	// ȥ饤
		while( d88.secinfo.r != sectno ){
			// ȥå2ƸĤʤХ顼
			if( !TryCnt ) return FALSE;
			fseek( d88.fp, (long)d88.secinfo.size, SEEK_CUR );
			ReadSector88();	// Υɹ
			if( d88.secinfo.r == d88.secinfo.sec_nr ) TryCnt--;
		}
		PRINTD( D88_LOG, " -> OK\n" );
		
		return TRUE;
	}
	PRINTD( D88_LOG, " -> FALSE\n" );
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ߤCHRN
////////////////////////////////////////////////////////////////
DWORD cD88::GetCHRN( void )
{
	PRINTD( D88_LOG, "[D88][GetCHRN]\n" );
	
	return d88.secinfo.c<<24 || d88.secinfo.h<<16 || d88.secinfo.r<<8 || d88.secinfo.n;
}


////////////////////////////////////////////////////////////////
// ե̾
////////////////////////////////////////////////////////////////
char *cD88::GetFileName( void )
{
	return FileName;
}


////////////////////////////////////////////////////////////////
// DISK᡼̾
////////////////////////////////////////////////////////////////
char *cD88::GetDiskImgName( void )
{
	return (char *)d88.name;
}


////////////////////////////////////////////////////////////////
// ץƥȥּ
////////////////////////////////////////////////////////////////
BOOL cD88::IsProtect( void )
{
	return Protected;
}
