#ifndef DISK_H_INCLUDED
#define DISK_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "d88.h"
#include "ini.h"

#include "p6device.h"

// ɥ饤³
#define	MAXDRV	2

// ߥ˥եåԡǥ Ƽ
typedef struct{
	int ATN;			// Attention		:ޥ׵
	int DAC;			// Data Accepted	:ǡ
	int RFD;			// Ready For Data	:ǡ
	int DAV;			// Data Valid		:ǡ
	
	int command;		// äޥ
	int step;			// ѥ᡼Ԥơ
	
	int blk;			// ž֥å
	int drv;			// ɥ饤ֹ-1
	int trk;			// ȥåֹ
	int sct;			// ֹ
	
	int size;			// Хȿ
	
	BYTE retdat;		// port D0H ֤
	
} DISK60;


// ޥ
// ºݤˤ PC-80S31 ΥޥɤƱ
enum FddCommand
{
	INIT				= 0x00,
	WRITE_DATA			= 0x01,
	READ_DATA			= 0x02,
	SEND_DATA			= 0x03,
	COPY				= 0x04,
	FORMAT				= 0x05,
	SEND_RESULT_STATUS	= 0x06,
	SEND_DRIVE_STATUS	= 0x07,
	TRANSMIT			= 0x11,
	RECEIVE				= 0x12,
	LOAD				= 0x14,
	SAVE				= 0x15,
	
	WAIT				= 0xff,	// Ԥξ
	EndofFdcCmd
};

////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class DSK6 : public IDoko {
protected:
	int DrvNum;							// ɥ饤ֿ
	char FilePath[MAXDRV][PATH_MAX];	// եѥ
	cD88 *d88[MAXDRV];					// D88֥ȤؤΥݥ
	BOOL Sys[MAXDRV];					// ƥǥե饰
	
public:
	DSK6( int );						// 󥹥ȥ饯
	virtual ~DSK6();					// ǥȥ饯
	
	virtual BOOL Init() = 0;			// 
	
	BOOL Mount( int, char * );			// DISK ޥ
	void Unmount( int );				// DISK ޥ
	
	int GetDrives();					// ɥ饤ֿ
	
	BOOL IsMount( int );				// ޥȺѤ?
	BOOL IsSystem( int );				// ƥǥ?
	BOOL IsProtect( int );				// ץƥ?
	
	char *GetFile( int );				// եѥ
	char *GetName( int );				// DISK̾
};


class DSK60 : public Device, public DSK6 {
private:
	DISK60 mdisk;			// ߥ˥եåԡǥƼ
	
	BYTE FddIn();			// DISK˥åȤΥǡ (port D0H)
	void FddOut( BYTE );	// DISK˥åȤؤΥޥɡǡ (port D1H)
	BYTE FddCntIn();		// DISK˥åȤ濮 (port D2H)
	void FddCntOut( BYTE );	// DISK˥åȤؤ濮 (port D3H)
	
	BYTE io_D1H;
	BYTE io_D2H;
	BYTE io_D3H;
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutD1H( int, BYTE data ){ io_D1H = data; FddOut( io_D1H ); }
	inline void OutD2H( int, BYTE data ){ io_D2H = (io_D2H&0x0f) | (data&0xf0); }
	inline void OutD3H( int, BYTE data ){ io_D3H = data; FddCntOut( io_D3H ); }
	inline BYTE InD0H( int ){ return FddIn(); }
	inline BYTE InD1H( int ){ return io_D1H; }
	inline BYTE InD2H( int ){ io_D2H = FddCntIn(); return io_D2H; }
	inline BYTE InD3H( int ){ return io_D3H; }
	
public:
	DSK60( const ID&, int );		// 󥹥ȥ饯
	~DSK60();						// ǥȥ饯
	
	BOOL Init();					// 
	
	// ǥХID
	enum IDOut{ outD1H=0, outD2H, outD3H };
	enum IDIn {  inD0H=0,  inD1H,  inD2H, inD3H };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


// ǡХåե(256BytesX4)
class cFDCbuf {
protected:
	BYTE Data[4][256];
	int Index[4];
	
public:
	cFDCbuf();						// 󥹥ȥ饯
	~cFDCbuf();						// ǥȥ饯
	
	void Push( int, BYTE );			// ǡХåե˥ǡ
	BYTE Pop( int );				// ǡХåեǡФ
	
	void Clear( int i ){ Index[i] = 0; }	// Хåե򥯥ꥢ
};


class DSK66 : public Device, public DSK6, public cFDCbuf {
private:
	struct CmdBuffer {
		BYTE Data[10];
		int Index;
	};
	
	CmdBuffer CmdIn;				// ޥɥХåե
	CmdBuffer CmdOut;				// ơХåե
	
	void PushStatus( int );			// ơХåե˥ǡ
	BYTE PopStatus();				// ơХåեǡФ
	void OutFDC( BYTE );			// FDC ˽
	BYTE InFDC();					// FDC ɹ
	void Exec();					// FDC ޥɼ¹
	void Read();					// Read
	void Write();					// Write
	void Seek();					// Seek
	void SenseInterruptStatus();	// Sense Interrupt Status
	
	BYTE SeekST0[4];				// SEEKST0
	BYTE LastCylinder[4];			// Ǹ˥
	BOOL SeekEnd[4];				// λե饰
	BYTE SendSectors;				// ž(100Hñ)
	BOOL DIO;						// ǡž TRUE: Buffer->CPU FALSE: CPU->Buffer
	
	BYTE Status;					// FDC ơ쥸
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB1H( int, BYTE data ){ DIO = data&2 ? TRUE : FALSE; }	// FD⡼
	inline void OutB2H( int, BYTE data ){}									// FDC INT?
	inline void OutB3H( int, BYTE data ){}									// PortB2h
//	inline void OutD0H( int, BYTE data ){ if( !DIO ) cFDCbuf::Push( 0, data ); }	// Buffer
//	inline void OutD1H( int, BYTE data ){ if( !DIO ) cFDCbuf::Push( 1, data ); }	// Buffer
//	inline void OutD2H( int, BYTE data ){ if( !DIO ) cFDCbuf::Push( 2, data ); }	// Buffer
//	inline void OutD3H( int, BYTE data ){ if( !DIO ) cFDCbuf::Push( 3, data ); }	// Buffer
	inline void OutD0H( int, BYTE data ){ cFDCbuf::Push( 0, data ); }		// Buffer
	inline void OutD1H( int, BYTE data ){ cFDCbuf::Push( 1, data ); }		// Buffer
	inline void OutD2H( int, BYTE data ){ cFDCbuf::Push( 2, data ); }		// Buffer
	inline void OutD3H( int, BYTE data ){ cFDCbuf::Push( 3, data ); }		// Buffer
	inline void OutD6H( int, BYTE data ){}									// ɥ饤֥쥯
	inline void OutD8H( int, BYTE data ){}									// 񤭹 ???
	inline void OutDAH( int, BYTE data ){ SendSectors = ~( data - 0x10 ); }	// ž̻
	inline void OutDDH( int, BYTE data ){ OutFDC( data ); }					// FDC ǡ쥸
	inline void OutDEH( int, BYTE data ){}									// ?
	
	inline BYTE InB2H( int ){ return 1; };									// FDC INT
//	inline BYTE InD0H( int ){ return DIO ? cFDCbuf::Pop( 0 ) : 0; }			// Buffer
//	inline BYTE InD1H( int ){ return DIO ? cFDCbuf::Pop( 1 ) : 0; }			// Buffer
//	inline BYTE InD2H( int ){ return DIO ? cFDCbuf::Pop( 2 ) : 0; }			// Buffer
//	inline BYTE InD3H( int ){ return DIO ? cFDCbuf::Pop( 3 ) : 0; }			// Buffer
	inline BYTE InD0H( int ){ return cFDCbuf::Pop( 0 ); }					// Buffer
	inline BYTE InD1H( int ){ return cFDCbuf::Pop( 1 ); }					// Buffer
	inline BYTE InD2H( int ){ return cFDCbuf::Pop( 2 ); }					// Buffer
	inline BYTE InD3H( int ){ return cFDCbuf::Pop( 3 ); }					// Buffer
	inline BYTE InD4H( int ){ return 0; }									// ?
	inline BYTE InDCH( int ){ return Status; }								// FDC ơ쥸
	inline BYTE InDDH( int ){ return InFDC(); }								// FDC ǡ쥸

public:
	DSK66( const ID&, int );		// 󥹥ȥ饯
	~DSK66();						// ǥȥ饯
	
	BOOL Init();					// 
	
	// ǥХID
	enum IDOut{ outB1H=0, outB2H, outB3H, outD0H, outD1H, outD2H,
				outD3H,   outD6H, outD8H, outDAH, outDDH, outDEH };
	enum IDIn {  inB2H=0,  inD0H,  inD1H,  inD2H,  inD3H,  inD4H,  inDCH,  inDDH };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};

#endif	// DISK_H_INCLUDED
