#include <limits.h>
#include <stdlib.h>

#include "graph.h"
#include "common.h"
#include "global.h"
#include "debug.h"
#include "memory.h"
#include "osd.h"
#include "schedule.h"
#include "status.h"


#define	P6WIDTH		(256)
#define	P6HEIGHT	(192)
#define	P2WIDTH		(320)
#define	P2HEIGHT	(200)

// ̾復ɥ
#define	P6WINW		(320)
#define	P6WINH		(240)

// ;򥵥
#define	FRAMEW		(16)
#define	FRAMEH		(0)

#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
// ǥХå⡼ɥɥ
#define	P6DEBUGW	(P6WINW+FRAMEW+vm->regw->Width())
#define	P6DEBUGH	(max(P6WINH+FRAMEH,vm->regw->Height()+vm->memw->Height())+vm->monw->Height())
#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


// 顼å
static BYTE COL_MODE1[4];		// mode 1 -----
static BYTE COL_MODE2[8];		// mode 2 -----
static BYTE COL_MODE3[10][4];	// mode 3 -----
static BYTE COL_MODE4[2][2];	// mode 4 -----


// --------- 60 ---------
static const BYTE COL60_MODE1[] =		// mode 1 -----
				{ 17,18,19,20 };

static const BYTE COL60_MODE2[] =		// mode 2 -----
				{ 21,22,23,24,25,26,27,28 };

static const BYTE COL60_MODE3[][4] =	// mode 3 -----
			{	{ 29,30,31,32 },
				{ 33,34,35,36 },
				{ 37,41,42,38 },	// mode4
				{ 39,45,46,40 },	// mode4
				{ 37,42,41,38 },	// mode4
				{ 39,46,45,40 },	// mode4
				{ 37,43,44,38 },	// mode4
				{ 39,47,48,40 },	// mode4
				{ 37,44,43,38 },	// mode4
				{ 39,48,47,40 }};	// mode4

static const BYTE COL60_MODE4[][2] =	// mode 4 -----
			{	{ 37,38 },
				{ 39,40 }};

static const BYTE COL60_MODE4A[][14] =	// mode 4 ˤ -----
			{	{ 37,38,37,38,37,38,37,38,37,38,37,38,37,38 },
				{ 39,40,65,66,67,68,69,70,71,72,73,74,75,76 }};

// --------- mk2 ---------
static const BYTE COL62_MODE1[] =		// mode 1-1 -----
				{ 64,57,59,57 };

static const BYTE COL62_MODE2[] =		// mode 1-2 -----
				{ 59,60,31,58,64,63,62,50 };

static const BYTE COL62_MODE3[][4] =	// mode 1-3 -----
			{	{ 59,60,61,58 },
				{ 64,63,62,50 },
				{ 57,41,42,59 },	// mode1-4
				{ 57,45,46,64 },	// mode1-4
				{ 57,42,41,59 },	// mode1-4
				{ 57,46,45,64 },	// mode1-4
				{ 57,43,44,59 },	// mode1-4
				{ 57,47,48,64 },	// mode1-4
				{ 57,44,43,59 },	// mode1-4
				{ 57,48,47,64 }};	// mode1-4

static const BYTE COL62_MODE4[][2] =	// mode 1-4 -----
			{	{ 57,59 },
				{ 57,64 }};

static const BYTE COL_MOD21[] =			// mode 2-1,2 -----
				{ 49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64 };

static const BYTE COL_MOD23[][16] =		// mode 2-3 -----
			{	{49,53,50,54,51,55,52,56,57,61,58,62,59,63,60,64},
				{59,60,61,58,64,63,62,50,59,60,61,58,64,63,62,50}};

static const BYTE COL_MOD24[][16] =		// mode 2-4 -----
			{	{49,53,50,54,51,55,52,56,57,61,58,62,59,63,60,64},
				{59,60,61,58,64,63,62,50,59,60,61,58,64,63,62,50}};



////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
DSP6::DSP6( VM6 *vm ) : P6DEVICE(vm)
{
	// ݥ󥿽
	bbuf  = NULL;				// ХåХåե
	sbuf  = NULL;				// ХåХåե(饤)
	Font1 = NULL;				// ⡼1ѥʥեȡ
	Font2 = NULL;				// ⡼1ѥmk2եȡ
	
	
	// ѥåȽ
	for( int i=0; i<128; i++ ){
		// ɸ५顼
		GPal[i].r = vm->cGlobal::UserColor[i].r;
		GPal[i].g = vm->cGlobal::UserColor[i].g;
		GPal[i].b = vm->cGlobal::UserColor[i].b;
		// 饤ѥ顼
		GPal[i+128].r = ( GPal[i].r * vm->cGlobal::ScanLineBr ) / 100;
		GPal[i+128].g = ( GPal[i].g * vm->cGlobal::ScanLineBr ) / 100;
		GPal[i+128].b = ( GPal[i].b * vm->cGlobal::ScanLineBr ) / 100;
	}
	
	Mode4Col = DEFAULT_MODE4_COLOR;
	
	CrtDisp  = TRUE;
	N60Win   = TRUE;
	
	VramAddr = 0xc200;
	AttrAddr = 0xc000;
}

DSP60::DSP60( VM6 *vm, const ID& id ) : DSP6(vm), Device(id){}

DSP62::DSP62( VM6 *vm, const ID& id ) : DSP6(vm), Device(id)
{
	Mk2CharMode  = TRUE;
	Mk2GraphMode = FALSE;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
DSP6::~DSP6( void )
{
	if( Font2 )  SDL_FreeSurface( Font2 );
	if( Font1 )  SDL_FreeSurface( Font1 );
	if( sbuf )   SDL_FreeSurface( sbuf );
	if( bbuf )   SDL_FreeSurface( bbuf );
}

DSP60::~DSP60( void ){}
DSP62::~DSP62( void ){}


////////////////////////////////////////////////////////////////
// ȥӥ塼ȥǡ
////////////////////////////////////////////////////////////////
BYTE DSP6::GetAttr( WORD addr )
{
	return vm->mem->ReadMainRam( AttrAddr + addr );
}


////////////////////////////////////////////////////////////////
// VRAMǡ
////////////////////////////////////////////////////////////////
BYTE DSP6::GetVram( WORD addr )
{
	return vm->mem->ReadMainRam( VramAddr + addr );
}


////////////////////////////////////////////////////////////////
// ե˥ѥå
////////////////////////////////////////////////////////////////
BOOL DSP6::InitPalette( SDL_Surface *scr )
{
	PRINTD( GRP_LOG, "[GRP][InitPalette]\n" );
	
	if( SDL_SetColors( scr, GPal, 0, 255 ) ) return TRUE;
	else                                     return FALSE;
}


////////////////////////////////////////////////////////////////
// ꡼󥵡ե
////////////////////////////////////////////////////////////////
BOOL DSP6::SetScreenSurface( void )
{
	PRINTD( GRP_LOG, "[GRP][SetScreenSurface]\n" );
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// ˥⡼?
		
		PRINTD2( GRP_LOG, " -> Monitor Mode ( X:%d Y:%d )\n", P6DEBUGW, P6DEBUGH );
		
		if( !SDL_SetVideoMode( P6DEBUGW, P6DEBUGH, 8, SDL_SWSURFACE | SDL_DOUBLEBUF | SDL_RESIZABLE ) ) return FALSE;
	}else
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{	int x = P6WINW;
		int y = P6WINH;
		
		if( DISPSCAN ){	// 饤󤢤?
			x *= 2;
			y *= 2;
		}
		
		if( DISPFULL ){	// ե륹꡼?
			
			PRINTD2( GRP_LOG, " -> FullScreen ( X:%d Y:%d )\n", x, y );
			
			// ޥä
			SDL_ShowCursor( SDL_DISABLE );
			// ꡼󥵡ե
			if( !SDL_SetVideoMode( x, y, 8, SDL_SWSURFACE | SDL_DOUBLEBUF | SDL_FULLSCREEN | SDL_ANYFORMAT ) ) return FALSE;
			
			PRINTD3( GRP_LOG, " -> OK ( %d x %d x %d )\n", SDL_GetVideoSurface()->w, SDL_GetVideoSurface()->h, SDL_GetVideoSurface()->format->BitsPerPixel );
			
		}else{
			// ơСɽ?
			if( DISPSTAT ) y += vm->staw->Height();
			
			PRINTD2( GRP_LOG, " -> Window ( X:%d Y:%d )\n", x+FRAMEW, y+FRAMEH );
			
			// ꡼󥵡ե
			if( !SDL_SetVideoMode( x+FRAMEW, y+FRAMEH, 8, SDL_SWSURFACE | SDL_DOUBLEBUF ) ) return FALSE;
		}
	}
	
	// ե륹꡼Ǥʤ?
	if( !DISPFULL ){
		// ɥץ
		SDL_WM_SetCaption( vm->cGlobal::WCaption, "" );
		// ޥɽ
		SDL_ShowCursor( SDL_ENABLE );
	}
	
	// ꡼󥵡ե˥ѥåȤ򤹤
	if( InitPalette( SDL_GetVideoSurface() ) ) return TRUE;
	else                                       return FALSE;
}


////////////////////////////////////////////////////////////////
// ХåХåե
////////////////////////////////////////////////////////////////
BOOL DSP6::SetBackBuffer( void )
{
	PRINTD( GRP_LOG, "[GRP][SetBackBuffer]\n" );
	
	int x,y;
	
	// ɥ N60? N60m?
	if( N60Win ){ x = P6WIDTH; y = P6HEIGHT; }	// N60
	else        { x = P2WIDTH; y = P2HEIGHT; }	// N60m
	
	// Ѥߤʤ餤ä
	if( bbuf ) SDL_FreeSurface( bbuf );
	if( sbuf ) SDL_FreeSurface( sbuf );
	
	// ХåХåե&ѥå
	bbuf = SDL_CreateRGBSurface( SDL_SWSURFACE, x, y, 8, 0, 0, 0, 0 );
	if( !bbuf ) return FALSE;
	if( !InitPalette( bbuf ) ) return FALSE;
	
	// 饤󤢤?
	if( DISPSCAN ){
		// ХåХåե&ѥå
		sbuf = SDL_CreateRGBSurface( SDL_SWSURFACE, x*2, y*2, 8, 0, 0, 0, 0 );
		if( !sbuf ) return FALSE;
		if( !InitPalette( sbuf ) ) return FALSE;
	}
	
	// ꡼󥵡եɤĤ֤
	if( SDL_FillRect( SDL_GetVideoSurface(), NULL, 0 ) ) return FALSE;
	else                                                 return TRUE;
}


////////////////////////////////////////////////////////////////
// ơС
////////////////////////////////////////////////////////////////
BOOL DSP6::SetStatusBar( void )
{
	PRINTD( GRP_LOG, "[GRP][SetStatusBar]\n" );
	
	if( vm->staw->Init() ) return TRUE;
	else               return FALSE;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL DSP6::InitCommon( void )
{
	PRINTD( GRP_LOG, "[GRP][InitCommon]\n" );
	
	// ⡼1ѥŸ
	Font1 = SDL_CreateRGBSurface( SDL_SWSURFACE, 8*256, 12, 8, 0, 0, 0, 0 );
	if( !Font1 ) return FALSE;
	
	SDL_LockSurface( Font1 );
	Uint8 *Pointer = (Uint8 *)Font1->pixels;
	for( int j=0; j<12; j++ ){
		for( int i=0; i<256; i++ ){
			BYTE c = vm->mem->ReadCGrom1( i*16+j );
			for( int k=7; k>=0; k-- ){
					*Pointer++ = ( ((c>>k)&1)? 0xff : 0 );
			}
		}
	}
	SDL_UnlockSurface( Font1 );
	
	// ⡼1(mk2)ѥŸ
	Font2 = SDL_CreateRGBSurface( SDL_SWSURFACE, 8*512, 10, 8, 0, 0, 0, 0 );
	if( !Font2 ) return FALSE;
	
	SDL_LockSurface( Font2 );
	Pointer = (Uint8 *)Font2->pixels;
	for( int j=0; j<10; j++ ){
		for( int i=0; i<512; i++ ){
			BYTE c = vm->mem->ReadCGrom2( i*16+j );
			for( int k=7; k>=0; k-- ){
					*Pointer++ = ( ((c>>k)&1)? 0xff : 0 );
			}
		}
	}
	SDL_UnlockSurface( Font2 );
	
	// ꡼󥵡ե
	if( !SetScreenSurface() ) return FALSE;
	
	// ХåХåե
	if( !SetBackBuffer() ) return FALSE;
	
	// ơС
	if( !SetStatusBar() ) return FALSE;
	
	return TRUE;
}

BOOL DSP60::Init( void )
{
	PRINTD( GRP_LOG, "[GRP][60][Init]\n" );
	
	// 顼
	for( int i=0; i<4; i++ ) COL_MODE1[i] = COL60_MODE1[i];
	for( int i=0; i<8; i++ ) COL_MODE2[i] = COL60_MODE2[i];
	for( int i=0; i<10; i++ )
		for( int j=0; j<4; j++ )
			COL_MODE3[i][j] = COL60_MODE3[i][j];
	for( int i=0; i<2; i++ )
		for( int j=0; j<2; j++ )
			COL_MODE4[i][j] = COL60_MODE4[i][j];
	
	// ʬ
	return DSP6::InitCommon();
}

BOOL DSP62::Init( void )
{
	PRINTD( GRP_LOG, "[GRP][62][Init]\n" );
	
	// 顼
	for( int i=0; i<4; i++ ) COL_MODE1[i] = COL62_MODE1[i];
	for( int i=0; i<8; i++ ) COL_MODE2[i] = COL62_MODE2[i];
	for( int i=0; i<10; i++ )
		for( int j=0; j<4; j++ )
			COL_MODE3[i][j] = COL62_MODE3[i][j];
	for( int i=0; i<2; i++ )
		for( int j=0; j<2; j++ )
			COL_MODE4[i][j] = COL62_MODE4[i][j];
	
	// ʬ
	return DSP6::InitCommon();
}


////////////////////////////////////////////////////////////////
// CRT KILL
////////////////////////////////////////////////////////////////
void DSP6::CrtKill( void )
{
	PRINTD( GRP_LOG, "[GRP][CrtKill]\n" );
	
	SDL_FillRect( bbuf, NULL, COL_MODE1[1] );
}

void DSP62::CrtKill( void )
{
	PRINTD( GRP_LOG, "[GRP][CrtKill]\n" );
	
	// mk2ʹߤξ
	//  RGBϤξϿù?
	//  ӥǥϤξϺ
	SDL_FillRect( bbuf, NULL, COL_MODE1[1] );
	
	// ξ
//	for( int y=0; y<bbuf->h; y++ ){
//		BYTE *sur = (BYTE *)bbuf->pixels + bbuf->pitch * y;
//		for( int x=0; x<bbuf->w; x+=8 ){
//			BYTE d = rand();
//			for( int i=0; i<8; i++ ){
//				*sur++ = d&1 ? COL_MODE1[0] : COL_MODE1[1];
//				d >>= 1;
//			}
//		}
//	}
}


////////////////////////////////////////////////////////////////
// ⡼ѥ֥롼
////////////////////////////////////////////////////////////////

// ----------------------------------
//     PC-6001
// ----------------------------------

// ⡼1 1ʸPUT
void DSP6::Putc_M1( int x, int y, WORD addr )
{
	PRINTD3( GRP_LOG, "[GRP][Putc_M1] -> x:%d y:%d addr:%04X\n", x, y, addr );
	
	BYTE data,attr;
	DWORD fg,bg;
	DWORD *soff,*doff;
	
	data = GetVram( addr );
	attr = GetAttr( addr );
	
	doff = (DWORD *)bbuf->pixels + x*2 + y*bbuf->pitch*12/sizeof(DWORD);
	soff = (DWORD *)Font1->pixels + data*8/sizeof(DWORD);
	fg   = COL_MODE1[attr&3];
	fg  |= fg<<8 | fg<<16 | fg<<24;
	bg   = COL_MODE1[attr&2 | ~attr&1];
	bg  |= bg<<8 | bg<<16 | bg<<24;
	for( int yc=0; yc<12; yc++ ){
		*doff++ = *soff&fg | ~*soff++&bg;
		*doff   = *soff&fg | ~*soff++&bg;
		doff   += bbuf->pitch/sizeof(DWORD)-1;
		soff   += Font1->pitch/sizeof(DWORD)-2;
	}
}


// ⡼2-1 1ʸPUT
void DSP6::Putc_M2( int x, int y, WORD addr)
{
	PRINTD3( GRP_LOG, "[GRP][Putc_M2] -> x:%d y:%d addr:%04X\n", x, y, addr );
	
	BYTE data,attr;
	DWORD fg,bg,d1,d2;
	DWORD *doff;
	
	data = GetVram( addr );
	attr = GetAttr( addr );
	
	doff = (DWORD *)bbuf->pixels + x*2 + y*bbuf->pitch*12/sizeof(DWORD);
	fg   = COL_MODE2[(attr<<1)&4 | (data>>6)&3];
	fg  |= fg<<8 | fg<<16 | fg<<24 ;
	bg   = 0x10101010;	// No.16()
	
	d1 = data&0x20? fg: bg;
	d2 = data&0x10? fg: bg;
	for( int yc=0; yc<4; yc++ ){
		*doff++ = d1;
		*doff   = d2;
		doff   += bbuf->pitch/sizeof(DWORD)-1;
	}
	
	d1 = data&0x08? fg: bg;
	d2 = data&0x04? fg: bg;
	for( int yc=4; yc<8; yc++ ){
		*doff++ = d1;
		*doff   = d2;
		doff   += bbuf->pitch/sizeof(DWORD)-1;
	}
	
	d1 = data&0x02? fg: bg;
	d2 = data&0x01? fg: bg;
	for( int yc=8; yc<12; yc++ ){
		*doff++ = d1;
		*doff   = d2;
		doff   += bbuf->pitch/sizeof(DWORD)-1;
	}
}


// ⡼2-2 1ʸPUT
void DSP6::Putc_M22( int x, int y, WORD addr)
{
	PRINTD3( GRP_LOG, "[GRP][Putc_M22] -> x:%d y:%d addr:%04X\n", x, y, addr );
	
	BYTE data,attr;
	DWORD fg,bg,d1,d2;
	DWORD *doff;
	
	data = GetVram( addr );
	attr = GetAttr( addr );
	
	doff = (DWORD *)bbuf->pixels + x*2 + y*bbuf->pitch*12/sizeof(DWORD);
	fg   = COL_MODE2[(data>>4)&7];
	fg  |= fg<<8 | fg<<16 | fg<<24;
	bg   = 0x10101010;	// No.16()
	
	d1 = data&0x08? fg: bg;
	d2 = data&0x04? fg: bg;
	for( int yc=0; yc<6; yc++ ){
		*doff++ = d1;
		*doff   = d2;
		doff += bbuf->pitch/sizeof(DWORD)-1;
	}
	
	d1 = data&0x02? fg: bg;
	d2 = data&0x01? fg: bg;
	for( int yc=6; yc<12; yc++ ){
		*doff++ = d1;
		*doff   = d2;
		doff += bbuf->pitch/sizeof(DWORD)-1;
	}
}



#define PUT1LINE											\
	*(DOff++  ) = d;										\
	if( !--DWidth ){										\
		DWidth  = P6WIDTH/sizeof(DWORD);					\
		DOff   += P6WIDTH/sizeof(DWORD) * (CRLines-1);		\
		DLines -= CRLines;									\
		CRLines = 1;										\
	}

#define PUT2LINE											\
	if( DLines > 1 ) *(DOff+P6WIDTH/sizeof(DWORD)  ) = d;	\
	*(DOff++  ) = d;										\
	if( !--DWidth ){										\
		DWidth  = P6WIDTH/sizeof(DWORD);					\
		DOff   += P6WIDTH/sizeof(DWORD) * (CRLines-1);		\
		DLines -= CRLines;									\
		CRLines = 1;										\
	}

#define PUT3LINE											\
	if( DLines > 2 ) *(DOff+P6WIDTH/sizeof(DWORD)*2) = d;	\
	if( DLines > 1 ) *(DOff+P6WIDTH/sizeof(DWORD)  ) = d;	\
	*(DOff++  ) = d;										\
	if( !--DWidth ){										\
		DWidth  = P6WIDTH/sizeof(DWORD);					\
		DOff   += P6WIDTH/sizeof(DWORD) * (CRLines-1);		\
		DLines -= CRLines;									\
		CRLines = 1;										\
	}

// ⡼3
void DSP6::Putc_M3( BYTE vram, int css )
{
	PRINTD( GRP_LOG, "[GRP][Putc_M3]\n" );
	
	DWORD d;
	
	d  = (DWORD)COL_MODE3[css][(vram>>6)&3];
	d |= (DWORD)COL_MODE3[css][(vram>>4)&3]<<16;
	d |= d<<8;
	PUT1LINE;
	d  = (DWORD)COL_MODE3[css][(vram>>2)&3];
	d |= (DWORD)COL_MODE3[css][ vram    &3]<<16;
	d |= d<<8;
	PUT1LINE;
}


// ⡼4
void DSP6::Putc_M4( BYTE vram, int css )
{
	PRINTD( GRP_LOG, "[GRP][Putc_M4]\n" );
	
	DWORD d;
	
	if( Mode4Col ){		// 顼ɽ
		// 128192 顼
		css += Mode4Col*2;
		d  = (DWORD)COL_MODE3[css][(vram>>6)&3];
		d |= (DWORD)COL_MODE3[css][(vram>>4)&3]<<16;
		d |= d<<8;
		PUT1LINE;
		d  = (DWORD)COL_MODE3[css][(vram>>2)&3];
		d |= (DWORD)COL_MODE3[css][ vram    &3]<<16;
		d |= d<<8;
		PUT1LINE;
	}else{
		// 256192 Υ
		d  = (DWORD)COL_MODE4[css][(vram>>7)&1];
		d |= (DWORD)COL_MODE4[css][(vram>>6)&1]<< 8;
		d |= (DWORD)COL_MODE4[css][(vram>>5)&1]<<16;
		d |= (DWORD)COL_MODE4[css][(vram>>4)&1]<<24;
		PUT1LINE;
		d  = (DWORD)COL_MODE4[css][(vram>>3)&1];
		d |= (DWORD)COL_MODE4[css][(vram>>2)&1]<< 8;
		d |= (DWORD)COL_MODE4[css][(vram>>1)&1]<<16;
		d |= (DWORD)COL_MODE4[css][ vram    &1]<<24;
		PUT1LINE;
	}
}


// 12896 顼
void DSP6::Putc_M32( BYTE vram, int css )
{
	PRINTD1( GRP_LOG, "[GRP][Putc_M32] -> %d\n", css );
	
	DWORD d;
	
	d  = (DWORD)COL_MODE3[css][(vram>>6)&3];
	d |= (DWORD)COL_MODE3[css][(vram>>4)&3]<<16;
	d |= d<<8;
	PUT2LINE;
	d  = (DWORD)COL_MODE3[css][(vram>>2)&3];
	d |= (DWORD)COL_MODE3[css][ vram    &3]<<16;
	d |= d<<8;
	PUT2LINE;
	
	CRLines = max( CRLines, 2 );
}


// 12864 顼
void DSP6::Putc_M33( BYTE vram, int css )
{
	PRINTD1( GRP_LOG, "[GRP][Putc_M33] -> %d\n", css );
	
	DWORD d;
	
	d  = (DWORD)COL_MODE3[css][(vram>>6)&3];
	d |= (DWORD)COL_MODE3[css][(vram>>4)&3]<<16;
	d |= d<<8;
	PUT3LINE;
	d  = (DWORD)COL_MODE3[css][(vram>>2)&3];
	d |= (DWORD)COL_MODE3[css][ vram    &3]<<16;
	d |= d<<8;
	PUT3LINE;
	
	CRLines = max( CRLines, 3 );
}


// 6464 顼
void DSP6::Putc_M34( BYTE vram, int css )
{
	PRINTD1( GRP_LOG, "[GRP][Putc_M34] -> %d\n", css );
	
	DWORD d;
	
	for( int i=7; i>0; --i ){
		d  = (DWORD)COL_MODE3[css][(vram>>(--i))&3];
		d |= d<<8;
		d |= d<<16;
		PUT3LINE;
	}
	CRLines = max( CRLines, 3 );
}


// 12896 Υ
void DSP6::Putc_M41( BYTE vram, int css )
{
	PRINTD1( GRP_LOG, "[GRP][Putc_M41] -> %d\n", css );
	
	DWORD d;
	
	for( int i=7; i>0; --i ){
		d  = (DWORD)COL_MODE4[css][(vram>>(i--))&1];
		d |= (DWORD)COL_MODE4[css][(vram>> i   )&1]<<16;
		d |= d<<8;
		PUT2LINE;
	}
	CRLines = max( CRLines, 2 );
}


// 128192 Υ
void DSP6::Putc_M42( BYTE vram, int css )
{
	PRINTD1( GRP_LOG, "[GRP][Putc_M42] -> %d\n", css );
	
	DWORD d;
	
	for( int i=7; i>0; --i ){
		d  = (DWORD)COL_MODE4[css][(vram>>(i--))&1];
		d |= (DWORD)COL_MODE4[css][(vram>> i   )&1]<<16;
		d |= d<<8;
		PUT1LINE;
	}
}


// 12864 Υ
void DSP6::Putc_M43( BYTE vram, int css )
{
	PRINTD1( GRP_LOG, "[GRP][Putc_M43] -> %d\n", css );
	
	DWORD d;
	
	for( int i=7; i>0; --i ){
		d  = (DWORD)COL_MODE4[css][(vram>>(i--))&1];
		d |= (DWORD)COL_MODE4[css][(vram>> i   )&1]<<16;
		d |= d<<8;
		PUT3LINE;
	}
	CRLines = max( CRLines, 3 );
}


// ----------------------------------
//     Mode 1,2 sub
// ----------------------------------
void DSP6::Mode_12( void )
{
	PRINTD( GRP_LOG, "[GRP][Mode_12]\n" );
	
	WORD AVOFF = 0;
	
	for( int y=0; y<16; y++ ){
		for( int x=0; x<32; x++ ){
			switch( GetAttr(AVOFF)&0x60 ){
			case 0x00:			// *** ⡼0 ***
			case 0x20:			// *** ⡼1 ***
				Putc_M1( x, y, AVOFF );
				break;
			case 0x60:			// *** ⡼2-1 ***
				Putc_M2( x, y, AVOFF );
				break;
			case 0x40:			// *** ⡼2-2 ***
				Putc_M22( x, y, AVOFF );
				break;
			}
			AVOFF++;
		}
	}
}


// ----------------------------------
//     Mode 3,4 sub
// ----------------------------------
void DSP6::Mode_34( void )
{
	PRINTD( GRP_LOG, "[GRP][Mode_34]\n" );
	
// ȥӥ塼Ȥ(?)ɽ
	DOff = (DWORD *)bbuf->pixels;					// ХåХåեؤΥݥ
	DWORD *DMax = DOff + (P6WIDTH*P6HEIGHT)/sizeof(DWORD);	// ХåХåեü(+1)ؤΥݥ
	int AOff = 0;
	int VOff = 0;
	
	CRLines = 1;
	DWidth = P6WIDTH/sizeof(DWORD);
	DLines = P6HEIGHT;
	
	while( DOff < DMax ){
		int Css   = (GetAttr(AOff)>>1)&1;	// 顼å
		int Gmode = (GetAttr(AOff)>>2)&7;	// եå⡼(07)
		BYTE Vram = GetVram( VOff++ );		// VRAMǡ
		
		switch( Gmode ){
		case 0:		//  64 64 顼
			Putc_M34( Vram, Css );
			break;
		case 1:		// 128 96 顼
			Putc_M32( Vram, Css );
			break;
		case 2:		// 128 64 顼
			Putc_M33( Vram, Css );
			break;
		case 3:		// 128192 顼
			Putc_M3( Vram, Css );
			break;
		case 4:		// 128 64 Υ
			Putc_M43( Vram, Css );
			break;
		case 5:		// 128192 Υ
			Putc_M42( Vram, Css );
			break;
		case 6:		// 128 96 Υ
			Putc_M41( Vram, Css );
			break;
		case 7:		// 256192 Υ
			Putc_M4( Vram, Css );
			break;
		}
		++AOff &= 0x1ff;	// ȥӥ塼Ȥ512bytesǥ롼
	}
}


// ----------------------------------
//     PC-6001mk2
// ----------------------------------

// [mk2] ⡼1 1ʸPUT
void DSP62::Putc_M21( int x, int y, WORD addr )
{
	PRINTD3( GRP_LOG, "[GRP][62][Putc_M21] -> x:%d y:%d addr:%04X\n", x, y, addr );
	
	BYTE data,attr;
	DWORD fg,bg;
	DWORD *soff,*doff;
	
	data = GetVram( addr );
	attr = GetAttr( addr );
	doff = (DWORD *)bbuf->pixels + x*2 + y*bbuf->pitch*10/sizeof(DWORD);
	soff = (DWORD *)Font2->pixels + (data+((attr&0x80)?256:0))*8/sizeof(DWORD);
	fg   = COL_MOD21[attr&0x0f];
	fg  |= fg<<8 | fg<<16 | fg<<24;
	bg   = COL_MOD21[((attr>>4)&0x07)|((Css2&1)<<3)];
	bg  |=  bg<<8 | bg<<16 | bg<<24;
	for( int yc=0; yc<10; yc++ ){
		*doff++ = *soff&fg | ~*soff++&bg;
		*doff   = *soff&fg | ~*soff++&bg;
		doff   += bbuf->pitch/sizeof(DWORD)-1;
		soff   += Font2->pitch/sizeof(DWORD)-2;
	}
}


// ----------------------------------
//     [mk2] Mode 1,2 sub
// ----------------------------------
void DSP62::Mode2_1( void )
{
	PRINTD( GRP_LOG, "[GRP][62][Mode2_1]\n" );
	
	WORD AVOFF;
	int x,y;
	
	for( y=0,AVOFF=0; y<20; y++ ){
		for( x=0; x<40; x++,AVOFF++ ){
			Putc_M21( x, y, AVOFF );
		}
	}
}


// ----------------------------------
//     [mk2] Mode 3 sub
// ----------------------------------
void DSP62::Mode2_3( void )
{
	PRINTD( GRP_LOG, "[GRP][62][Mode2_3]\n" );
	
	int voff=0;
	BYTE data,attr;
	DWORD d;
	DWORD *doff;
	
	doff = (DWORD *)bbuf->pixels;
	do{
		data = GetAttr( voff );
		attr = GetVram( voff++ );
		d  = (DWORD)COL_MOD23[Css3][((attr>>4)&0x0c)|((data>>6)&3)];
		d |= (DWORD)COL_MOD23[Css3][((attr>>2)&0x0c)|((data>>4)&3)]<<16;
		d |= d<<8;
		*doff++ = d;
		d  = (DWORD)COL_MOD23[Css3][( attr    &0x0c)|((data>>2)&3)];
		d |= (DWORD)COL_MOD23[Css3][((attr<<2)&0x0c)|( data    &3)]<<16;
		d |= d<<8;
		*doff++ = d;
	}while( voff < 0x1f40 );
}

// ----------------------------------
//     [mk2] Mode 4 sub
// ----------------------------------
void DSP62::Mode2_4( void )
{
	PRINTD( GRP_LOG, "[GRP][62][Mode2_4]\n" );
	
	int voff=0;
	BYTE data,attr,c;
	DWORD d;
	DWORD *doff;
	
	doff = (DWORD *)bbuf->pixels;
	c = (Css2<<3)|(Css1<<2);
	do{
		data = GetVram( voff );
		attr = GetAttr( voff++ );
		d  = (DWORD)COL_MOD24[Css3][c|((data>>6)&2)|((attr>>7)&1)];
		d |= (DWORD)COL_MOD24[Css3][c|((data>>5)&2)|((attr>>6)&1)]<< 8;
		d |= (DWORD)COL_MOD24[Css3][c|((data>>4)&2)|((attr>>5)&1)]<<16;
		d |= (DWORD)COL_MOD24[Css3][c|((data>>3)&2)|((attr>>4)&1)]<<24;
		*doff++ = d;
		d  = (DWORD)COL_MOD24[Css3][c|((data>>2)&2)|((attr>>3)&1)];
		d |= (DWORD)COL_MOD24[Css3][c|((data>>1)&2)|((attr>>2)&1)]<< 8;
		d |= (DWORD)COL_MOD24[Css3][c|( data    &2)|((attr>>1)&1)]<<16;
		d |= (DWORD)COL_MOD24[Css3][c|((data<<1)&2)|( attr    &1)]<<24;
		*doff++ = d;
	}while( voff < 0x1f40 );
}


////////////////////////////////////////////////////////////////
// VRAM Ƥ ХåХåե
////////////////////////////////////////////////////////////////
void DSP60::Vram2Screen( void )
{
	PRINTD( GRP_LOG, "[GRP][60][Vram2Screen]s\n" );
	
	if( CrtDisp ){
		LockSurface();
		// ⡼Ƚ
		// ե˥塼åȥեåκߤϹθʤ(⤽Բǽ?)
		if( GetAttr(0)&0x80 ) Mode_34();	// եå
		else                  Mode_12();	// ե˥塼å
		UnlockSurface();
	}else{
		CrtKill();
	}
}

void DSP62::Vram2Screen( void )
{
	PRINTD( GRP_LOG, "[GRP][62][Vram2Screen]\n" );
	
	if( CrtDisp ){
		LockSurface();
		if( N60Win ){	// N60
			// ⡼Ƚ
			// ե˥塼åȥեåκߤϹθʤ(⤽Բǽ?)
			if( GetAttr(0)&0x80 ) Mode_34();	// եå
			else                  Mode_12();	// ե˥塼å
		}else{			// N60m
			if( Mk2CharMode )		// 饯⡼ɡ
				Mode2_1();			// ⡼1,2
			else{
				// եå
				if( Mk2GraphMode ) Mode2_3();	// ⡼3
				else               Mode2_4();	// ⡼4
			}
		}
		UnlockSurface();
	}else{
		CrtKill();
	}
}


////////////////////////////////////////////////////////////////
// ScanLine
////////////////////////////////////////////////////////////////
void DSP6::BlitScanLine( void )
{
	PRINTD( GRP_LOG, "[GRP][ScanLine]\n" );
	
	int x,y;
	Uint32 s,d;
	Uint32 *soff,*doff,*eoff;
	
	if( SDL_MUSTLOCK( bbuf ) ) SDL_LockSurface( bbuf );
	if( SDL_MUSTLOCK( sbuf ) ) SDL_LockSurface( sbuf );
	
	soff = (Uint32 *)bbuf->pixels;
	doff = (Uint32 *)sbuf->pixels;
	eoff = doff + sbuf->w/sizeof(Uint32);
	
	for( y=0; y<bbuf->h; y++ ){
		for( x=0; x<(int)(bbuf->w/sizeof(Uint32)); x++ ){
			s = *soff++;
			d  = (s&0x0000ff00)<<8;
			d |=  s&0x000000ff;
			d |=  d<<8;
			*doff++ = d;
			*eoff++ = d|0x80808080;
			d  =  s&0xff000000;
			d |= (s&0x00ff0000)>>8;
			d |=  d>>8;
			*doff++ = d;
			*eoff++ = d|0x80808080;
		}
		doff += sbuf->w/sizeof(Uint32);
		eoff += sbuf->w/sizeof(Uint32);
	}
	
	if( SDL_MUSTLOCK( bbuf ) ) SDL_UnlockSurface( bbuf );
	if( SDL_MUSTLOCK( sbuf ) ) SDL_UnlockSurface( sbuf );
}


////////////////////////////////////////////////////////////////
// ̹
////////////////////////////////////////////////////////////////
void DSP6::DrawScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][DrawScreen]\n" );
	
	int x,y;
	
	SDL_Surface *scr = SDL_GetVideoSurface();	// ꡼󥵡եؤΥݥ
	
	// ɥå
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// ˥⡼?
		x = P6DEBUGW;
		y = P6DEBUGH;
	}else
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{	x = P6WINW;
		y = P6WINH;
		
		// 饤󤢤?
		if( DISPSCAN ){ x *= 2; y *= 2; }
		
		// ե륹꡼Ǥʤ?
		if( !DISPFULL ){
			x += FRAMEW; y += FRAMEH;
			// ơСɽ?
			if( DISPSTAT ) y += vm->staw->Height();
		}
	}
	
	// ɥŬڤʤľ
	if( !scr || (x != scr->w) || (y != scr->h) ){
		SetScreenSurface();
		SetStatusBar();	// ơС
		scr = SDL_GetVideoSurface();	// ꡼󥵡եؤΥݥ󥿤Ƽ
	}
	
	// ХåХåեå
	// ɥ N60? N60m?
	if( N60Win ){ x = P6WIDTH; y = P6HEIGHT; }	// N60
	else        { x = P2WIDTH; y = P2HEIGHT; }	// N60m
	// 饤󤢤?
	if( DISPSCAN ){ x *= 2; y *= 2; }
	// ХåХåեŬڤʤľ
	if( !bbuf || (x != bbuf->w) || (y != bbuf->h) )
		SetBackBuffer();
	
	// ХåХåե
	Vram2Screen();
	
	// ꡼󥵡եblit
	PRINTD( GRP_LOG, " -> Blit" );
	
	SDL_Rect ScrPos;
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// ˥⡼?
		PRINTD( GRP_LOG, " -> Monitor" );
		
		// ХåХåե
		ScrPos.x = ( P6WINW + FRAMEW - bbuf->w )/2;
		ScrPos.y = ( P6WINH + FRAMEH - bbuf->h )/2;
		SDL_BlitSurface( bbuf, NULL, scr, &ScrPos );
		
		// ˥ɥ
		ScrPos.x = 0;
		ScrPos.y = max( P6WINH + FRAMEH, vm->regw->Height() + vm->memw->Height() );
		vm->monw->Show( &ScrPos );
		
		// 쥸ɥ
		ScrPos.x = P6WINW + FRAMEW;
		ScrPos.y = 0;
		vm->regw->Show( &ScrPos );
		
		// ꥦɥ
		ScrPos.x = P6WINW + FRAMEW;
		ScrPos.y = vm->regw->Height();
		vm->memw->Show( &ScrPos );
	}else
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{	if( DISPSCAN ){	// 饤󤢤?
			BlitScanLine();
			ScrPos.x = ( scr->w - sbuf->w )/2;
			ScrPos.y = ( scr->h - sbuf->h - (DISPSTAT ? vm->staw->Height() : 0) )/2;
			
			PRINTD4( GRP_LOG, " -> ScanLine( %d,%d )-( %d.%d )", ScrPos.x, ScrPos.y, ScrPos.x+sbuf->w, ScrPos.y+sbuf->h );
			
			SDL_BlitSurface( sbuf, NULL, scr, &ScrPos );
		}else{
			ScrPos.x = ( scr->w - bbuf->w )/2;
			ScrPos.y = ( scr->h - bbuf->h - (DISPSTAT ? vm->staw->Height() : 0) )/2;
			
			PRINTD4( GRP_LOG, " -> scr( %dx%d ) bbuf( %dx%d )", scr->w, scr->h, bbuf->w, bbuf->h );
			PRINTD4( GRP_LOG, " -> NoScanLine( %d,%d )-( %d,%d )", ScrPos.x, ScrPos.y, ScrPos.x+bbuf->w, ScrPos.y+bbuf->h );
			
			SDL_BlitSurface( bbuf, NULL, scr, &ScrPos );
		}
		
		// ơС
		if( DISPSTAT ){
			PRINTD( GRP_LOG, " -> Statusbar" );
			
			// ơС򹹿blit
			vm->staw->Update();
		}
	}
	
	PRINTD( GRP_LOG, " -> OK\n" );
	
	// եå
	SDL_Flip( scr );
}


////////////////////////////////////////////////////////////////
// եå
////////////////////////////////////////////////////////////////
void DSP6::LockSurface( void )
{
	PRINTD( GRP_LOG, "[GRP][LockSurface]\n" );
	
	// ХåХåե
	if( SDL_MUSTLOCK( bbuf ) )           SDL_LockSurface( bbuf );
	// ⡼1ѥʥեȡ
	if( SDL_MUSTLOCK( Font1 ) )          SDL_LockSurface( Font1 );
	// ⡼1ѥmk2եȡ
	if( Font2 && SDL_MUSTLOCK( Font2 ) ) SDL_LockSurface( Font2 );
}


////////////////////////////////////////////////////////////////
// եΥå
////////////////////////////////////////////////////////////////
void DSP6::UnlockSurface( void )
{
	PRINTD( GRP_LOG, "[GRP][UnlockSurface]\n" );
	
	// ХåХåե
	if( SDL_MUSTLOCK( bbuf ) )           SDL_UnlockSurface( bbuf );
	// ⡼1ѥʥեȡ
	if( SDL_MUSTLOCK( Font1 ) )          SDL_UnlockSurface( Font1 );
	// ⡼1ѥmk2եȡ
	if( Font2 && SDL_MUSTLOCK( Font2 ) ) SDL_UnlockSurface( Font2 );
}


////////////////////////////////////////////////////////////////
// VRAM ɥ쥹ڤؤ
// ( bit 1,2 ͭ)
//   ! ɥ쥹MainRam֥åƬΥեåȤȤ
////////////////////////////////////////////////////////////////
void DSP6::SetVramAddr( BYTE data )
{
	PRINTD1( GRP_LOG, "[GRP][SetVramAddr] -> %d : ", data );
	
	//	[00] A:C000H V:C200H
	//	[01] A:E000H V:E200H
	//	[10] A:8000H V:8200H
	//	[11] A:A000H V:A200H
	// ¥ɥ쥹 +0x8000
	AttrAddr = (((data+4)&6)<<12);
	VramAddr = AttrAddr + 0x0200;
	
	PRINTD2( GRP_LOG, "V:%04X A:%04X\n", VramAddr, AttrAddr );
}

void DSP62::SetVramAddr( BYTE data )
{
	PRINTD1( GRP_LOG, "[GRP][62][SetVramAddr] -> %d : ", data );
	
	if( !N60Win ){			// mk2 or 66
		//	[00] A:8000H V:8400H or A000H
		//	[01] A:C000H V:C400H or E000H
		//	[10] A:0000H V:0400H or 2000H
		//	[11] A:4000H V:4400H or 6000H
		AttrAddr = ((data+4)&6)<<13;
		if( Mk2CharMode )	// 饯⡼
			VramAddr = AttrAddr + 0x0400;
		else				// եå⡼
			VramAddr = AttrAddr + 0x2000;
	}else{					// 60
		//	[00] A:C000H V:C200H
		//	[01] A:E000H V:E200H
		//	[10] A:8000H V:8200H
		//	[11] A:A000H V:A200H
		// mk2ʹߤξϼ¥ɥ쥹˰
		AttrAddr = 0x8000 | (((data+4)&6)<<12);
		VramAddr = AttrAddr + 0x0200;
	}
	
	PRINTD2( GRP_LOG, "V:%04X A:%04X\n", VramAddr, AttrAddr );
}


////////////////////////////////////////////////////////////////
// ȹ礻
////////////////////////////////////////////////////////////////
void DSP62::SetCss( BYTE data )
{
	PRINTD1( GRP_LOG, "[GRP][62][SetCss] -> %02X : ", data );
	
	Css1 =  data    &1;
	Css2 = (data>>1)&1;
	Css3 = (data>>2)&1;
	
	PRINTD3( GRP_LOG, "1:%d 2:%d 3:%d\n", Css1, Css2, Css3 );
}


////////////////////////////////////////////////////////////////
// CRTȥ⡼
////////////////////////////////////////////////////////////////
void DSP62::SetCrtControler( BYTE data )
{
	PRINTD1( GRP_LOG, "[GRP][62][SetCrtControler] -> %02X\n", data );
	
	CrtCtrlPara = data;
	
	// VRAM ɥ쥹ѥ᡼ջ
	BYTE vrampara = N60Win ? ((AttrAddr&0x7fff)>>12)-4 : (AttrAddr>>13)-4;
	
	N60Win       = data&2 ? TRUE : FALSE;	// ɥ       TRUE:N60        FALSE:N60m
	Mk2CharMode  = data&4 ? TRUE : FALSE;	// mk2 ɽ⡼         TRUE:饯 FALSE:եå
	Mk2GraphMode = data&8 ? TRUE : FALSE;	// mk2 եå TRUE:160*200    FALSE:320*200
	
	PRINTD1( GRP_LOG, " DATA        :%02X\n", data );
	PRINTD1( GRP_LOG, " N60Win      :%s\n", N60Win       ? "N60"  : "N60m" );
	PRINTD1( GRP_LOG, " Mk2CharMode :%s\n", Mk2CharMode  ? "Char" : "Graph" );
	PRINTD1( GRP_LOG, " Mk2GraphMode:%d\n", Mk2GraphMode ? 160    : 320 );
	
	// VRAM ɥ쥹
	SetVramAddr( vrampara );
	
	// BUSREQѲ
	DSP6::ChangeBUSREQ();
}


////////////////////////////////////////////////////////////////
// ʥåץå
////////////////////////////////////////////////////////////////
void DSP6::SnapShot( char *path )
{
	PRINTD( GRP_LOG, "[GRP][SnapShot]\n" );
	
	char img_file[PATH_MAX];
	char img_name[PATH_MAX] = "P6V";
	char img_ext[]          = ".png";
	int Index = 0;
	
	// ꡼󥷥åȳǼեʤХ顼
	if( !OSD_FileExist( path ) ) return;
	
	// ꡼󥷥åȥե̾
	do{
		sprintf( img_file, "%s%s%03d%s", path, img_name, ++Index, img_ext );
	}while( OSD_FileExist( img_file ) || (Index > 999) );
	
	if( !(Index > 999) ) SavePNG( img_file, bbuf );	// Ϣ֤ͭʤPNG¸
}


////////////////////////////////////////////////////////////////
// ꡼󥵡ե򥯥ꥢ
////////////////////////////////////////////////////////////////
void DSP6::ClearScreen( void )
{
	// 0ȷǤ
	SDL_FillRect( SDL_GetVideoSurface(), NULL, 0 );
}


////////////////////////////////////////////////////////////////
// CRTɽ
////////////////////////////////////////////////////////////////
void DSP6::SetCrtDisp( BOOL st )
{
	CrtDisp = st;
	
	// BUSREQѲ
	ChangeBUSREQ();
}


////////////////////////////////////////////////////////////////
// BUSREQѲ
////////////////////////////////////////////////////////////////
void DSP6::ChangeBUSREQ( void )
{
	vm->sche->CalcCpuState();
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL DSP6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	for( int i=0; i<256; i++ ){
		char stren[16];
		sprintf( stren, "GPal_%d", i );
		Ini->PutEntry( "GRAPH", NULL, stren, "0x%02X%02X%02X",	GPal[i].r,	GPal[i].g,	GPal[i].b );
	}
	Ini->PutEntry( "GRAPH", NULL, "Mode4Col",	"%d",		Mode4Col );
	Ini->PutEntry( "GRAPH", NULL, "VramAddr",	"0x%04X",	VramAddr );
	Ini->PutEntry( "GRAPH", NULL, "AttrAddr",	"0x%04X",	AttrAddr );
	
//	Ini->PutEntry( "GRAPH", NULL, "CRLines",	"%d",		CRLines );
//	Ini->PutEntry( "GRAPH", NULL, "DWidth",		"%d",		DWidth );
//	Ini->PutEntry( "GRAPH", NULL, "DLines",		"%d",		DLines );
	
	Ini->PutEntry( "GRAPH", NULL, "CrtDisp",	"%s",		CrtDisp ? "Yes" : "No" );
	Ini->PutEntry( "GRAPH", NULL, "N60Win",		"%s",		N60Win ? "Yes" : "No" );
	
	return TRUE;
}

BOOL DSP62::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "GRAPH", NULL, "Mk2CharMode",	"%s",		Mk2CharMode ? "Yes" : "No" );
	Ini->PutEntry( "GRAPH", NULL, "Mk2GraphMode",	"%s",		Mk2GraphMode ? "Yes" : "No" );
	Ini->PutEntry( "GRAPH", NULL, "Css1",			"%d",		Css1 );
	Ini->PutEntry( "GRAPH", NULL, "Css2",			"%d",		Css2 );
	Ini->PutEntry( "GRAPH", NULL, "Css3",			"%d",		Css3 );
	Ini->PutEntry( "GRAPH", NULL, "CrtCtrlPara",	"0x%02X",	CrtCtrlPara );
	
	return DSP6::DokoSave( Ini );
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL DSP6::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	// ط
	for( int i=0; i<256; i++ ){
		char stren[16], str[16];
		sprintf( stren, "GPal_%d", i );
		sprintf( str,   "0x%02X%02X%02X", GPal[i].r, GPal[i].g, GPal[i].b );
		if( Ini->GetString( "GRAPH", stren, str, str ) ){
			int st = strtol( str, NULL, 16 );
			GPal[i].r = (st>>16)&0xff;
			GPal[i].g = (st>> 8)&0xff;
			GPal[i].b = (st    )&0xff;
		}
	}
	
	Ini->GetInt(   "GRAPH", "Mode4Col",	&Mode4Col,	Mode4Col );
	Ini->GetInt(   "GRAPH", "VramAddr",	&st,		VramAddr );	VramAddr = st;
	Ini->GetInt(   "GRAPH", "AttrAddr",	&st,		AttrAddr );	AttrAddr = st;
	
//	Ini->GetInt(   "GRAPH", "CRLines",	&CRLines,	CRLines );
//	Ini->GetInt(   "GRAPH", "DWidth",	&DWidth,	DWidth );
//	Ini->GetInt(   "GRAPH", "DLines",	&DLines,	DLines );
	
	Ini->GetTruth( "GRAPH", "CrtDisp",	&CrtDisp,	CrtDisp );
	Ini->GetTruth( "GRAPH", "N60Win",	&N60Win,	N60Win );
	
	return TRUE;
}

BOOL DSP62::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetTruth( "GRAPH", "Mk2CharMode",	&Mk2CharMode,	Mk2CharMode );
	Ini->GetTruth( "GRAPH", "Mk2GraphMode",	&Mk2GraphMode,	Mk2GraphMode );
	Ini->GetInt(   "GRAPH", "Css1",			&Css1,			Css1 );
	Ini->GetInt(   "GRAPH", "Css2",			&Css2,			Css2 );
	Ini->GetInt(   "GRAPH", "Css3",			&Css3,			Css3 );
	Ini->GetInt(   "GRAPH", "CrtCtrlPara",	&st,			CrtCtrlPara );	CrtCtrlPara = st;
	
	return DSP6::DokoLoad( Ini );
}



////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor DSP60::descriptor = {
	DSP60::indef, DSP60::outdef
};

const Device::OutFuncPtr DSP60::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &DSP60::OutB0H )
};

const Device::InFuncPtr DSP60::indef[] = {
};


const Device::Descriptor DSP62::descriptor = {
	DSP62::indef, DSP62::outdef
};

const Device::OutFuncPtr DSP62::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &DSP62::OutB0H ),
	STATIC_CAST( Device::OutFuncPtr, &DSP62::OutC0H ),
	STATIC_CAST( Device::OutFuncPtr, &DSP62::OutC1H )
};

const Device::InFuncPtr DSP62::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &DSP62::InC1H )
};
