#ifndef GRAPH_H_INCLUDED
#define GRAPH_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"

#include "p6device.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
//  ---------------------------------
class DSP6 : public P6DEVICE, public IDoko {
protected:
	SDL_Surface *bbuf;		// ХåХåե
	SDL_Surface *sbuf;		// ХåХåե(饤)
	SDL_Surface *Font1;		// ⡼1ѥʥեȡ
	SDL_Surface *Font2;		// ⡼1ѥmk2եȡ
	
	SDL_Color GPal[256];	// ѥå
	
	int Mode4Col;			// ⡼4顼⡼ 0: 1:/ 2:/ 3:ԥ/ 4:/ԥ
	
	BOOL CrtDisp;			// CRTɽ TRUE:ɽ FALSE:ɽ
	BOOL N60Win;			// ɥ TRUE:N60 FALSE:N60m
	
	WORD VramAddr;			// VRAM ɥ쥹 0:0xc200 1:0xe200 2:0x8200 3:0xa200
	WORD AttrAddr;			// ATTR ɥ쥹 0:0xc000 1:0xe000 2:0x8000 3:0xa000
	
	BYTE GetAttr( WORD );					// ȥӥ塼ȥǡ
	BYTE GetVram( WORD );					// VRAMǡ
	
	BOOL InitPalette( SDL_Surface * );		// ե˥ѥå
	
	BOOL SetScreenSurface();				// ꡼󥵡ե
	BOOL SetBackBuffer();					// ХåХåե
	BOOL SetStatusBar();					// ơС
	
	void BlitScanLine();					// ScanLine
	
	virtual void LockSurface();				// եå
	virtual void UnlockSurface();			// եΥå
	
	virtual void SetVramAddr( BYTE );		// VRAM ɥ쥹ڤؤ
	virtual void Vram2Screen() = 0;			// VRAM Ƥ ХåХåե
	virtual void CrtKill();					// CRT KILL
	
	inline void Putc_M1( int, int, WORD );	// ⡼1   1ʸPUT
	inline void Putc_M2( int, int, WORD );	// ⡼2-1 1ʸPUT
	inline void Putc_M22( int, int, WORD );	// ⡼2-2 1ʸPUT
	
	inline void ChangeBUSREQ();				// BUSREQѲ
	
	// ѥ
	DWORD *DOff;							// ХåХåեؤΥݥ
	int CRLines;							// 
	int DWidth;								// 1line DWORD
	int DLines;								// line
	
	inline void Putc_M3( BYTE, int );		// ⡼3
	inline void Putc_M4( BYTE, int );		// ⡼4
	inline void Putc_M32( BYTE, int );		// 128 96 顼
	inline void Putc_M33( BYTE, int );		// 128 64 顼
	inline void Putc_M34( BYTE, int );		//  64 64 顼
	inline void Putc_M41( BYTE, int );		// 128 96 Υ
	inline void Putc_M42( BYTE, int );		// 128192 Υ
	inline void Putc_M43( BYTE, int );		// 128 64 Υ
	
	inline void Mode_12();					// Mode 1,2 sub
	inline void Mode_34();					// Mode 3,4 sub
	
public:
	DSP6( VM6 * );							// 󥹥ȥ饯
	virtual  ~DSP6();						// ǥȥ饯
	
	virtual BOOL Init( void ) = 0;			// 
	BOOL InitCommon();						// ʬ
	
	int GetMode4Color(){ return Mode4Col; }	// ⡼4顼⡼ɼ
	void SetMode4Color( int col ){ Mode4Col = col; }	//        
	
	void DrawScreen();						// ̹
	void SnapShot( char * );				// ʥåץå
	void ClearScreen();						// ꡼󥵡ե򥯥ꥢ
	
	BOOL GetWinSize(){ return N60Win; }		// ɥ
	BOOL GetCrtDisp(){ return CrtDisp; }	// CRTɽּ
	void SetCrtDisp( BOOL );				// CRTɽ
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


// 60 ---------------------------------
class DSP60 : public DSP6, public Device {
private:
	void Vram2Screen();						// VRAM Ƥ ХåХåե
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int, BYTE data ){ SetVramAddr( data ); }
	
public:
	DSP60( VM6 *, const ID& );				// 󥹥ȥ饯
	~DSP60();								// ǥȥ饯
	
	BOOL Init( void );						// 
	
	// ǥХID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
};


// mk2 ---------------------------------
class DSP62 : public DSP6, public Device {
private:
	BOOL Mk2CharMode;						// mk2 ɽ⡼ TRUE:饯 FALSE:եå
	BOOL Mk2GraphMode;						// mk2 եå TRUE:160*200 FALSE:320*200
	
	int Css1;								// Ȥ߹碌
	int Css2;
	int Css3;
	
	BYTE CrtCtrlPara;						// CRTȥͿѥ᡼¸
	
	void SetVramAddr( BYTE );				// VRAM ɥ쥹ڤؤ
	void Vram2Screen();						// VRAM Ƥ ХåХåե
	void CrtKill();							// CRT KILL
	
	inline void Putc_M21( int, int, WORD );	// [mk2] ⡼1 1ʸPUT
	inline void Mode2_1();					// [mk2] Mode 1,2 sub
	inline void Mode2_3();					// [mk2] Mode 3 sub
	inline void Mode2_4();					// [mk2] Mode 4 sub
	
	void SetCss( BYTE );					// ȹ礻
	void SetCrtControler( BYTE );			// CRTȥ⡼
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int, BYTE data ){ SetVramAddr( data ); }
	inline void OutC0H( int, BYTE data ){ SetCss( data ); }
	inline void OutC1H( int, BYTE data ){ SetCrtControler( data ); }
	inline BYTE InC1H( int ){ return CrtCtrlPara; }
	
public:
	DSP62( VM6 *, const ID& );				// 󥹥ȥ饯
	~DSP62();								// ǥȥ饯
	
	BOOL Init( void );						// 
	
	// ǥХID
	enum IDOut{ outB0H=0, outC0H, outC1H };
	enum IDIn {  inC1H=0 };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// GRAPH_H_INCLUDED
