// OSˑ̔ėp[`(UIp)
// ɍ킹ĕR[hύX邱
//  Windows : ShiftJIS
//  Unix    : EUC

#include <windows.h>
#include <shlobj.h>
#include <new>

#include "SDL/SDL_syswm.h"

#include "disk.h"
#include "error.h"
#include "global.h"
#include "graph.h"
#include "ini.h"
#include "osd.h"
#include "p6v.h"
#include "pc60.h"
#include "schedule.h"
#include "tape.h"


///////////////////////////////////////////////////////////
// [J֐`
///////////////////////////////////////////////////////////
static HWND OsdGetWindowHandle();		// EBhEnh擾
static int ShowConfig( HWND, char * );	// ݒvpeBV[g\

static BOOL OsdReadINI(  HWND, int );	// ݒǍ
static BOOL OsdWriteINI( HWND, int );	// ݒۑ

static BOOL CALLBACK OsdCnfgProc1(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProc2(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProc3(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProc4(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProc5(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProcCol( HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProcEtc( HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK VerInfoProc(    HWND, UINT, WPARAM, LPARAM );

static void OsdOwnerDrawBtn( HDC, RECT, COLORREF );	// I[i[h[{^ `

///////////////////////////////////////////////////////////
// dȂɃO[oϐ
///////////////////////////////////////////////////////////
static cIni *Ini = NULL;		// INIIuWFNg|C^



///////////////////////////////////////////////////////////
// |bvAbvj[\
///////////////////////////////////////////////////////////
void VM6::ShowPopupMenu( int x, int y )
{
	// MF_BYPOSITIONp
	enum {	MSYSTEM = 1,
			MTAPE   = 2,
			MDISK   = 3,
			MCONFIG = 4,
			MDEBUG  = 5,
			MHELP   = 6
		};
	
	POINT pt;
	HWND hwnd;
	HMENU hm,hsm;
	int id;
	
	pt.x = x;
	pt.y = y;
	hwnd = OsdGetWindowHandle();
	
	if( GetMenu( hwnd ) ) return;
	
	hm  = LoadMenu( (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE), MAKEINTRESOURCE( ID_MENU ) );
	hsm = GetSubMenu( hm, 0 );
	
	// j[̑O
	// TAPE
	EnableMenuItem( hsm, ID_TAPEEJECT, MF_BYCOMMAND | *cmt->GetFile() ? MF_ENABLED : MF_GRAYED );
	// DISK
	switch( disk->GetDrives() ){
	case 0:
		DeleteMenu( hsm, MDISK, MF_BYPOSITION );
		break;
	case 1:
		DeleteMenu( GetSubMenu( hsm, MDISK ), 1, MF_BYPOSITION );
		EnableMenuItem( hsm, ID_DISKEJECT1, MF_BYCOMMAND | *disk->GetFile(0) ? MF_ENABLED : MF_GRAYED );
		break;
	default:
		EnableMenuItem( hsm, ID_DISKEJECT1, MF_BYCOMMAND | *disk->GetFile(0) ? MF_ENABLED : MF_GRAYED );
		EnableMenuItem( hsm, ID_DISKEJECT2, MF_BYCOMMAND | *disk->GetFile(1) ? MF_ENABLED : MF_GRAYED );
	}
	
	// gROM
	EnableMenuItem( hsm, ID_ROMEJECT, MF_BYCOMMAND | (*cGlobal::ExtRomFile  ? MF_ENABLED : MF_GRAYED) );
	
	CheckMenuRadioItem( hsm, ID_M4MONO, ID_M4GRPK, ID_M4MONO + graph->GetMode4Color(), MF_BYCOMMAND );
	CheckMenuItem( hsm, ID_NOWAIT,   sche->GetWaitEnable()  ? MF_UNCHECKED : MF_CHECKED );
	CheckMenuItem( hsm, ID_TURBO,    cGlobal::TurboTAPE     ? MF_CHECKED   : MF_UNCHECKED );
	CheckMenuItem( hsm, ID_SCANLINE, cGlobal::ScanLine      ? MF_CHECKED   : MF_UNCHECKED );
	CheckMenuItem( hsm, ID_STATUS,   cGlobal::StatDisp      ? MF_CHECKED   : MF_UNCHECKED );
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	CheckMenuItem( hsm, ID_MONITOR,  cGlobal::MonDisp     ? MF_CHECKED   : MF_UNCHECKED );
	CheckMenuItem( hsm, ID_TIMERINT, cGlobal::TimerIntr   ? MF_UNCHECKED : MF_CHECKED );
	#else
	DeleteMenu( hsm, MDEBUG, MF_BYPOSITION );
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	ClientToScreen( hwnd, &pt );
	id = TrackPopupMenu( hsm, TPM_RETURNCMD | TPM_LEFTALIGN, pt.x, pt.y, 0, hwnd, NULL );
	DestroyMenu( hm );
	
	// ڂƂ̏
	char str[PATH_MAX];
	switch( id ){
	case ID_TAPEINSERT:		// TAPE }
		if( OSD_FileSelect( hwnd, FD_TapeLoad, str, cGlobal::TapePath ) )
		if( !TapeInsert( str ) ) Error::SetError( Error::TapeMountFailed );
		break;
		
	case ID_TAPEEJECT:		// TAPE ro
		TapeEject();
		break;
		
	case ID_DISKINSERT1:	// DISK1 }
		if( OSD_FileSelect( hwnd, FD_Disk, str, cGlobal::DiskPath ) )
		if( !DiskInsert( 0, str ) ) Error::SetError( Error::DiskMountFailed );
		break;
		
	case ID_DISKEJECT1:		// DISK1 ro
		DiskEject( 0 );
		break;
		
	case ID_DISKINSERT2:	// DISK2 }
		if( OSD_FileSelect( hwnd, FD_Disk, str, cGlobal::DiskPath ) )
		if( !DiskInsert( 1, str ) ) Error::SetError( Error::DiskMountFailed );
		break;
		
	case ID_DISKEJECT2:		// DISK2 ro
		DiskEject( 1 );
		break;
		
	case ID_ROMINSERT:		// gROM }
		if( OSD_FileSelect( hwnd, FD_ExtRom, str, cGlobal::ExtRomPath ) ){
			// Zbg𔺂̂ŃbZ[W\
			OSD_Message( MSG_RESETI, MSG_RESETC, OSDM_OK | OSDM_ICONINFO );
			if( !ExtRomInsert( str ) ) Error::SetError( Error::ExtRomMountFailed );
			else                       Reset();
		}
		break;
		
	case ID_ROMEJECT:		// gROM ro
		// Zbg𔺂̂ŃbZ[W\
		OSD_Message( MSG_RESETE, MSG_RESETC, OSDM_OK | OSDM_ICONINFO );
		ExtRomEject();
		Reset();
		break;
		
	case ID_CONFIG:			// ݒ
		if( ShowConfig( hwnd, cGlobal::IniPath ) > 0 )
			// ċN?
			if( OSD_Message( MSG_RESTART, MSG_RESTARTC, OSDM_YESNO | OSDM_ICONQUESTION ) == OSDR_YES )
				SENDEVENT( SDL_RESTART )
		break;
		
	case ID_RESET:			// Zbg
		Reset();
		break;
		
	case ID_RESTART:		// ċN
		SENDEVENT( SDL_RESTART )
		break;
		
	case ID_DOKOSAVE:		// ǂłSAVE
		if( OSD_FileSelect( hwnd, FD_DokoSave, str, (char *)OSD_GetModulePath() ) )
		if( !DokoDemoSave( str ) ) Error::SetError( Error::DokoWriteFailed );
		break;
		
	case ID_DOKOLOAD:		// ǂłLOAD
		if( OSD_FileSelect( hwnd, FD_DokoLoad, str, (char *)OSD_GetModulePath() ) )
		if( !DokoDemoLoad( str ) ) Error::SetError( Error::DokoReadFailed );
		break;
		
	case ID_QUIT:			// I
		SENDEVENT( SDL_QUIT )
		break;
		
	case ID_NOWAIT:			// WaitLύX
		sche->SetWaitEnable( sche->GetWaitEnable() ? FALSE : TRUE );
		break;
		
	case ID_TURBO:			// Turbo TAPE
		cGlobal::TurboTAPE = cGlobal::TurboTAPE ? FALSE : TRUE;
		break;
		
	case ID_SCANLINE:		// XLC[hύX
		cGlobal::ScanLine = cGlobal::ScanLine ? FALSE : TRUE;
		break;
		
	case ID_STATUS:			// Xe[^Xo[\ԕύX
		cGlobal::StatDisp = cGlobal::StatDisp ? FALSE : TRUE;
		break;
		
							// MODE4J[
	case ID_M4MONO:		// mN
		graph->SetMode4Color( 0 );
		break;
	case ID_M4RDBL:		// /
		graph->SetMode4Color( 1 );
		break;
	case ID_M4BLRD:		// /
		graph->SetMode4Color( 2 );
		break;
	case ID_M4PKGR:		// sN/
		graph->SetMode4Color( 3 );
		break;
	case ID_M4GRPK:		// /sN
		graph->SetMode4Color( 4 );
		break;
		
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	case ID_MONITOR:		// j^[[h
		ToggleMonitor();
		break;
		
	case ID_TIMERINT:		// ^C}݋
		cGlobal::TimerIntr = cGlobal::TimerIntr ? FALSE : TRUE;
		break;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	case ID_VERSION:		// o[W
		DialogBox( (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE), MAKEINTRESOURCE(ID_VER), hwnd, (DLGPROC)VerInfoProc );
		break;
	}
}


///////////////////////////////////////////////////////////
// EBhEnh擾
///////////////////////////////////////////////////////////
static HWND OsdGetWindowHandle( void )
{
	SDL_SysWMinfo WinInfo;
	
	SDL_VERSION( &WinInfo.version );
  	if( SDL_GetWMInfo( &WinInfo ) ) return WinInfo.window;
	else                            return NULL;
}


///////////////////////////////////////////////////////////
// ݒvpeBV[g\
///////////////////////////////////////////////////////////
static int ShowConfig( HWND hwnd, char *inifile )
{
	Ini = NULL;
	
	// INIt@CJ
	try{
		Ini = new cIni();
		if( !Ini->Init( inifile ) ) throw Error::IniReadFailed;
		cGlobal::InitIni( Ini, FALSE );
	}
	// new Ɏsꍇ
	catch( std::bad_alloc ){
		return -1;
	}
	// O
	catch( Error::Errno i ){
		delete Ini;
		return -1;
	}
	
	
	// y[W̐ݒsȂ
	PROPSHEETPAGE psp[8];
	PROPSHEETHEADER psh;
	
	// {
	psp[0].dwSize      = sizeof(PROPSHEETPAGE);
	psp[0].dwFlags     = PSP_DEFAULT;
	psp[0].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[0].pszTemplate = MAKEINTRESOURCE(ID_CNFG1);
	psp[0].pszIcon     = NULL;
	psp[0].pfnDlgProc  = (DLGPROC)OsdCnfgProc1;
	psp[0].pszTitle    = NULL;
	psp[0].lParam      = 0;
	
	// 
	psp[1].dwSize      = sizeof(PROPSHEETPAGE);
	psp[1].dwFlags     = PSP_DEFAULT;
	psp[1].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[1].pszTemplate = MAKEINTRESOURCE(ID_CNFG2);
	psp[1].pszIcon     = NULL;
	psp[1].pfnDlgProc  = (DLGPROC)OsdCnfgProc2;
	psp[1].pszTitle    = NULL;
	psp[1].lParam      = 0;
	
	// TEh
	psp[2].dwSize      = sizeof(PROPSHEETPAGE);
	psp[2].dwFlags     = PSP_DEFAULT;
	psp[2].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[2].pszTemplate = MAKEINTRESOURCE(ID_CNFG3);
	psp[2].pszIcon     = NULL;
	psp[2].pfnDlgProc  = (DLGPROC)OsdCnfgProc3;
	psp[2].pszTitle    = NULL;
	psp[2].lParam      = 0;
	
	// t@C
	psp[3].dwSize      = sizeof(PROPSHEETPAGE);
	psp[3].dwFlags     = PSP_DEFAULT;
	psp[3].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[3].pszTemplate = MAKEINTRESOURCE(ID_CNFG4);
	psp[3].pszIcon     = NULL;
	psp[3].pfnDlgProc  = (DLGPROC)OsdCnfgProc4;
	psp[3].pszTitle    = NULL;
	psp[3].lParam      = 0;
	
	// tH_
	psp[4].dwSize      = sizeof(PROPSHEETPAGE);
	psp[4].dwFlags     = PSP_DEFAULT;
	psp[4].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[4].pszTemplate = MAKEINTRESOURCE(ID_CNFG5);
	psp[4].pszIcon     = NULL;
	psp[4].pfnDlgProc  = (DLGPROC)OsdCnfgProc5;
	psp[4].pszTitle    = NULL;
	psp[4].lParam      = 0;
	
	// F1
	psp[5].dwSize      = sizeof(PROPSHEETPAGE);
	psp[5].dwFlags     = PSP_DEFAULT;
	psp[5].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[5].pszTemplate = MAKEINTRESOURCE(ID_CNFGCL1);
	psp[5].pszIcon     = NULL;
	psp[5].pfnDlgProc  = (DLGPROC)OsdCnfgProcCol;
	psp[5].pszTitle    = NULL;
	psp[5].lParam      = 0;
	
	// F2
	psp[6].dwSize      = sizeof(PROPSHEETPAGE);
	psp[6].dwFlags     = PSP_DEFAULT;
	psp[6].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[6].pszTemplate = MAKEINTRESOURCE(ID_CNFGCL2);
	psp[6].pszIcon     = NULL;
	psp[6].pfnDlgProc  = (DLGPROC)OsdCnfgProcCol;
	psp[6].pszTitle    = NULL;
	psp[6].lParam      = 0;
	
	// ̑
	psp[7].dwSize      = sizeof(PROPSHEETPAGE);
	psp[7].dwFlags     = PSP_DEFAULT;
	psp[7].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[7].pszTemplate = MAKEINTRESOURCE(ID_CNFGETC);
	psp[7].pszIcon     = NULL;
	psp[7].pfnDlgProc  = (DLGPROC)OsdCnfgProcEtc;
	psp[7].pszTitle    = NULL;
	psp[7].lParam      = 0;
	
	
	psh.dwSize     = sizeof(PROPSHEETHEADER);
	psh.dwFlags    = PSH_PROPSHEETPAGE | PSH_NOAPPLYNOW;
	psh.hwndParent = hwnd;
	psh.hInstance  = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psh.pszIcon    = NULL;
	psh.pszCaption = (LPSTR) "ݒ";
	psh.nPages     = sizeof(psp) / sizeof(PROPSHEETPAGE);
	psh.ppsp       = (LPCPROPSHEETPAGE) &psp;
	
	// vpeBV[g\
	int ret = PropertySheet( &psh );
	
	delete Ini;
	
	return ret;
}


enum { PP_BASE, PP_DISP, PP_SOUND, PP_FILE, PP_FOLDER, PP_COL, PP_ETC };

///////////////////////////////////////////////////////////
// ݒǍ
///////////////////////////////////////////////////////////
static BOOL OsdReadINI( HWND hwnd, int page )
{
	int st;					// Ԏ擾p
	char str[PATH_MAX];		// 擾p
	char str2[PATH_MAX];	// 擾p\
	
	if( !Ini ) return FALSE;
	
	switch( page ){
	case PP_BASE:	// {
		// @
		Ini->GetInt( "CONFIG", "Model", &st, DEFAULT_MODEL );
		SendMessage( GetDlgItem( hwnd, ID_RB01 ), BM_SETCHECK, (st==60)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB02 ), BM_SETCHECK, (st==62)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB03 ), BM_SETCHECK, (st==66)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB04 ), BM_SETCHECK, (st==64)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB05 ), BM_SETCHECK, (st==68)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// FDD
		Ini->GetInt( "CONFIG", "FDD", &st, DEFAULT_FDD );
		SendMessage( GetDlgItem( hwnd, ID_RB31 ), BM_SETCHECK, (st==0)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB32 ), BM_SETCHECK, (st==1)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB33 ), BM_SETCHECK, (st==2)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// gRAMgp
		Ini->GetTruth( "CONFIG", "ExtRam", &st, DEFAULT_EXTRAM );
		SendMessage( GetDlgItem( hwnd, ID_CB1 ), BM_SETCHECK, st, 0 );
		
		// Turbo TAPE
		Ini->GetTruth( "CONFIG", "TurboTAPE", &st, DEFAULT_TURBO );
		SendMessage( GetDlgItem( hwnd, ID_CB3 ), BM_SETCHECK, st, 0 );
		
		// L[s[gԊu
		Ini->GetInt( "CONFIG", "KeyRepeat", &st, DEFAULT_REPEAT );
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_KEYREP, str );
		
		break;
		
	case PP_DISP:	// 
		// MODE4J[
		Ini->GetInt( "CONFIG", "Mode4Color", &st, DEFAULT_MODE4_COLOR );
		SendMessage( GetDlgItem( hwnd, ID_RB11 ), BM_SETCHECK, (st==0)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB12 ), BM_SETCHECK, (st==1)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB13 ), BM_SETCHECK, (st==2)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB14 ), BM_SETCHECK, (st==3)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB15 ), BM_SETCHECK, (st==4)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// XLC
		Ini->GetTruth( "CONFIG", "ScanLine", &st, DEFAULT_SCANLINE );
		SendMessage( GetDlgItem( hwnd, ID_CB2 ), BM_SETCHECK, st, 0 );
		
		// XLCPx
		Ini->GetInt( "CONFIG", "ScanLineBr", &st, DEFAULT_SCANLINEBR );
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_SCANLINEBR, str );
		
		// t[[g
		Ini->GetInt( "CONFIG", "FrameRate", &st, DEFAULT_FPS );
		SendMessage( GetDlgItem( hwnd, ID_TBFPS ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBFPS ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBFPS ), TBM_SETRANGE, TRUE, MAKELPARAM(1,6) );
		
		break;
		
	case PP_SOUND:	// TEh
		// TvO[g
		Ini->GetInt( "CONFIG", "SampleRate", &st, DEFAULT_SAMPLE_RATE );
		SendMessage( GetDlgItem( hwnd, ID_RB21 ), BM_SETCHECK, (st==44100)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB22 ), BM_SETCHECK, (st==22050)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB23 ), BM_SETCHECK, (st==11025)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// obt@TCY
		Ini->GetInt( "CONFIG", "SoundBuffer", &st, SOUND_BUFFER_SIZE );
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_EDIT1, str );
		
		// }X^[
		Ini->GetInt( "CONFIG", "MasterVolume", &st, DEFAULT_MASTERVOL );
		SendMessage( GetDlgItem( hwnd, ID_TBMST ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBMST ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBMST ), TBM_SETRANGE, TRUE, MAKELPARAM(0,10) );
		
		// PSG
		Ini->GetInt( "CONFIG", "PsgVolume", &st, DEFAULT_PSGVOL );
		SendMessage( GetDlgItem( hwnd, ID_TBPSG ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBPSG ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBPSG ), TBM_SETRANGE, TRUE, MAKELPARAM(0,10) );
		
		// 
		Ini->GetInt( "CONFIG", "VoiceVolume", &st, DEFAULT_VOICEVOL );
		SendMessage( GetDlgItem( hwnd, ID_TBVCE ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBVCE ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBVCE ), TBM_SETRANGE, TRUE, MAKELPARAM(0,10) );
		
		// TAPEj^
		Ini->GetInt( "CONFIG", "TapeVolume", &st, DEFAULT_TAPEVOL );
		SendMessage( GetDlgItem( hwnd, ID_TBTAPE ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBTAPE ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBTAPE ), TBM_SETRANGE, TRUE, MAKELPARAM(0,10) );
		
		break;
		
	case PP_FOLDER:	// tH_
		// ROMpX
		sprintf( str, "%s" ROM_DIR, OSD_GetModulePath() );		// ftHg
		Ini->GetString( "PATH", "RomPath", str, str );
		DELDELIMITER( str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_PATH1, str );
		
		// TAPEpX
		sprintf( str, "%s" TAPE_DIR, OSD_GetModulePath() );		// ftHg
		Ini->GetString( "PATH", "TapePath", str, str );
		DELDELIMITER( str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_PATH2, str );
		
		// DISKpX
		sprintf( str, "%s" DISK_DIR, OSD_GetModulePath() );		// ftHg
		Ini->GetString( "PATH", "DiskPath", str, str );
		DELDELIMITER( str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_PATH3, str );
		
		// gROMpX
		sprintf( str, "%s" EXTROM_DIR, OSD_GetModulePath() );	// ftHg
		Ini->GetString( "PATH", "ExtRomPath", str, str );
		DELDELIMITER( str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_PATH4, str );
		
		// IMGpX
		sprintf( str, "%s" IMAGE_DIR, OSD_GetModulePath() );	// ftHg
		Ini->GetString( "PATH", "ImgPath", str, str );
		DELDELIMITER( str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_PATH5, str );
		
		// WAVEpX
		sprintf( str, "%s" WAVE_DIR, OSD_GetModulePath() );		// ftHg
		Ini->GetString( "PATH", "WavePath", str, str );
		DELDELIMITER( str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_PATH6, str );
		
		// FONTpX
		sprintf( str, "%s" FONT_DIR, OSD_GetModulePath() );		// ftHg
		Ini->GetString( "PATH", "FontPath", str, str );
		DELDELIMITER( str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_PATH7, str );
		
		break;
		
	case PP_FILE:	// t@C
		// gROMt@C
		Ini->GetString( "FILES", "ExtRom", str2, "" );
		DELIMITER( str2 );
		if( str2[0] == '/' ) sprintf( str, "%s%s", cGlobal::GetRomPath(), str2 );
		else                 strncpy( str, str2, PATH_MAX );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_FEXROM, str );
		
		// TAPE(LOAD)t@C
		Ini->GetString( "FILES", "tape", str, "" );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_FTPLD, str );
		
		// TAPE(SAVE)t@C
		sprintf( str, "%s" SAVE_FILE, cGlobal::GetTapePath() );		// ftHg
		Ini->GetString( "FILES", "save", str, str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_FTPSV, str );
		
		// DISKt@C
		Ini->GetString( "FILES", "disk", str, "" );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_FDISK, str );
		
		// v^t@C
		sprintf( str, "%s" PRINTER_FILE, OSD_GetModulePath() );		// ftHg
		Ini->GetString( "FILES", "printer", str, str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_FPRINT, str );
		
		// SptHgt@C
		sprintf( str, "%s" FONTZ_FILE, cGlobal::GetFontPath() );	// ftHg
		Ini->GetString( "FILES", "fontz", str, str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_FFONTZ, str );
		
		// ptHgt@C
		sprintf( str, "%s" FONTH_FILE, cGlobal::GetFontPath() );	// ftHg
		Ini->GetString( "FILES", "fonth", str, str );
		UNDELIMITER( str );
		SetDlgItemText( hwnd, ID_FFONTH, str );
		
		break;
		
	case PP_COL:	// F1
		break;
		
	case PP_ETC:	// ̑
		// I[o[NbN
		Ini->GetInt( "CONFIG", "OverClock", &st, DEFAULT_REPEAT );
		st = min( max( 1, st ), 1000 );
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_OVERCLK, str );
		
		// CRC`FbN
		Ini->GetTruth( "CONFIG", "CheckCRC", &st, TRUE );
		SendMessage( GetDlgItem( hwnd, ID_CB4 ), BM_SETCHECK, st, 0 );
		
		break;
	}
	
	return TRUE;
}


///////////////////////////////////////////////////////////
// ݒۑ
///////////////////////////////////////////////////////////
static BOOL OsdWriteINI( HWND hwnd, int page )
{
	int st;					// Ԏ擾p
	char str[PATH_MAX];		// 擾p
	
	if( !Ini ) return FALSE;
	
	switch( page ){
	case PP_BASE:	// {
		// @
		if     ( IsDlgButtonChecked( hwnd, ID_RB02 ) ) st = 62;	// PC-6001mk2
		else if( IsDlgButtonChecked( hwnd, ID_RB03 ) ) st = 66;	// PC-6601
		else if( IsDlgButtonChecked( hwnd, ID_RB04 ) ) st = 64;	// PC-6001mk2SR
		else if( IsDlgButtonChecked( hwnd, ID_RB05 ) ) st = 68;	// PC-6601SR
		else                                           st = 60;	// LȊOȂPC-6001
		Ini->PutEntry( "CONFIG", MSINI_Model, "Model", "%02d", st );
		
		// FDD
		if     ( IsDlgButtonChecked( hwnd, ID_RB32 ) ) st = 1;		// 2
		else if( IsDlgButtonChecked( hwnd, ID_RB33 ) ) st = 2;		// 1
		else                                           st = 0;		// LȊOȂȂ
		Ini->PutEntry( "CONFIG", MSINI_FDD, "FDD", "%d", st );
		
		// gRAMgp
		Ini->PutEntry( "CONFIG", MSINI_ExtRam, "ExtRam", "%s", IsDlgButtonChecked( hwnd, ID_CB1 ) ? "Yes" : "No" );
		
		// Turbo TAPE
		Ini->PutEntry( "CONFIG", MSINI_TurboTAPE, "TurboTAPE", "%s", IsDlgButtonChecked( hwnd, ID_CB3 ) ? "Yes" : "No" );
		
		// L[s[gԊu
		GetDlgItemText( hwnd, ID_KEYREP, str, sizeof(str) );
		st = strtol( str, NULL, 0 );
		Ini->PutEntry( "CONFIG", MSINI_KeyRepeat, "KeyRepeat", "%d", st );
		
		break;
		
	case PP_DISP:	// 
		// MODE4J[
		if     ( IsDlgButtonChecked( hwnd, ID_RB12 ) ) st = 1;	// /
		else if( IsDlgButtonChecked( hwnd, ID_RB13 ) ) st = 2;	// /
		else if( IsDlgButtonChecked( hwnd, ID_RB14 ) ) st = 3;	// sN/
		else if( IsDlgButtonChecked( hwnd, ID_RB15 ) ) st = 4;	// /sN
		else                                           st = 0;	// LȊOȂ烂mN
		Ini->PutEntry( "CONFIG", MSINI_Mode4Color, "Mode4Color", "%d", st );
		
		// XLC
		Ini->PutEntry( "CONFIG", MSINI_ScanLine, "ScanLine", "%s", IsDlgButtonChecked( hwnd, ID_CB2 ) ? "Yes" : "No" );
		
		// XLCPx
		GetDlgItemText( hwnd, ID_SCANLINEBR, str, sizeof(str) );
		st = strtol( str, NULL, 0 );
		Ini->PutEntry( "CONFIG", MSINI_ScanLineBr, "ScanLineBr", "%d", st );
		
		// t[[g
		st = SendMessage( GetDlgItem( hwnd, ID_TBFPS ), TBM_GETPOS, 0, 0 );
		Ini->PutEntry( "CONFIG", MSINI_FrameRate, "FrameRate", "%d", st*10 );
		
		break;
		
	case PP_SOUND:	// TEh
		// TvO[g
		if     ( IsDlgButtonChecked( hwnd, ID_RB22 ) ) st = 22050;	// 22050
		else if( IsDlgButtonChecked( hwnd, ID_RB23 ) ) st = 11025;	// 11025
		else                                           st = 44100;	// LȊOȂ44100
		Ini->PutEntry( "CONFIG", MSINI_SampleRate, "SampleRate", "%d", st );
		
		// obt@TCY
		GetDlgItemText( hwnd, ID_EDIT1, str, sizeof(str) );
		st = strtol( str, NULL, 0 );
		Ini->PutEntry( "CONFIG", MSINI_SoundBuffer, "SoundBuffer", "%d", st );
		
		// }X^[
		st = SendMessage( GetDlgItem( hwnd, ID_TBMST ), TBM_GETPOS, 0, 0 );
		Ini->PutEntry( "CONFIG", MSINI_MasterVolume, "MasterVolume", "%d", st*10 );
		
		// PSG
		st = SendMessage( GetDlgItem( hwnd, ID_TBPSG ), TBM_GETPOS, 0, 0 );
		Ini->PutEntry( "CONFIG", MSINI_PsgVolume, "PsgVolume", "%d", st*10 );
		
		// 
		st = SendMessage( GetDlgItem( hwnd, ID_TBVCE ), TBM_GETPOS, 0, 0 );
		Ini->PutEntry( "CONFIG", MSINI_VoiceVolume, "VoiceVolume", "%d", st*10 );
		
		// TAPEj^
		st = SendMessage( GetDlgItem( hwnd, ID_TBTAPE ), TBM_GETPOS, 0, 0 );
		Ini->PutEntry( "CONFIG", MSINI_TapeVolume, "TapeVolume", "%d", st*10 );
		
		break;
		
	case PP_FOLDER:	// tH_
		// ROMpX
		GetDlgItemText( hwnd, ID_PATH1, str, sizeof(str) );
		DELDELIMITER( str );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH", MSINI_RomPath, "RomPath", "%s", str );
		
		// TAPEpX
		GetDlgItemText( hwnd, ID_PATH2, str, sizeof(str) );
		DELDELIMITER( str );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH", MSINI_TapePath, "TapePath", "%s", str );
		
		// DISKpX
		GetDlgItemText( hwnd, ID_PATH3, str, sizeof(str) );
		DELDELIMITER( str );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH", MSINI_DiskPath, "DiskPath", "%s", str );
		
		// gROMpX
		GetDlgItemText( hwnd, ID_PATH4, str, sizeof(str) );
		DELDELIMITER( str );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH", MSINI_ExtRomPath, "ExtRomPath", "%s", str );
		
		// IMGpX
		GetDlgItemText( hwnd, ID_PATH5, str, sizeof(str) );
		DELDELIMITER( str );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH", MSINI_ImgPath, "ImgPath", "%s", str );
		
		// WAVEpX
		GetDlgItemText( hwnd, ID_PATH6, str, sizeof(str) );
		DELDELIMITER( str );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH", MSINI_WavePath, "WavePath", "%s", str );
		
		// FONTpX
		GetDlgItemText( hwnd, ID_PATH7, str, sizeof(str) );
		DELDELIMITER( str );
		UNDELIMITER( str );
		Ini->PutEntry( "PATH", MSINI_FontPath, "FontPath", "%s", str );
		
		break;
		
	case PP_FILE:	// t@C
		// gROMt@C
		GetDlgItemText( hwnd, ID_FEXROM, str, sizeof(str) );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES", MSINI_ExtRom, "ExtRom", "%s", str );
		
		// TAPE(LOAD)t@C
		GetDlgItemText( hwnd, ID_FTPLD, str, sizeof(str) );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES", MSINI_tape, "tape", "%s", str );
		
		// TAPE(SAVE)t@C
		GetDlgItemText( hwnd, ID_FTPSV, str, sizeof(str) );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES", MSINI_save, "save", "%s", str );
		
		// DISKt@C
		GetDlgItemText( hwnd, ID_FDISK, str, sizeof(str) );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES", MSINI_disk, "disk", "%s", str );
		
		// v^t@C
		GetDlgItemText( hwnd, ID_FPRINT, str, sizeof(str) );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES", MSINI_printer, "printer", "%s", str );
		
		// SptHgt@C
		GetDlgItemText( hwnd, ID_FFONTZ, str, sizeof(str) );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES", MSINI_fontz, "fontz", "%s", str );
		
		// ptHgt@C
		GetDlgItemText( hwnd, ID_FFONTH, str, sizeof(str) );
		UNDELIMITER( str );
		Ini->PutEntry( "FILES", MSINI_fonth, "fonth", "%s", str );
		
		break;
		
	case PP_COL:	// F1
		break;
		
	case PP_ETC:	// ̑
		// I[o[NbN
		GetDlgItemText( hwnd, ID_OVERCLK, str, sizeof(str) );
		st = min( max( 1, strtol( str, NULL, 0 ) ), 1000 );
		Ini->PutEntry( "CONFIG", MSINI_OverClock, "OverClock", "%d", st );
		
		// CRC`FbN
		Ini->PutEntry( "CONFIG", MSINI_CheckCRC, "CheckCRC", "%s", IsDlgButtonChecked( hwnd, ID_CB4 ) ? "Yes" : "No" );
		
		break;
	}
	
	// INIt@Cɏ
	Ini->Write();
	
	return TRUE;
}


///////////////////////////////////////////////////////////
// ݒ_CAOvV[W
///////////////////////////////////////////////////////////
// {
static BOOL CALLBACK OsdCnfgProc1( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_BASE ) ) OSD_Message( MSGE_INIREAD, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
//	case WM_COMMAND:
//		PropSheet_Changed( GetParent( hwnd ), hwnd );
//		return TRUE;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:	// OK{^
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_BASE ) ) OSD_Message( MSGE_INIWRITE, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// 
static BOOL CALLBACK OsdCnfgProc2( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_DISP ) ) OSD_Message( MSGE_INIREAD, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_DISP ) ) OSD_Message( MSGE_INIWRITE, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// TEh
static BOOL CALLBACK OsdCnfgProc3( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_SOUND ) ) OSD_Message( MSGE_INIREAD, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_SOUND ) ) OSD_Message( MSGE_INIWRITE, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// t@C
static BOOL CALLBACK OsdCnfgProc4( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_FILE ) ) OSD_Message( MSGE_INIREAD, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_COMMAND:
		char Folder[PATH_MAX];
		switch( wp ){
		case ID_B11:	// t@CQƃ{^(gROMC[W)
			GetDlgItemText( hwnd, ID_FEXROM, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_ExtRom, Folder, NULL ) ){
				UNDELIMITER( Folder );
				SetDlgItemText( hwnd, ID_FEXROM, Folder );
			}
			break;
			
		case ID_B12:	// t@CQƃ{^(TAPEC[W(LOAD))
			GetDlgItemText( hwnd, ID_FTPLD, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_TapeLoad, Folder, cGlobal::GetTapePath() ) ){
				UNDELIMITER( Folder );
				SetDlgItemText( hwnd, ID_FTPLD, Folder );
			}
			break;
			
		case ID_B13:	// t@CQƃ{^(TAPEC[W(SAVE))
			GetDlgItemText( hwnd, ID_FTPSV, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_TapeSave, Folder, cGlobal::GetTapePath() ) ){
				UNDELIMITER( Folder );
				SetDlgItemText( hwnd, ID_FTPSV, Folder );
			}
			break;
			
		case ID_B14:	// t@CQƃ{^(DISKC[W)
			GetDlgItemText( hwnd, ID_FDISK, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_Disk, Folder, cGlobal::GetDiskPath() ) ){
				UNDELIMITER( Folder );
				SetDlgItemText( hwnd, ID_FDISK, Folder );
			}
			break;
			
		case ID_B15:	// t@CQƃ{^(v^o̓t@C)
			GetDlgItemText( hwnd, ID_FPRINT, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_Printer, Folder, NULL ) ){
				UNDELIMITER( Folder );
				SetDlgItemText( hwnd, ID_FPRINT, Folder );
			}
			break;
			
		case ID_B16:	// t@CQƃ{^(SptHgt@C)
			GetDlgItemText( hwnd, ID_FFONTZ, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_FontZ, Folder, cGlobal::GetFontPath() ) ){
				UNDELIMITER( Folder );
				SetDlgItemText( hwnd, ID_FFONTZ, Folder );
			}
			break;
			
		case ID_B17:	// t@CQƃ{^(ptHgt@C)
			GetDlgItemText( hwnd, ID_FFONTH, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_FontH, Folder, cGlobal::GetFontPath() ) ){
				UNDELIMITER( Folder );
				SetDlgItemText( hwnd, ID_FFONTH, Folder );
			}
			break;
		}
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_FILE ) ) OSD_Message( MSGE_INIWRITE, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// tH_
static BOOL CALLBACK OsdCnfgProc5( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_FOLDER ) ) OSD_Message( MSGE_INIREAD, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_COMMAND:
		char Folder[PATH_MAX];
		switch( wp ){
		case ID_B01:	// tH_Qƃ{^(ROM)
			GetDlgItemText( hwnd, ID_PATH1, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH1, Folder );
			break;
			
		case ID_B02:	// tH_Qƃ{^(TAPE)
			GetDlgItemText( hwnd, ID_PATH2, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH2, Folder );
			break;
			
		case ID_B03:	// tH_Qƃ{^(DISK)
			GetDlgItemText( hwnd, ID_PATH3, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH3, Folder );
			break;
			
		case ID_B04:	// tH_Qƃ{^(gROM)
			GetDlgItemText( hwnd, ID_PATH4, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH4, Folder );
			break;
			
		case ID_B05:	// tH_Qƃ{^(IMG)
			GetDlgItemText( hwnd, ID_PATH5, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH5, Folder );
			break;
			
		case ID_B06:	// tH_Qƃ{^(WAVE)
			GetDlgItemText( hwnd, ID_PATH6, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH6, Folder );
			break;
			
		case ID_B07:	// tH_Qƃ{^(FONT)
			GetDlgItemText( hwnd, ID_PATH7, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH7, Folder );
			break;
		}
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_FOLDER ) ) OSD_Message( MSGE_INIWRITE, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// F1
static BOOL CALLBACK OsdCnfgProcCol( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	// INIp
	int st;
	char strin[16];
	char str[PATH_MAX];
	static COLORREF Color = 0;
	static COLORREF CustColors[16] = { RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ),
									   RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ),
									   RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ),
									   RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ) };
	static CHOOSECOLOR cc = { 0 };	// F̑Ip
	
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_COL ) ) OSD_Message( MSGE_INIREAD, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		
		// F̑I R_CAO 
		cc.lStructSize  = sizeof(CHOOSECOLOR);
		cc.hwndOwner    = hwnd;
		cc.rgbResult    = Color;
		cc.lpCustColors = CustColors;
		cc.Flags        = CC_FULLOPEN | CC_RGBINIT;
		
		break;
		
	case WM_DRAWITEM:	// I[i[h[
		if( wp >= ID_COL17 && wp < ID_COLMAX ){
			sprintf( strin, "COL%03d", wp-ID_COL00 );	// 0-16 ͕ύXs
			if( Ini->GetString( "COLOR", strin, str, "" ) ){
				st = strtol( str, NULL, 16 );
				// I[i[h[{^ `
				OsdOwnerDrawBtn( ((LPDRAWITEMSTRUCT)lp)->hDC,
								 ((LPDRAWITEMSTRUCT)lp)->rcItem,
								 RGB( (st>>16)&0xff, (st>>8)&0xff, st&0xff ) );
			}
			return TRUE;
		}
		return FALSE;
		
	case WM_COMMAND:
		if( wp >= ID_COL17 && wp < ID_COLMAX ){
			sprintf( strin, "COL%03d", wp-ID_COL00 );	// 0-16 ͕ύXs
			if( Ini->GetString( "COLOR", strin, str, "" ) ){
				st = strtol( str, NULL, 16 );
				Color = RGB( (st>>16)&0xff, (st>>8)&0xff, st&0xff );
				// F̑I R_CAO\
				cc.rgbResult    = Color;
				if( ChooseColor( &cc ) ){
					Color = cc.rgbResult;
					sprintf( strin, "COL%03d", wp-ID_COL00 );
					Ini->PutEntry( "COLOR", OSD_ColorName( wp-ID_COL00-17 ), strin, "%02X%02X%02X", GetRValue( Color ), GetGValue( Color ), GetBValue( Color ) );
					InvalidateRect( hwnd, NULL, TRUE );
				}
			}
		}
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_COL ) ) OSD_Message( MSGE_INIWRITE, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// ̑
static BOOL CALLBACK OsdCnfgProcEtc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_ETC ) ) OSD_Message( MSGE_INIREAD, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_ETC ) ) OSD_Message( MSGE_INIWRITE, MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}


// I[i[h[{^ `
static void OsdOwnerDrawBtn( HDC hdc, RECT rc, COLORREF col )
{
	HPEN hOldPen   = (HPEN)SelectObject( hdc, (HPEN)GetStockObject( BLACK_PEN ) );
	HBRUSH hBrs    = CreateSolidBrush( col );
	HBRUSH hOldBrs = (HBRUSH)SelectObject( hdc, hBrs );
	
	Rectangle( hdc, rc.left, rc.top, rc.right, rc.bottom );
	
	SelectObject( hdc, hOldPen );
	SelectObject( hdc, hOldBrs );
	DeleteObject( hBrs );
}



///////////////////////////////////////////////////////////
// o[W_CAOvV[W
///////////////////////////////////////////////////////////
static BOOL CALLBACK VerInfoProc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	static HCURSOR hCursor = NULL;
	
	switch( msg ){
	case WM_INITDIALOG:
		{
		// o[Wݒ
		SetDlgItemText( hwnd, ID_VERSTR, "PC-6001V " VERSION );
		
		// ACRݒ
		const char *ilp;
		switch( cGlobal::GetModel() ){
		case 62: ilp = MAKEINTRESOURCE(P62ICON); break;
		case 66: ilp = MAKEINTRESOURCE(P66ICON); break;
		case 64: ilp = MAKEINTRESOURCE(P64ICON); break;
		case 68: ilp = MAKEINTRESOURCE(P68ICON); break;
		default: ilp = MAKEINTRESOURCE(P60ICON);
		}
		HICON hNewIcon = LoadIcon( (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE), ilp );
		HICON hOldIcon = (HICON)SendMessage( GetDlgItem( hwnd, ID_VERICON ), STM_SETICON, (WPARAM)hNewIcon, 0 );
		if( hOldIcon ) DeleteObject( hOldIcon );
		
		// w^J[\擾
		HINSTANCE hInstHelp;
		char WinDir[MAX_PATH];
		
		GetWindowsDirectory( WinDir, MAX_PATH-13 );
		lstrcat( WinDir, "\\winhlp32.exe");
		hInstHelp = LoadLibrary( WinDir );
		if( hInstHelp ){
			hCursor = (HCURSOR)CopyImage( LoadImage( hInstHelp, MAKEINTRESOURCE(106), IMAGE_CURSOR, 0, 0, LR_DEFAULTCOLOR ), IMAGE_CURSOR, 0, 0, LR_COPYDELETEORG );
			FreeLibrary( hInstHelp );
		}else
			hCursor = (HCURSOR)LoadImage( NULL, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_DEFAULTCOLOR );
		break;
		}
	case WM_SETCURSOR:	// J[\ύX
		if( (HWND)wp == GetDlgItem( hwnd, ID_URL ) ){
			SetCursor( hCursor );
			SetWindowLong( hwnd, DWL_MSGRESULT, MAKELONG( TRUE, 0 ) );
			return TRUE;
		}
		return FALSE;
		break;
		
	case WM_CTLCOLORSTATIC:	// URL̐Fς
		{
		HDC hDC = (HDC)wp;
		if( (HWND)lp == GetDlgItem( hwnd, ID_URL ) ){
//			SelectObject( hDC, hFontHtml );		// tHgς
			SetTextColor( hDC, RGB(0,0,255) );	// Fς
			SetBkMode( hDC, TRANSPARENT );
			return (BOOL)(HBRUSH)GetStockObject( NULL_BRUSH );
		}
		return (BOOL)(HBRUSH)( COLOR_BTNFACE + 1 );
		}
		break;
		
	case WM_COMMAND:
    	switch( LOWORD(wp) ){
		case IDOK:
		case IDCANCEL:
			if( hCursor ) DestroyCursor( hCursor );	// J[\J
			EndDialog( hwnd, TRUE );
			break;
		case ID_URL:
			{
			char Url[256];
			GetWindowText( GetDlgItem( hwnd, ID_URL ), Url, 256 );
			ShellExecute( hwnd, "open", Url, NULL, NULL, SW_SHOWNORMAL );
			InvalidateRect( GetDlgItem( hwnd, ID_URL ), NULL, FALSE );
			return TRUE;
			}
		}
	}
	return FALSE;
}
