#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "ini.h"
#include "osd.h"

#define MAX_LINE	256
#define TABW		4
#define TABN		4


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cNode::cNode( cNode *pn )
{
	// ѿ
	NodeID   = NODE_NONE;
	
	// ΥΡ
	PrevNode = pn;
	// ΥΡ
	if( PrevNode ){
		NextNode = PrevNode->GetNextNode();
		PrevNode->SetNextNode( this );
	}else
		NextNode = NULL;
	
	Comment = Section = Entry = Value = NULL;
	
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cNode::~cNode( void )
{
	if( Comment ) delete [] Comment;
	if( Section ) delete [] Section;
	if( Entry   ) delete [] Entry;
	if( Value   ) delete [] Value;
	
	// ĤʤäƤΡɤк
	if( NextNode ) delete NextNode;
}


////////////////////////////////////////////////////////////////
// Ρɤɲ
////////////////////////////////////////////////////////////////
cNode *cNode::AddNode( void )
{
	return new cNode( this );
}


////////////////////////////////////////////////////////////////
// ǡ򥻥å(ʸϤ)
////////////////////////////////////////////////////////////////
void cNode::SetMember( NodeType id, const char *str )
{
	char tstr[MAX_LINE+1];
	char *tpstr;
	
	strncpy( tstr, str, MAX_LINE );
	
	NodeID = id;
	switch( NodeID ){
	case NODE_COMMENT:	// Comment
		// ';'μʸȤƬ
//		tpstr = strchr( tstr, ';' );
//		if( !tpstr ) tpstr = tstr;
//		else         tpstr++;
		
		// βԤ
		while( str[strlen(tstr)-1] == '\n' )
			tstr[strlen(tstr)-1] = '\0';
		
		if( Comment ) delete [] Comment;
		Comment = new char[strlen(tstr)+1];
		strcpy( Comment, tstr );
		break;
		
	case NODE_SECTION:	// Section
		// ']'ΤȤˤ
		if( strchr( tstr, ']' ) ) *strchr( tstr, ']' ) = '\0';
		// '['μʸƬ
		if( strchr( tstr, '[' ) ) tpstr = strchr( tstr, '[' ) + 1;
		else                      tpstr = tstr;
		if( Section ) delete [] Section;
		Section = new char[strlen( tpstr ) + 1];
		strcpy( Section, tpstr );
		break;
		
	case NODE_ENTRY:	// Entry
		//  ---
		// '='μʸͤƬ
		tpstr = strchr( tstr, '=' ) + 1;
		
		// Ǹ夬Ԥʤ'\0'֤
		if( tpstr[strlen(tpstr)-1] == '\n' )
			tpstr[strlen(tpstr)-1] = '\0';
		// ͤ' ''\t'̵
		while( *tpstr == ' ' || *tpstr == '\t')
			tpstr++;
		
		// Ǹ'\"'';' ϥ
		if( strrchr( tpstr, ';' ) > strrchr( tpstr, '\"' ) ){
			this->SetMember( NODE_COMMENT, strrchr( tpstr, ';' )+1 );
			NodeID = NODE_ENTRY;
			*strrchr( tpstr, ';' ) = '\0';
		}
		// ͤθ' ''\t'̵
		while( tpstr[strlen(tpstr)-1] == ' ' || tpstr[strlen(tpstr)-1] == '\t' )
			tpstr[strlen(tpstr)-1] = '\0';
		
		// Ƭ'\"'Ф
		if( *tpstr == '\"' ) tpstr++;
		// '\"'ˤ
		if( tpstr[strlen(tpstr)-1] == '\"' )
			tpstr[strlen(tpstr)-1] = '\0';
		
		if( Value ) delete [] Value;
		Value = new char[strlen( tpstr ) + 1];
		strcpy( Value, tpstr );
		
		// ȥ ---
		// '='ΤȤˤ
		*strchr( tstr, '=' ) = '\0';
		tpstr = tstr;
		// ȥ' ''\t'̵
		while( *tpstr == ' ' || *tpstr == '\t')
			tpstr++;
		// ȥ' ''\t'̵
		while( tpstr[strlen(tpstr)-1] == ' ' || tpstr[strlen(tpstr)-1] == '\t' )
			tpstr[strlen(tpstr)-1] = '\0';
		
		if( Entry ) delete [] Entry;
		Entry = new char[strlen( tpstr ) + 1];
		strcpy( Entry, tpstr );
		break;
		
	case NODE_NONE:
	default:
		NodeID = NODE_NONE;
		
	}
	
}


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cIni::cIni( void )
{
	Ready   = FALSE;
	IniNode = NULL;
	
	*FileName = '\0';
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cIni::~cIni( void )
{
	if( IniNode ) delete IniNode;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cIni::Init( char *filename )
{
	char str[MAX_LINE+1];
	FILE *fp;
	cNode *node;
	
	// ե̾¸
	strncpy( FileName, filename, PATH_MAX-1 );
	
	// ǽΥΡɳ(ߡ)
	if( IniNode ) delete IniNode;
	IniNode = node = new cNode( NULL );
	if( !IniNode ) return FALSE;
	
	// INIե򳫤
	fp = fopen( FileName, "rt" );
	if( !fp ) return FALSE;
	
	// Ƭɤ
	fseek( fp, 0, SEEK_SET );
	// ǡ̵ʤޤǷ֤
	while( fgets( str, MAX_LINE, fp ) ){
		// Ρɳ
		node = node->AddNode();
		if( !node ){
			fclose( fp );
			return FALSE;
		}
		
		// Ƭ';'ä饳ȹ
		if( *str == ';' )
			node->SetMember( cNode::NODE_COMMENT, str+1 );
		else
		// '['']'ޤ'='ޤޤʤʤ饻
		if( strchr( str, '[' ) && strchr( str, ']' ) && !strchr( str, '=' ) )
			node->SetMember( cNode::NODE_SECTION, str );
		else
		// '='ޤʤ饨ȥ
		if( strchr( str, '=' ) )
			node->SetMember( cNode::NODE_ENTRY, str );
		else
		// ɤǤʤХ
			node->SetMember( cNode::NODE_COMMENT, str );
	}
	fclose( fp );
	
	Ready = TRUE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cIni::Write( void )
{
	FILE *fp;
	cNode *node;
	
	if( !Ready ) return FALSE;
	
	// INIե򳫤
	fp = fopen( FileName, "wt" );
	if( !fp ) return FALSE;
	
	node = IniNode;
	do{
		switch( node->NodeID ){
		case cNode::NODE_COMMENT:	// Comment
			if( strlen(node->Comment) ) fprintf( fp, ";%s\n", node->Comment );
			else                        fprintf( fp, "\n" );
			break;
			
		case cNode::NODE_SECTION:	// Section
			fprintf( fp, "[%s]\n", node->Section );
			break;
			
		case cNode::NODE_ENTRY:	// Entry
			fprintf( fp, "%s", node->Entry );
			for( int i=TABN*TABW-(int)strlen(node->Entry); i>0; i-=TABW )
				fprintf( fp, "\t" );
				
			fprintf( fp, "= %s", node->Value );
				
			if( node->Comment ){
				for( int i=TABN*TABW-((int)strlen(node->Value)+2); i>0; i-=TABW )
					fprintf( fp, "\t" );
				fprintf( fp, "\t;%s\n", node->Comment );
			}else
				fprintf( fp, "\n" );
			
			break;
			
		case cNode::NODE_NONE:
		default:
			break;
		}
	}while( (node = node->GetNextNode()) );
	
	fclose( fp );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ʸɹ
////////////////////////////////////////////////////////////////
BOOL cIni::GetString( const char *section, const char *entry, char *val, const char *def )
{
	cNode *node, *tnode;
	BOOL Found  = FALSE;
	
	// ޤϥǥեͤ򥻥å
	strcpy( val, def );
	
	if( !Ready ) return FALSE;
	
	// õ
	node = IniNode;
	do{
		if( node->NodeID == cNode::NODE_SECTION )
			if( !stricmp( node->Section, section ) ) Found = TRUE;
	}while( (node = node->GetNextNode()) && !Found );
	// 󤬸Ĥʤȥ꤬ʤХ顼
	if( !Found || !node ) return FALSE;
	Found = FALSE;
	
	// ȥõ
	do{
		tnode = node;
		if( node->NodeID == cNode::NODE_ENTRY )
			if( !stricmp( node->Entry, entry ) ) Found = TRUE;
	}while( (node = node->GetNextNode()) && tnode->NodeID != cNode::NODE_SECTION && !Found  );
	// ȥ꤬ĤʤХ顼
	if( !Found ) return FALSE;
	
	// ͤ¸
	strcpy( val, tnode->Value );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɹ
////////////////////////////////////////////////////////////////
BOOL cIni::GetInt( const char *section, const char *entry, int *val, const int def )
{
	BOOL res;
	char str[MAX_LINE+1];
	
	// ޤϥǥեͤ򥻥å
	*val = def;
	
	if( (res = GetString( section, entry, str, "" )) )
		*val = strtol( str, NULL, 0 );
	
	return res;
}


////////////////////////////////////////////////////////////////
// YesNoɹ
////////////////////////////////////////////////////////////////
BOOL cIni::GetTruth( const char *section, const char *entry, BOOL *val, const BOOL def )
{
	BOOL res;
	char str[MAX_LINE+1];
	
	// ޤϥǥեͤ򥻥å
	*val = def;
	
	if( (res = GetString( section, entry, str, "" )) ){
		if( !strcmp( str, "1" ) || !stricmp( str, "yes" ) || !stricmp( str, "on" ) || !stricmp( str, "true" ) )
			*val = TRUE;
		else
		if( !strcmp( str, "0" ) || !stricmp( str, "no" ) || !stricmp( str, "off" ) || !stricmp( str, "false" ) )
			*val = FALSE;
		else
			return FALSE;
	}
	return res;
}


////////////////////////////////////////////////////////////////
// ȥɲ
////////////////////////////////////////////////////////////////
BOOL cIni::PutEntry( const char *section, const char *comment, const char *entry, const char *val, ... )
{
	char rstr[MAX_LINE+1];
	cNode *node, *tnode;
	BOOL Found = FALSE;
	
	if( !Ready ) return FALSE;
	
	// 
	va_list arg;
	va_start( arg, val );
	vsprintf( rstr, val, arg );
	va_end( arg );
	
	
	// õ
	node = IniNode;
	do{
		tnode = node;
		if( node->NodeID == cNode::NODE_SECTION )
			if( !stricmp( node->Section, section ) ) Found = TRUE;
	}while( (node = node->GetNextNode() ) && !Found );
	
	// 󤬸Ĥʤɲ
	if( !Found ){
		// Ρɲ
		node = tnode->AddNode();
		if( !node ) return FALSE;
		node->SetMember( cNode::NODE_SECTION, section );
		// ȥΡɲ
		node = node->AddNode();
		if( !node ) return FALSE;
	}else{
	// 󤬸Ĥä
		Found = FALSE;
		
		// ȥõ
		do{
			tnode = node;
			if( node->NodeID == cNode::NODE_ENTRY )
				if( !stricmp( node->Entry, entry ) ) Found = TRUE;
		}while( (node = node->GetNextNode()) && tnode->NodeID != cNode::NODE_SECTION && !Found  );
		node = tnode;
		// ȥ꤬Ĥʤɲ
		if( !Found ){
			// ΥãκǸΥΡɤ
			if( tnode->NodeID == cNode::NODE_SECTION ) node = tnode->GetPrevNode();
			
			// ȥΡɲ
			node = node->AddNode();
			if( !node ) return FALSE;
		}
	}
	
	// ȥ˥Ȥʤɲ
	if( comment ) node->SetMember( cNode::NODE_COMMENT, comment );
	
	// ȥ¸
	char tstr[MAX_LINE+1];
	sprintf( tstr, "%s=%s", entry, rstr );
	node->SetMember( cNode::NODE_ENTRY, tstr );
	
	return TRUE;
}
