#include "intr.h"
#include "schedule.h"


// ٥ID
#define	EID_TIMER	(1)
#define	EID_LOAD	(2)
#define	EID_SAVE	(3)


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
INT6::INT6( VM6 *vm ) : P6DEVENT(vm){}
INT60::INT60( VM6 *vm, const ID& id ) : INT6(vm), Device(id){}
INT62::INT62( VM6 *vm, const ID& id ) : INT6(vm), Device(id){}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
INT6::~INT6( void ){}
INT60::~INT60( void ){}
INT62::~INT62( void ){}


////////////////////////////////////////////////////////////////
// ٥ȥХåؿ
////////////////////////////////////////////////////////////////
void INT6::EventCallback( int id, int clock )
{
	switch( id ){
	case EID_TIMER:		// ޳ȯ
		SetTimerIntr();
		break;
	}
}


////////////////////////////////////////////////////////////////
// ޳߼ȿѹ
////////////////////////////////////////////////////////////////
void INT6::SetTimerIntrHz( BYTE data )
{
	vm->sche->SetHz( this, EID_TIMER, UTIMER_HZ/(data+1) );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL INT6::Init( void )
{
	PRINTD( INTR_LOG, "[INTR][Init]\n" );
	
	// ٥ɲ
	if( !vm->sche->Add( this, EID_TIMER, DEFAULT_TIMER_HZ, EV_LOOP|EV_HZ ) ) return FALSE;
	
	Reset();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void INT60::Reset( void )
{
	PRINTD( INTR_LOG, "[INTR][Reset]\n" );
	
	// ߥɥ쥹
	TimerAddr = 3;
	
	// Ƽѿ
	TimerIntrEnable  =			// ޳ߵĥե饰ߤ
	IntrReserved     = FALSE;	// ͽե饰ߤ
	
	// Ƽȯե饰ߤ
	IntrKEY1 =
	IntrKEY2 =
	IntrKEY3 =
	IntrTIMER =
	IntrCMT_R =
	IntrCMT_E =
	IntrJOY = FALSE;
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	TimerCount = 		// 1ô֤Υ޳߲
	CmtCount   = 0;		// 1ô֤CMT߲
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
}

void INT62::Reset( void )
{
	PRINTD( INTR_LOG, "[INTR][Reset]\n" );
	
	// ߥɥ쥹
	TimerAddr = 3;
	Int1Addr  = Int2Addr = 0;
	
	// Ƽѿ
	TimerIntrEnable  =			// ޳ߵĥե饰ߤ
	TimerIntrEnable2 =			// ޳ߵĥե饰ߤ(mk2ʹ)
	IntrReserved     = FALSE;	// ͽե饰ߤ
	
	// Ƽȯե饰ߤ
	IntrKEY1 =
	IntrKEY2 =
	IntrKEY3 =
	IntrTIMER =
	IntrCMT_R =
	IntrCMT_E =
	IntrJOY = FALSE;
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	TimerCount = 		// 1ô֤Υ޳߲
	CmtCount   = 0;		// 1ô֤CMT߲
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
}


////////////////////////////////////////////////////////////////
// ߥå
// ȯꤷPoretAΥǡ򥻥å
// ߤ̤ͥϤ褯狼
////////////////////////////////////////////////////////////////
int INT6::IntrCheck( void )
{
	int	IntrNo = -1;
	
	// ޳
	if( IntrTIMER && IsTimerIntrEnable() ){
		IntrTIMER = FALSE;
		IntrNo    = TimerAddr;
		#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		TimerCount++;
		#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	}
	// 1 1
	else if( IntrKEY1 ){
		IntrKEY1 = FALSE;
		IntrNo   = 7;
	}
	// 1 2
	// 1ȤΤ???
//	else if( IntrKEY1 ){
//		IntrKEY1 = FALSE;
//		IntrNo   = 8;
//	}
	// CMT READ 
	else if( IntrCMT_R ){
		IntrCMT_R = FALSE;
		IntrNo    = 4;
		SetIntrReserved( ResCmt );
	}
	// CMT ERROR 
	else if( IntrCMT_E ){
		IntrCMT_E = FALSE;
		IntrNo    = 9;
	}
	// 2
	else if( IntrKEY2 ){
		IntrKEY2 = FALSE;
		IntrNo   = 10;
	}
	// 3
	else if( IntrKEY3 ){
		IntrKEY3 = FALSE;
		IntrNo   = 1;
	}
	// RS232S  (̤)
//	else if( FALSE ){
//		IntrNo = 0;
//	}
	// ѥ
	else if( IntrJOY ){
		IntrJOY = FALSE;
		IntrNo  = 11;
	}
	
	if( IntrNo >= 0 ){
		PRINTD1( INTR_LOG, "[INTR][IntrCheck] IntrNo = %d\n", IntrNo  );
		IntrNo <<= 1;
	}
	
	return IntrNo;
}


////////////////////////////////////////////////////////////////
// ޳ȯ
////////////////////////////////////////////////////////////////
void INT6::SetTimerIntr( void )
{
	PRINTD( INTR_LOG, "[INTR][SetTimerIntr]\n" );
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( vm->cGlobal::TimerIntr )
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		IntrTIMER = TRUE;
}


////////////////////////////////////////////////////////////////
// CMTȯ
////////////////////////////////////////////////////////////////
void INT6::SetCmtIntr( BYTE data )
{
	PRINTD( INTR_LOG, "[INTR][SetCmtIntr]" );
	
	IntrCMT_R = TRUE;
	ResCmt    = data;
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	CmtCount++;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
}


////////////////////////////////////////////////////////////////
// ȯ
////////////////////////////////////////////////////////////////
void INT6::SetKeyIntr( int type, BYTE data )
{
	PRINTD1( INTR_LOG, "[INTR][SetKeyIntr] Type:%d\n", type );
	
	// ߵ/ػߤˤ餺PortAˤϥǡ餷
	// 8049 & 8255 λŻ?
	if( SetIntrReserved( data ) ){
		switch( type ){
		case 1: IntrKEY1 = TRUE; break;	// 1ȯ
		case 2: IntrKEY2 = TRUE; break;	// 2ȯ
		case 3: IntrKEY3 = TRUE; break;	// 3ȯ
		}
	}
}


////////////////////////////////////////////////////////////////
// ѥȯ
////////////////////////////////////////////////////////////////
void INT6::SetJoyIntr( BYTE data )
{
	PRINTD( INTR_LOG, "[INTR][SetJoyIntr]\n" );
	
	// ߵ/ػߤˤ餺PortAˤϥǡ餷
	// 8049 & 8255 λŻ?
	if( SetIntrReserved( data ) ) IntrJOY = TRUE;
}


////////////////////////////////////////////////////////////////
// ͽ
// PortAͤϰŪ¸,ݡȥ꡼ɻ˽
// ΥǡɤޤƤʤн
////////////////////////////////////////////////////////////////
BOOL INT6::SetIntrReserved( BYTE data )
{
	PRINTD( INTR_LOG, "[INTR][SetIntrReserved]\n" );
	
// ڳ߶ػ߻ΥϤԶ礬ȯ뤿Ȥꤢ̵
//	if( IntrReserved ) return FALSE;
//	else{
		IntrReserved = TRUE;
		IntrPortA    = data;
		return TRUE;
//	}
}


////////////////////////////////////////////////////////////////
// ͽPortAåͼ
// :ߤPortA
////////////////////////////////////////////////////////////////
BYTE INT6::GetIntrReserved( BYTE data )
{
	PRINTD( INTR_LOG, "[INTR][GetIntrReserved]\n" );
	
	if( IntrReserved ){
		IntrReserved = FALSE;
		return IntrPortA;
	}else
		return data;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL INT6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "INTR", NULL, "TimerIntrEnable",		"%s",		TimerIntrEnable ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrKEY1",			"%s",		IntrKEY1 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrKEY2",			"%s",		IntrKEY2 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrKEY3",			"%s",		IntrKEY3 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrTIMER",			"%s",		IntrTIMER ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrCMT_R",			"%s",		IntrCMT_R ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrCMT_E",			"%s",		IntrCMT_E ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrJOY",				"%s",		IntrJOY ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "TimerAddr",			"0x%02X",	TimerAddr );
	Ini->PutEntry( "INTR", NULL, "IntrReserved",		"%s",		IntrReserved ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrPortA",			"0x%02X",	IntrPortA );
	Ini->PutEntry( "INTR", NULL, "ResCmt",				"0x%02X",	ResCmt );
	
	return TRUE;
}

BOOL INT62::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "INTR", NULL, "TimerIntrEnable2",	"%s",		TimerIntrEnable2 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "Int1Addr",			"0x%02X",	Int1Addr );
	Ini->PutEntry( "INTR", NULL, "Int2Addr",			"0x%02X",	Int2Addr );
	
	return INT6::DokoSave( Ini );
}



////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL INT6::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetTruth( "INTR", "TimerIntrEnable",	&TimerIntrEnable,	TimerIntrEnable );
	Ini->GetTruth( "INTR", "IntrKEY1",			&IntrKEY1,			IntrKEY1 );
	Ini->GetTruth( "INTR", "IntrKEY2",			&IntrKEY2,			IntrKEY2 );
	Ini->GetTruth( "INTR", "IntrKEY3",			&IntrKEY3,			IntrKEY3 );
	Ini->GetTruth( "INTR", "IntrTIMER",			&IntrTIMER,			IntrTIMER );
	Ini->GetTruth( "INTR", "IntrCMT_R",			&IntrCMT_R,			IntrCMT_R );
	Ini->GetTruth( "INTR", "IntrCMT_E",			&IntrCMT_E,			IntrCMT_E );
	Ini->GetTruth( "INTR", "IntrJOY",			&IntrJOY,			IntrJOY );
	Ini->GetInt(   "INTR", "TimerAddr",			&st,				TimerAddr );	TimerAddr = st;
	Ini->GetTruth( "INTR", "IntrReserved",		&IntrReserved,		IntrReserved );
	Ini->GetInt(   "INTR", "IntrPortA",			&st,				IntrPortA );	IntrPortA = st;
	Ini->GetInt(   "INTR", "ResCmt",			&st,				ResCmt );		ResCmt = st;
	
	return TRUE;
}

BOOL INT62::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetTruth( "INTR", "TimerIntrEnable2",	&TimerIntrEnable2,	TimerIntrEnable2 );
	Ini->GetInt(   "INTR", "Int1Addr",			&st,				Int1Addr );		Int1Addr = st;
	Ini->GetInt(   "INTR", "Int2Addr",			&st,				Int2Addr );		Int2Addr = st;
	
	return INT6::DokoLoad( Ini );
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor INT60::descriptor = {
	INT60::indef, INT60::outdef
};

const Device::OutFuncPtr INT60::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &INT60::OutB0H )
};

const Device::InFuncPtr INT60::indef[] = {
};


const Device::Descriptor INT62::descriptor = {
	INT62::indef, INT62::outdef
};

const Device::OutFuncPtr INT62::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutB0H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF3H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF4H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF5H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF6H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF7H )
};

const Device::InFuncPtr INT62::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &INT62::InF7H )
};
