#ifndef INTR_H_INCLUDED
#define INTR_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"

#include "p6device.h"

////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class INT6 : public P6DEVENT, public IDoko {
protected:
	BOOL TimerIntrEnable;	// ޳ߵĥե饰
	
	// Ƽȯե饰
	BOOL IntrKEY1;
	BOOL IntrKEY2;
	BOOL IntrKEY3;
	BOOL IntrTIMER;
	BOOL IntrCMT_R;
	BOOL IntrCMT_E;
	BOOL IntrJOY;
	
	BYTE TimerAddr;			// ޳ߥɥ쥹
	BOOL IntrReserved;		// ͽե饰
	BYTE IntrPortA;			// PortA˽
	
	// PortA ͽ
//	BYTE ResKey;
//	BYTE ResJoy;
	BYTE ResCmt;
	
	BOOL SetIntrReserved( BYTE );			// ͽ
	virtual BOOL IsTimerIntrEnable() = 0;	// ޳ߵĥå
	void SetTimerIntrHz( BYTE );			// ޳߼ȿѹ
	
public:
	INT6( VM6 * );							// 󥹥ȥ饯
	virtual ~INT6();						// ǥȥ饯
	
	void EventCallback( int, int );			// ٥ȥХåؿ
	
	BOOL Init();							// 
	virtual void Reset() = 0;				// ꥻå
	
	int	IntrCheck();						// ߥå
	
	void SetTimerIntr();					// ޳ȯ
	void SetCmtIntr( BYTE );				// CMTȯ
	void SetKeyIntr( int, BYTE );			// ȯ
	void SetJoyIntr( BYTE );				// ѥȯ
	
	BYTE GetIntrReserved( BYTE );			// ͽPortAåͼ
	
	BOOL IsCmtIntrReady(){ return !(IntrReserved || IntrCMT_R);  }	// CMTȯ?
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	Uint32 TimerCount;						// 1ô֤Υ޳߲
	Uint32 CmtCount;						// 1ô֤CMT߲
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class INT60 : public INT6, public Device {
private:
	BOOL IsTimerIntrEnable(){ return TimerIntrEnable; }	// ޳ߵĥå
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int , BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutB0H] %02X\n", data );
										     TimerIntrEnable = (data&1 ? FALSE : TRUE); }
	
public:
	INT60( VM6 *, const ID& );		// 󥹥ȥ饯
	~INT60();						// ǥȥ饯
	
	void Reset();					// ꥻå
	
	// ǥХID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
};


class INT62 : public INT6, public Device {
private:
	BOOL TimerIntrEnable2;	// ޳ߵĥե饰(PortF3H mk2ʹ)
	BYTE Int1Addr;			// INT1ߥɥ쥹
	BYTE Int2Addr;			// INT2ߥɥ쥹
	
	BOOL IsTimerIntrEnable(){ return TimerIntrEnable && TimerIntrEnable2; }	// ޳ߵĥå
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutB0H] %02X\n", data );
										  TimerIntrEnable  = (data&1 ? FALSE : TRUE); }
	inline void OutF3H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF3H] %02X\n", data );
										  TimerIntrEnable2 = (data&4 ? FALSE : TRUE); }
	inline void OutF4H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF4H] %02X\n", data>>1 );
										  Int1Addr = data>>1; }
	inline void OutF5H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF5H] %02X\n", data>>1 );
										  Int2Addr = data>>1; }
	inline void OutF6H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF6H] %02X\n", data );
										  SetTimerIntrHz( data ); }
	inline void OutF7H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF7H] %02X\n", data>>1 );
										  TimerAddr = data>>1; }
	inline BYTE InF7H( int ){ PRINTD1( INTR_LOG, "[INTR][InF7H] %02X\n", TimerAddr );
							  return TimerAddr; }
	
public:
	INT62( VM6 *, const ID& );		// 󥹥ȥ饯
	~INT62();						// ǥȥ饯
	
	void Reset();					// ꥻå
	
	// ǥХID
	enum IDOut{ outB0H=0, outF3H, outF4H, outF5H, outF6H, outF7H };
	enum IDIn {  inF7H=0 };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};

#endif	// INTR_H_INCLUDED
