#include <new>

#include "io.h"
#include "error.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
IO6::IO6( void )
{
	io = NULL;
	dl = NULL;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
IO6::~IO6( void )
{
	if( dl ) delete dl;
	if( io ) delete io;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL IO6::Init( void )
{
	// ֥ȳ
	try{
		dl = new DeviceList;	// ǥХꥹ
		io = new IOBus;			// I/O
		
		if( !io->Init( dl ) ) throw Error::InitFailed;
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		if( dl ){ delete dl; dl = NULL; }
		return FALSE;
	}
	// 㳰ȯ
	catch( Error::Errno i ){
		Error::SetError( i );
		return FALSE;
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ǥХ³
////////////////////////////////////////////////////////////////
BOOL IO6::Connect( IDevice* device, const IOBus::Connector* connector )
{
	return io->Connect( device, connector );
}


////////////////////////////////////////////////////////////////
// ǥХ
////////////////////////////////////////////////////////////////
BOOL IO6::Disconnect( IDevice* device )
{
	return io->Disconnect( device );
}


////////////////////////////////////////////////////////////////
// INؿ
////////////////////////////////////////////////////////////////
BYTE IO6::In( int port )
{
	PRINTD1( IO_LOG, "[IO][In] port : %02X", port );
	
	return io->In( port );
}


////////////////////////////////////////////////////////////////
// OUTؿ
////////////////////////////////////////////////////////////////
void IO6::Out( int port, BYTE data )
{
	PRINTD2( IO_LOG, "[IO][Out] port : %02X  data : %02X", port, data );
	
	io->Out( port, data );
}
