#ifndef P6T2_H_INCLUDED
#define P6T2_H_INCLUDED

#include "pc6001v.h"
#include "ini.h"


// P6T ֥å
typedef struct{
	int STime;				// ̵λ(ms)
	int PTime;				// ԡλ(ms)
	int Offset;				// ٥᡼ƬΥեå
	int DNum;				// ǡ
} P6TBLKINFO;


// DATA֥å饹
class cP6DATA {
private:
	P6TBLKINFO Info;					// P6T ֥å
	BYTE *Data;							// ǡؤΥݥ
	
	cP6DATA *next;						// DATA֥åؤΥݥ
	cP6DATA *before;					// DATA֥åؤΥݥ
	
	cP6DATA *TopBlock();				// Ƭ֥åؤΥݥ󥿤֤
	cP6DATA *LastBlock();				// ֥åؤΥݥ󥿤֤
	
public:
	cP6DATA();							// 󥹥ȥ饯
	~cP6DATA();							// ǥȥ饯
	
	cP6DATA *Next()  { return next; }	// Υ֥åؤΥݥ󥿤֤
	cP6DATA *Before(){ return before; }	// Υ֥åؤΥݥ󥿤֤
	
	int SetData( FILE *, int );			// ǡå
	void SetPeriod( int, int );			// ̵,ԡ֥å
	
	void GetInfo( P6TBLKINFO * );		// P6T ֥å
	int GetSize(){ return Info.DNum; }	// DATA֥å
	
	BYTE Read( int );					// 1Byteɹ
	
	cP6DATA *New();						// DATA֥åɲ
	cP6DATA *Clone();					// ԡ
	cP6DATA *Clones();					// ԡ
	
	int Writefd( FILE * );				// ե˽(ǡ)
};


// PART饹
class cP6PART {
private:
	BYTE ID;								// IDֹ
	char Name[17];							// ǡ̾(16ʸ+'00H')
	WORD Baud;								// ܡ졼(600/1200)
	cP6DATA *Data;							// ƬDATA֥åؤΥݥ
	
	cP6PART *next;							// PARTؤΥݥ
	cP6PART *before;						// PARTؤΥݥ
	
	cP6PART *TopPart();						// ƬPARTؤΥݥ󥿤֤
	cP6PART *LastPart();					// PARTؤΥݥ󥿤֤
	
	BYTE Renumber();						// IDֹʥС
	
public:
	cP6PART();								// 󥹥ȥ饯
	~cP6PART();								// ǥȥ饯
	
	cP6PART *Next()  { return next; }		// PARTؤΥݥ󥿤֤
	cP6PART *Before(){ return before; }		// PARTؤΥݥ󥿤֤
	cP6PART *Part( int );					// ǤդPARTؤΥݥ󥿤֤
	
	cP6PART *New();							// PARTɲ
	cP6PART *Link( cP6PART * );				// PARTϢ
	cP6PART *Clone();						// ԡ
	
	cP6DATA *FirstData(){ return Data; }	// ƬDATA֥åؤΥݥ󥿼
	BYTE GetID()   { return ID; }			// IDֹ
	char *GetName(){ return Name; }			// ǡ̾
	WORD GetBaud() { return Baud; }			// ܡ졼ȼ
	
	cP6DATA *NewBlock();					// DATA֥åɲ
	
	int GetBlocks();						// DATA֥å
	int GetSize();							// PART
	
	int SetName( char * );					// ǡ̾
	void SetBaud( int baud ){ Baud = baud; }	// ܡ졼
	
	BOOL Readf( FILE * );					// ե뤫PARTɹ
	int Writefd( FILE * );					// ե˽(ǡ)
	BOOL Writeff( FILE * );					// ե˽(եå)
};


// P6T饹
class cP6T : public IDoko {
private:
	char Name[17];							// ǡ̾(16ʸ+'00H')
	BYTE Version;							// С
	
	BOOL Start;								// ȥȥե饰
	BYTE BASIC;								// BASIC⡼(PC-6001ξ̵̣)
	BYTE Page;								// ڡ
	WORD ASKey;								// ȥȥޥɥ
	WORD EHead;								// ĥ󥵥(64KBޤ)
	
	char *ask;								// ȥȥޥɳǼΰؤΥݥ
	char *exh;								// ĥǼΰؤΥݥ
	
	cP6PART *Part;							// ƬPARTؤΥݥ
	
	// ɹߴط
	cP6PART *rpart;							// ߤɹPART
	cP6DATA *rdata;							// ߤɹDATA֥å
	int rpt;								// ߤɹߥݥ(DATA֥å)
	int swait;								// ̵Ԥ
	int pwait;								// ԡԤ
	
	BOOL ReadP6T( char *filename );			// P6Tɹ
	BOOL ConvP6T( char *filename );			// ٥P6TѴɹ
	
public:
	cP6T();									// 󥹥ȥ饯
	virtual ~cP6T();						// ǥȥ饯
	
	int GetBlocks();						// DATA֥å
	int GetParts();							// PART
	
	cP6PART *GetPart( int num ){ return Part->Part(num); }	// ǤPARTؤΥݥ󥿼
	
	int SetName( char * );					// ǡ̾
	char *GetName(){ return Name; }			//         
	BOOL GetStart(){ return Start; }		// ȥȥե饰
	BYTE GetBASIC(){ return BASIC; }		// BASIC⡼ɼ
	BYTE GetPage() { return Page; }			// ڡ
	
	int GetSize();							// ٥᡼
	
	char *GetAutoStartStr(){ return ask; }	// ȥʸ
	WORD GetAutoStartLen(){ return ASKey; }	// ȥʸ
	
	BYTE ReadOne();							// 1ʸɹ
	
	BOOL IsSWaiting();						// ̵Ԥ?
	BOOL IsPWaiting();						// ԡԤ?
	
	BOOL Readf( char * );					// ե뤫ɹ
	BOOL Writef( char * );					// ե˽
	
	int GetCount();							// TAPE󥿼
	void SetCount( int );					//             
	
	void Reset();							// ꥻå(ɹߴط)
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};



#endif	// P6T2_H_INCLUDED
