#include "pc6001v.h"
#include "console.h"
#include "osd.h"
#include "pc60.h"

#include "icons.h"

#include "error.h"





///////////////////////////////////////////////////////////
// ᥤ
///////////////////////////////////////////////////////////
int main( int argc, char *argv[] )
{
	VM6 *P6Core = NULL;		// ֥ȥݥ
	
	BOOL Restart;			// Ƶưե饰
	
	// ŵưػ
	if( OSD_IsWorking() ) return FALSE;
	
	// SDL
	if( SDL_Init( SDL_INIT_TIMER | SDL_INIT_AUDIO | SDL_INIT_VIDEO | SDL_INIT_JOYSTICK ) < 0 ){
		Error::SetError( Error::SDLInitFailed );
		OSD_Message( (char *)Error::GetErrorText(), MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		return FALSE;
	}
	
	// P6֥Ȥ
	do{
		Restart = FALSE;
		
		// INIեɹ
		if( !cGlobal::Init() ){
			Error::SetError( Error::IniDefault );
			OSD_Message( (char *)Error::GetErrorText(), MSGE_ERROR, OSDR_OK | OSDM_ICONWARNING );
			Error::SetError( Error::NoError );
		}
		
		// 󥽡ѥեɹ
		if( !cBDF::OpenFont( cGlobal::GetFontFileZ(), cGlobal::GetFontFileH() ) ){
			Error::SetError( Error::FontFailed );
			OSD_Message( (char *)Error::GetErrorText(), MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			return FALSE;
		}
		
		Uint8 *ipix;
		SDL_Palette *ipal;
		
		// ROMե¸ߥå&ѹ
		char RomSerch[PATH_MAX];
		int IniModel = cGlobal::GetModel();
		sprintf( RomSerch, "%s*.%2d", cGlobal::GetRomPath(), IniModel );
		if( !OSD_FileExist( RomSerch ) ){
			int models[] = { 60, 62, 66 };
			for( int i=0; i < (int)(sizeof(models)/sizeof(int)); i++ ){
				sprintf( RomSerch, "%s*.%2d", cGlobal::GetRomPath(), models[i] );
				if( OSD_FileExist( RomSerch ) ){
					cGlobal::SetModel( models[i] );
					break;
				}
			}
			// ROM?
			if( IniModel != cGlobal::GetModel() ){
				Error::SetError( Error::RomChange );
				OSD_Message( (char *)Error::GetErrorText(), MSGE_ERROR, OSDR_OK | OSDM_ICONWARNING );
				Error::SetError( Error::NoError );
			}
		}
		
		switch( cGlobal::GetModel() ){
		case 62:
			P6Core = new VM62;
			ipix = p62pix;
			ipal = &p62pal;
			break;
			
		case 66:
			P6Core = new VM66;
			ipix = p66pix;
			ipal = &p66pal;
			break;
			
		default:
			P6Core = new VM60;
			ipix = p60pix;
			ipal = &p60pal;
		}
		
		// 
		SDL_Surface *p6icon = SDL_CreateRGBSurfaceFrom( ipix, 32, 32, 8, 32, 0, 0, 0, 0 );
		SDL_SetPalette( p6icon, SDL_LOGPAL, ipal->colors, 0, ipal->ncolors );
		SDL_SetColorKey( p6icon, SDL_SRCCOLORKEY, 0 );
		SDL_WM_SetIcon( p6icon, NULL );
		SDL_FreeSurface( p6icon );
		
		// VMƼ¹
		if( P6Core->Init() ){
			P6Core->Start();
			Restart = P6Core->EventLoop();
			P6Core->Stop();
		}else{
			// Ԥ
			OSD_Message( (char *)Error::GetErrorText(), MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
		}
		
		// P6֥Ȥ
		if( P6Core ) delete P6Core;
		
		// 󥽡ѥե˴
		cBDF::CloseFont();
		
		cGlobal::UnInit();
		
	}while( Restart );
	
	// SDLåȥ
	SDL_Quit();
	
	// λ
	OSD_Finish();
	
	return TRUE;
}
