#include "pd8049.h"
#include "intr.h"
#include "keyboard.h"
#include "tape.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
SUB6::SUB6( VM6 *vm ) : P6DEVICE(vm)
{
	Reset();
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
SUB6::~SUB6( void ){}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL SUB6::Init( void )
{
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void SUB6::Reset( void )
{
	Status    = PD8049_IDLE;
	CmtStatus = CMTCLOSE;
}


////////////////////////////////////////////////////////////////
// ơ
////////////////////////////////////////////////////////////////
int SUB6::GetStatus( void )
{
	return Status & 0xf8;
}


////////////////////////////////////////////////////////////////
// ϥɥ(Out93H)
////////////////////////////////////////////////////////////////
void SUB6::HandShake( BYTE data )
{
	// bitб
	switch( (data>>1)&0x07 ){
	case 4: // bit4: 8049
		if( data&1 ){	// λ(?)
			Status &= ~PD8049_BIT3;					// bit3 ꥻå
		}else{			// Ŀ
			Status |= PD8049_BIT3 | PD8049_BIT7;	// bit3,7 å(*** 8049α? ***)
		}
		break;
	
	case 6: // bit6: 8049
		if( data&1 ){	// λ(?)
			Status &= ~(PD8049_BIT3 | PD8049_BIT5);	// bit3,5 ꥻå
		}else{			// Ŀ
			Status |= PD8049_BIT3 | PD8049_BIT5;	// bit3,5 å(*** 8049α? ***)
		}
		break;
	}
}


////////////////////////////////////////////////////////////////
// ޥɽ
////////////////////////////////////////////////////////////////
void SUB6::Command( BYTE comm )
{
	static BOOL CmtPut = FALSE;
	
	// CMT 1ʸ
	if( CmtPut ){
		vm->cmts->CmtWrite( comm );
		CmtPut = FALSE;
		return;
	}
	
	// ޥ
	switch( comm ){
	case 0x0c:	// ------ RS-232C ----------
	case 0x2c:
		break;
		
	case 0x06:	// ------ STICK,STRIG ----------
		// ѥȯ
		vm->intr->SetJoyIntr( vm->key->GetKeyJoy() );
		break;
		
	case 0x19:	// ------ CMT(LOAD) OPEN ----------
		CmtStatus = LOADOPEN;
		break;
		
	case 0x1a:	// ------ CMT(LOAD) CLOSE ----------
		CmtStatus = CMTCLOSE;
		break;
		
	case 0x1d:	// ------ CMT(LOAD) 600ܡ ----------
//		vm->cmt->SetBaud( 600 );
		break;
		
	case 0x1e:	// ------ CMT(LOAD) 1200ܡ ----------
//		vm->cmt->SetBaud( 1200 );
		break;
		
	case 0x38:	// ------ CMT 1ʸ ----------
		CmtPut = TRUE;
		break;
		
	case 0x39:	// ------ CMT(SAVE) OPEN ----------
		CmtStatus = SAVEOPEN;
		break;
		
	case 0x3a:	// ------ CMT(SAVE) CLOSE ----------
		CmtStatus = CMTCLOSE;
		vm->cmts->Unmount();
		break;
		
	case 0x3d:	// ------ CMT(SAVE) 600ܡ ----------
		vm->cmts->SetBaud( 600 );
		break;
		
	case 0x3e:	// ------ CMT(SAVE) 1200ܡ ----------
		vm->cmts->SetBaud( 1200 );
		break;
	}
}


////////////////////////////////////////////////////////////////
// ׵
////////////////////////////////////////////////////////////////
void SUB6::ReqKeyIntr( int flag, BYTE data )
{
	// flag
	// bit 0 : ON_STOP
	// bit 1 : ON_GRAPH
	// bit 2 : ON_FUNC
	
	if( flag&1 ){	// STOP ?
		// CMT OPEN ?
		if( CmtStatus ) vm->intr->SetKeyIntr( 1, 0x03 );
		else            vm->intr->SetKeyIntr( 2, 0xfa );
	}else{			// STOPʳ
		// GRAPH or FUNCTION KEY ?
		if( flag&6 )    vm->intr->SetKeyIntr( 2, data );
		else            vm->intr->SetKeyIntr( 3, data );
	}
}


////////////////////////////////////////////////////////////////
// CMT(LOAD)׵
////////////////////////////////////////////////////////////////
void SUB6::ReqCmtIntr( BYTE data )
{
	PRINTD( SUB_LOG, "[8049][ReqCmtIntr]\n" );
	
	// LOADOPENʤCMTȯ
	if( CmtStatus == LOADOPEN ) vm->intr->SetCmtIntr( data );
}


////////////////////////////////////////////////////////////////
// CMTơ
////////////////////////////////////////////////////////////////
int SUB6::GetCmtStatus( void )
{
	return CmtStatus;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL SUB6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "8049", NULL, "CmtStatus",	"%d",		CmtStatus );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL SUB6::DokoLoad( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->GetInt(   "8049", "CmtStatus",		&CmtStatus,	CmtStatus );
	
	return TRUE;
}
