#include "pd8255.h"
#include "graph.h"
#include "intr.h"
#include "memory.h"
#include "pd8049.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
D8255::D8255( void )
{
	Reset();
}

PIO6::PIO6( VM6 *vm, const ID& id ) : P6DEVICE(vm), Device(id){}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
D8255::~D8255(){}
PIO6::~PIO6(){}


////////////////////////////////////////////////////////////////
// ꥻå
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::Reset( void )
{
	// н
	PortA    = PortB    = PortC     = 0xff;
	ModeA    = ModeB    = 0;
	PortAdir = PortBdir = PortC1dir = PortC2dir = TRUE;
}


////////////////////////////////////////////////////////////////
// ⡼
//
// :	data	ǡž
//				bit6,5: 롼AΥ⡼	1x:⡼2 01:⡼1 00:⡼0
//				bit4:   PortA				1:(ɤ) 0:()
//				bit3:   PortC(bit4-7)		1:(ɤ) 0:()
//				bit2:   롼BΥ⡼	1:⡼1 0:⡼0
//				bit1:   PortB				1:(ɤ) 0:()
//				bit0:   PortC(bit0-3)		1:(ɤ) 0:()
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::SetMode( BYTE data )
{
	ModeA     = (data>>6)&1 ? 2    : (data>>5)&1;
	ModeB     = (data>>2)&1;
	PortAdir  = (data>>4)&1 ? TRUE : FALSE;
	PortC2dir = (data>>3)&1 ? TRUE : FALSE;
	PortBdir  = (data>>1)&1 ? TRUE : FALSE;
	PortC1dir = (data   )&1 ? TRUE : FALSE;
}


////////////////////////////////////////////////////////////////
// 
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL PIO6::Init( void )
{
	D8255::Reset();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// PartA 饤
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteA( BYTE data )
{
	if( !PortAdir ) PortA = data;
}

void PIO6::WriteA( BYTE data )
{
	if( !PortAdir ){
		PortA = data;
		vm->subcpu->Command( data );
	}
}


////////////////////////////////////////////////////////////////
// PartB
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteB( BYTE data )
{
	if( !PortBdir ) PortB = data;
}


////////////////////////////////////////////////////////////////
// PartC 饤
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteC( BYTE data )
{
	if( !PortC1dir ) PortC = ( PortC & 0xf0 ) | ( data & 0x0f );
	if( !PortC2dir ) PortC = ( PortC & 0x0f ) | ( data & 0xf0 );
}

void PIO6::WriteC( BYTE data )
{
	if( !PortC1dir ){
		 PortC = ( PortC & 0xf0 ) | ( data & 0x0f );
		// bit0: ץ󥿥ȥ
		
		// bit1: CRTɽ
		vm->graph->SetCrtDisp( PortC&2 ? TRUE : FALSE );
		
		// bit2: CG ROM BANK 
		vm->mem->SetCGBank( PortC&4 ? FALSE : TRUE );
	}
	if( !PortC2dir ) PortC = ( PortC & 0x0f ) | ( data & 0xf0 );
}


////////////////////////////////////////////////////////////////
// PartD 饤(ȥݡ)
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteD( BYTE data )
{
	if( data&0x80 ){	// Ǿ̥ӥåȤ1ʤ
		// ⡼
		SetMode( data );
	}else{				// Ǿ̥ӥåȤ0ʤ
		// ӥåȥå/ꥻå(λ⡼ɤͭ?Ȥꤢ̵)
		if( data&1 ) PortC |= 1<<((data>>1)&0x07);
		else         PortC &= ~(1<<((data>>1)&0x07));
	}
}

void PIO6::WriteD( BYTE data )
{
	if( data&0x80 ){	// Ǿ̥ӥåȤ1ʤ
		// ⡼
		D8255::SetMode( data );
	}else{				// Ǿ̥ӥåȤ0ʤ
		// ӥåȥå/ꥻå(λ⡼ɤͭ?Ȥꤢ̵)
		if( data&1 ) PortC |= 1<<((data>>1)&0x07);
		else         PortC &= ~(1<<((data>>1)&0x07));
		
		// bitб
		switch( (data>>1)&0x07 ){
		case 0: // ץ󥿥ȥ
			break;
			
		case 1: // CRTɽ
			vm->graph->SetCrtDisp( data&1 ? TRUE : FALSE );
			break;
			
		case 2: // CG ROM BANK 
			vm->mem->SetCGBank( data&1 ? FALSE : TRUE );
			break;
			
		case 3: // 8049
		case 4: // 8049
		case 5: // 8049
		case 6: // 8049
		case 7: // 8049
			vm->subcpu->HandShake( data );
			break;
		}
	}
}


////////////////////////////////////////////////////////////////
// PartA ꡼
//
// :	ʤ
// :	BYTE	PortA
////////////////////////////////////////////////////////////////
BYTE D8255::ReadA( void )
{
	return PortA;
}

BYTE PIO6::ReadA( void )
{
	// ߤˤߤȯƤͤ򥻥å
	PortA = vm->intr->GetIntrReserved( PortA );
	
	PRINTD1( PPI_LOG, "[8255][Read][PortA] %02X\n", PortA );
	
	return PortA;
}


////////////////////////////////////////////////////////////////
// PartB ꡼
//
// :	ʤ
// :	BYTE	PortB
////////////////////////////////////////////////////////////////
BYTE D8255::ReadB( void )
{
	return PortB;
}


////////////////////////////////////////////////////////////////
// PartC ꡼
//
// :	ʤ
// :	BYTE	PortC
////////////////////////////////////////////////////////////////
BYTE D8255::ReadC( void )
{
	return PortC;
}

BYTE PIO6::ReadC( void )
{
	// 8049Υơ
	PortC = ( PortC & 0x07 ) | ( vm->subcpu->GetStatus() & 0xf8 );
	
	PRINTD1( PPI_LOG, "[8255][Read][PortC] %02X\n", PortC );
	
	return PortC;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL PIO6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "8255", NULL, "PortA",		"0x%02X",	PortA );
	Ini->PutEntry( "8255", NULL, "PortB",		"0x%02X",	PortB );
	Ini->PutEntry( "8255", NULL, "PortC",		"0x%02X",	PortC );
	Ini->PutEntry( "8255", NULL, "PortAdir",	"%s",		PortAdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortBdir",	"%s",		PortBdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC1dir",	"%s",		PortC1dir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC2dir",	"%s",		PortC2dir ? "Yes" : "No" );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL PIO6::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetInt(   "8255", "PortA",		&st,		PortA );	PortA = st;
	Ini->GetInt(   "8255", "PortB",		&st,		PortB );	PortB = st;
	Ini->GetInt(   "8255", "PortC",		&st,		PortC );	PortC = st;
	Ini->GetTruth( "8255", "PortAdir",	&PortAdir,	PortAdir );
	Ini->GetTruth( "8255", "PortBdir",	&PortBdir,	PortBdir );
	Ini->GetTruth( "8255", "PortC1dir",	&PortC1dir,	PortC1dir );
	Ini->GetTruth( "8255", "PortC2dir",	&PortC2dir,	PortC2dir );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor PIO6::descriptor = {
	PIO6::indef, PIO6::outdef
};

const Device::OutFuncPtr PIO6::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out90H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out91H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out92H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out93H )
};

const Device::InFuncPtr PIO6::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &PIO6::In90H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::In92H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::In93H )
};
