#ifndef PD8255_H_INCLUDED
#define PD8255_H_INCLUDED

#include "pc6001v.h"
#include "device.h"

#include "p6device.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class D8255 {
protected:
	BYTE PortA;						// ݡA
	BYTE PortB;						// ݡB
	BYTE PortC;						// ݡC
	
	int ModeA;						// 롼A⡼
	int ModeB;						// 롼B⡼
	
	BOOL PortAdir;					// ݡA          TRUE:(ɤ) FALSE:()
	BOOL PortBdir;					// ݡB          TRUE:(ɤ) FALSE:()
	BOOL PortC1dir;					// ݡC(bit0-3)  TRUE:(ɤ) FALSE:()
	BOOL PortC2dir;					// ݡC(bit4-7)  TRUE:(ɤ) FALSE:()
	
	// ϴؿ
	virtual void WriteA( BYTE );
	virtual void WriteB( BYTE );
	virtual void WriteC( BYTE );
	virtual void WriteD( BYTE );	// ȥݡȽ
	virtual BYTE ReadA();
	virtual BYTE ReadB();
	virtual BYTE ReadC();
	
	void SetMode( BYTE );			// ⡼
	
public:
	D8255();						// 󥹥ȥ饯
	virtual ~D8255();				// ǥȥ饯
	
	void Reset();					// ꥻå
};


class PIO6 : public P6DEVICE, public Device, public D8255, public IDoko {
private:
	// ϴؿ
	void WriteA( BYTE );
	void WriteC( BYTE );
	void WriteD( BYTE );	// ȥݡȽ
	BYTE ReadA();
	BYTE ReadC();
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void Out90H( int, BYTE data ){ WriteA( data ); };
	inline void Out91H( int, BYTE data ){ WriteB( data ); };
	inline void Out92H( int, BYTE data ){ WriteC( data ); };
	inline void Out93H( int, BYTE data ){ WriteD( data ); };
	inline BYTE In90H( int ){ return ReadA(); };
	inline BYTE In92H( int ){ return ReadC(); };
	inline BYTE In93H( int ){ return 0xff; };
	
public:
	PIO6( VM6 *, const ID& );		// 󥹥ȥ饯
	~PIO6();						// ǥȥ饯
	
	BOOL Init( void );				// 
	
	// ǥХID
	enum IDOut{ out90H=0, out91H, out92H, out93H };
	enum IDIn {  in90H=0,  in92H,  in93H };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};

#endif	// PD8255_H_INCLUDED
