#include "schedule.h"
#include "graph.h"

// ٥ID
#define	EID_WAIT	(1)
#define	EID_VSYNC	(2)


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cSche::cSche( void )
{
	for( int i=0; i<MAXEVENT; i++ ){
		ev[i].device = NULL;
		ev[i].Active = FALSE;
		ev[i].ncount = 0;
		ev[i].ratio  = 0;
	}
	MasterClock = CPU_CLOCK;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cSche::~cSche( void ){}


////////////////////////////////////////////////////////////////
// ٥ȸ
//
// :	dev			٥ȥǥХ֥ȥݥ
//			id			٥ID
// :	evinfo *	٥Ⱦݥ(¸ߤʤNULL)
////////////////////////////////////////////////////////////////
cSche::evinfo *cSche::Find( P6DEVENT *dev, int id )
{
	for( int i=0; i<MAXEVENT; i++ )
		if( ev[i].device == dev && ev[i].id == id ) return &ev[i];
	
	return NULL;
}


////////////////////////////////////////////////////////////////
// ޥå
//
// :	clock	ޥå
// :	ʤ
////////////////////////////////////////////////////////////////
void cSche::SetMasterClock( int clock )
{
	MasterClock = clock;
	for( int i=0; i<MAXEVENT; i++ )
		if( ev[i].device && ev[i].nps > 0 )
			ev[i].Period = (int)((double)clock / ev[i].nps);
}


////////////////////////////////////////////////////////////////
// ٥ɲ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
//			hz		٥ȯȿ
//			loop	롼׻ TRUE:롼 FALSE:󥿥
//			flag	٥ȥ
//				bit0  : ֤ؼ 0:󥿥 1:롼
//				bit2,3: ñ 00:Hz 01:ms 10:CPUơȿ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL cSche::Add( P6DEVENT *dev, int id, double hz, int flag )
{
	// ϿѤߤξϰöƺϿ
	evinfo *e = Find( dev, id );
	if( e ) Del( e->device, e->id );
	
	for( int i=0; i<MAXEVENT; i++ ){
		if( !ev[i].device ){
			ev[i].device = dev;
			ev[i].id     = id;
			ev[i].Active = TRUE;
			
			// ٥ȯȿ
			switch( flag&(EV_MS|EV_STATE) ){
			case EV_MS:		// msǻؼ
				ev[i].nps    = (double)1000 / hz;
				ev[i].Clock  = (int)((double)MasterClock / ev[i].nps);
				break;
			case EV_STATE:	// CPUơȿǻؼ
				ev[i].nps    = (double)MasterClock / hz;
				ev[i].Clock  = (int)hz;
				break;
			default:		// Hzǻؼ
				ev[i].nps    = hz;
				ev[i].Clock  = (int)((double)MasterClock / hz);
			}
			
			// 
			if( flag&EV_LOOP ){	// 롼ץ٥
				ev[i].Period = ev[i].Clock;
				if( ev[i].Period < 1 ) ev[i].Period = 1;
			}else				// 󥿥।٥
				ev[i].Period = 0;
			return TRUE;
		}
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ٥Ⱥ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL cSche::Del( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ){
		e->device = NULL;
		e->Active = FALSE;
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// ٥ȯȿ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
//			hz		٥ȯȿ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL cSche::SetHz( P6DEVENT *dev, int id, double hz )
{
	evinfo *e = Find( dev, id );
	if( e ){
		e->nps    = hz;
		e->Period = (int)((double)MasterClock / hz);
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// ٥ȹ
//
// :	clk		ʤ륯å
// :	ʤ
////////////////////////////////////////////////////////////////
void cSche::Update( int clk )
{
	for( int i=0; i<MAXEVENT; i++ ){
		// ͭʥ٥?
		if( ev[i].Active ){
			ev[i].Clock -= clk;
			// ֳ֤Ĺʣȯǽ
			// Ȥꤢƥס뤹äƤȤǤΤ?
			while( ev[i].Clock <= 0 ){
				// ٥ȥХå¹
				ev[i].device->EventCallback( ev[i].id, ev[i].Clock );
				
				if( ev[i].Period > 0 ){	// 롼ץ٥
					ev[i].Clock += ev[i].Period;
					ev[i].ncount++;	// 䤹
				}else{					// 󥿥।٥
					Del( ev[i].device, ev[i].id );
					break;
				}
			}
		}
	}
}


////////////////////////////////////////////////////////////////
// ꥤ٥ȤꥻåȤ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
// :	ʤ
////////////////////////////////////////////////////////////////
void cSche::Reset( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ) e->Clock = e->Period;
}


////////////////////////////////////////////////////////////////
// ٥ȯޤǤλĤꥯå
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
// :	int		Ĥꥹơȿ(ID̵ʤ0)
////////////////////////////////////////////////////////////////
int cSche::Rest( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ) return e->Clock;
	else    return 0;
}


////////////////////////////////////////////////////////////////
// ٥ȤοʹΨ
//   ɴʬΨ10ܤ֤(100%1000)
//   0ʲ,100ʾˤʤ0-100˴ݤ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
// :	int		٥ȿʹΨ(%) * 10
////////////////////////////////////////////////////////////////
int cSche::Scale( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	// ٥Ȥ¸ߤ1ΥåꤵƤ?
	if( e && e->Period > 0 ){
		int sc = (int)( (DWORD)( e->Period - e->Clock ) * 1000 / (DWORD)e->Period );
		return min( max( 0, sc ), 1000 );
	}else
		return 0;
}








////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
SCH6::SCH6( VM6 *vm ) : P6DEVENT(vm)
{
	CpuClock   = CPU_CLOCK;
	WaitEnable = TRUE;
	VSYNC      = FALSE;
	
	// ޥե
	WaitSem = SDL_CreateSemaphore( 0 );
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
SCH6::~SCH6( void )
{
	// ư
	Stop();
	
	// ޥե
	if( WaitSem ) SDL_DestroySemaphore( WaitSem );

}


////////////////////////////////////////////////////////////////
// ٥ȥХåؿ
//
// :	id		٥ID
//			clock	å
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::EventCallback( int id, int clock )
{
	switch( id ){
	case EID_WAIT:
		VWait();
		break;
	case EID_VSYNC:
		VSYNC = TRUE;
		break;
	}
}


////////////////////////////////////////////////////////////////
// åɴؿ(С饤)
//   SDL_Delay()٤˺ΤǤäø
//   49.7ʾϢ³ưOSǤԶ礬뤱ɡǤ
//
// :	inst	ʬȤΥ֥ȥݥ
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::OnThread( void *inst )
{
	SCH6 *ti;
	int timecnt = 0; 	// ٥ȯΨ¬
	double now,last;
	
	ti = (SCH6 *)inst;	// ʬȤΥ֥ȥݥ󥿼
	
	// ǽԤ֤
	now  = (double)SDL_GetTicks();
	last = now;
	double NextWait = now + (double)1000.0/VSYNC_HZ;
	
	while( !this->SThread::IsCancel() ){
		now = (double)SDL_GetTicks();
		if( now >= NextWait ){
			NextWait += (double)1000.0/VSYNC_HZ;
			ti->WaitReset();
		}else
			SDL_Delay( 1 );
		
		timecnt += (int)(now - last);
		if( timecnt > 1000 ){
			timecnt -= 1000;
			for( int i=0; i<MAXEVENT; i++ ){
				if( ev[i].device && ev[i].Active ){
					ev[i].ratio  = (int)((double)( ev[i].ncount * 100 ) / ev[i].nps);
					ev[i].ncount = 0;
				}
			}
		}
		last = now;
	}
}


////////////////////////////////////////////////////////////////
// ư
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
BOOL SCH6::Start( void )
{
	// å
	if( !this->SThread::BeginThread( this ) ) return FALSE;
	this->SThread::Start();
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ư
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::Stop( void )
{
	this->SThread::Cancel();	// åɽλե饰ΩƤ
	this->SThread::Waiting();	// åɽλޤԤ
}


////////////////////////////////////////////////////////////////
// VSYNC Wait
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::VWait( void )
{
	if( vm->IsWaitEnable() ) SDL_SemWait( WaitSem );
}


////////////////////////////////////////////////////////////////
// Wait
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::WaitReset( void )
{
	if( !SDL_SemValue( WaitSem ) ) SDL_SemPost( WaitSem );
	VSYNC = FALSE;
}


////////////////////////////////////////////////////////////////
// 
//
// :	clock	CPUå(Hz)
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL SCH6::Init( int clock )
{
	// ޥեå
	if( !WaitSem ) return FALSE;
	
	// CPUå
	CpuClock = clock;
	
	// ٥ɲ
	if( !vm->sche->Add( this, EID_WAIT,  VSYNC_HZ, EV_LOOP|EV_HZ ) ) return FALSE;
//	if( !vm->sche->Add( this, EID_VSYNC, VSYNC_HZ, EV_LOOP|EV_HZ ) ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ̤ɽ֤˱CPUơȿ׻
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
// PC-6001mk2SRΥޥ˥奢뤫 (ʤSR? ޤ޼긵ˤ줷ʤä)
// ʿߥ (ñ:usec)
// ɽ⡼ ʿ Хåݡ ɽ եȥݡ
// 32ʸ		4.87	13.74		35.76		9.33
// 40,80ʸ	4.87	 9.27		44.69		4.86

// ľߥ (ñ:msec)
// ɽ⡼ ľ Хåݡ ɽ եȥݡ
// 192H			0.25	 2.49		12.23		1.72
// 200H			0.25	 2.23		12.74		1.47
// 204H			0.25	 2.11		12.99		1.34

// ɽȿ
// ʿ 15.70kHz(63.70usec)
// ľ 59.92 Hz(16.69msec)

// ޤȤȤʴ
// ʿȡ   456 Clk (ɥåȥå 7.16MHz? 3.58MHzξå?)
// ʿɽ       256 320 Clk
// ʿɽ     200 136 Clk
// ľȡ饤 262 Line
// ľɽ饤     192 200 204 Line
// ľɽ饤    70  62  58 Line


// [ɽ]ΤCPUߤȹͤȡƯΨϤʴ
// N60   : 58.859% ( 200*192 + 456*70 ) / ( 262*456 )
// N60m  : 46.431% ( 136*200 + 456*62 ) / ( 262*456 )
// N66SR : 45.360% ( 136*204 + 456*58 ) / ( 262*456 )

#define	Ref1	(double)( (double)( 200*192 + 456*70 ) / (double)( 262*456 ) )
#define	Ref2	(double)( (double)( 136*200 + 456*62 ) / (double)( 262*456 ) )

void SCH6::CalcCpuState( void )
{
	BOOL disp = vm->graph->GetCrtDisp();
	BOOL win  = vm->graph->GetWinSize();
	
	// 1äΥơȿ
	int CpuState;
	if( disp ) CpuState = (int)( (win ? Ref1 : Ref2) * (double)CpuClock );
	else       CpuState = CpuClock;
	
	// ޥå
	cSche::SetMasterClock( CpuState );
}


////////////////////////////////////////////////////////////////
// ¹®
//
// :	ʤ
// :	int		¹®(®100%)
////////////////////////////////////////////////////////////////
int SCH6::GetRatio( void )
{
	evinfo *e = Find( this, EID_WAIT );
//	evinfo *e = Find( this, EID_VSYNC );
	if( e ) return e->ratio;
	else    return 0;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL SCH6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL SCH6::DokoLoad( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	return TRUE;
}
