#include <stdio.h>
#include <shlobj.h>

#include "tape.h"
#include "disk.h"
#include "global.h"
#include "intr.h"
#include "keyboard.h"
#include "pd8049.h"
#include "schedule.h"


// P6TեޥåVer.2
//  Ūˤϡ֥٥᡼+եå+٥᡼(4byte)פȤ¤
//  եåˤDATA֥å󤬴ޤޤ롣
//  DATA֥å̵ڤȤ1ȿ롣
//  BASICʤɡ֥إåܥǡפȤ¤ξ硤DATA֥å2ĤȤʤ뤬
//  IDֹƱˤ뤳ȤǴϢդƴǤ롣
//
// [եå]
//  header (2byte) : "P6"
//  ver    (1byte) : С
//  dbnum  (1byte) : ޤޤDATA֥å(255Ĥޤ)
//  start  (1byte) : ȥȥե饰(0:̵ 1:ͭ)
//  basic  (1byte) : BASIC⡼(PC-6001ξ̵̣)
//  page   (1byte) : ڡ
//  askey  (2byte) : ȥȥޥʸ
//  ...ޥɤϤθaskeyʬ³
//  exhead (2byte) : ĥ󥵥(64KBޤ)
//  ...ĥ󤬤Ϥθexheadʬ³
//
// [DATA֥å]
//  header (2byte) : "TI"
//  id     (1byte) : IDֹ(DATA֥åϢդ)
//  name  (16byte) : ǡ̾(15ʸ+'00H')
//  baud   (2byte) : ܡ졼(600/1200)
//  stime  (2byte) : ̵λ(ms)
//  ptime  (2byte) : ԡλ(ms)
//  offset (4byte) : ٥᡼ƬΥեå
//  size   (4byte) : ǡ


// ٥ID
#define	EID_TAPE	(1)

// ȿ
#define PG_HI	(0)
#define PG_LO	(1)

////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
CMTL::CMTL( VM6 *vm, const ID& id ) : P6DEVENT(vm), Device(id)
{
	*FilePath = '\0';
	p6t = NULL;
	Relay = FALSE;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
CMTL::~CMTL( void )
{
	Unmount();
}


////////////////////////////////////////////////////////////////
// ٥ȥХåؿ
//
// :	id		٥ID
//			clock	å
// :	ʤ
////////////////////////////////////////////////////////////////
void CMTL::EventCallback( int id, int clock )
{
	switch( id ){
	case EID_TAPE:	// CMT߽
		// ߽Ǥʤ?
		if( vm->intr->IsCmtIntrReady() ){
			// CMTåץǡ
			WORD rd = Update();
			// ǡʤCMTȯ
			if( rd & PG_D ) vm->subcpu->ReqCmtIntr( rd & 0xff );
		}
		break;
	}
}


////////////////////////////////////////////////////////////////
// ⡼(PLAY,STOP)
////////////////////////////////////////////////////////////////
BOOL CMTL::Remote( BOOL relay )
{
    PRINTD1( TAPE_LOG, "[TAPE][Relay] -> %s\n", relay ? "TRUE" : "FALSE" );
	
	// 졼ξ֤¸
	Relay = relay;
	
	// 졼ξ֤ˤꥤ٥ɲor
	if( relay ){
		if( !vm->sche->Add( this, EID_TAPE, DEFAULT_CMT_HZ, EV_LOOP|EV_HZ ) ) return FALSE;
	}else{
		if( !vm->sche->Del( this, EID_TAPE ) ) return FALSE;
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL CMTL::Init( cRing *buf )
{
	// P6T ΰ(ꥻåȻˤ̵)
	p6t = NULL;
	
	// ȥ꡼ݥ
	SndDev::Buf = buf;
	
	// TAPE˥
	SndDev::Volume = DEFAULT_TAPEVOL;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void CMTL::Reset( void )
{
	if( !p6t ) return;
	
	// ȥͭ?
	if( p6t->GetStart() ){
		char buf[256] = "";
		
		// TAPEꥻå
		p6t->Reset();
		
		// Хåե˽
		switch( vm->cGlobal::P6Model ){
		case 60:	// PC-6001
			sprintf( buf, "%c%c", p6t->GetPage()+'0', 0x0d );
			break;
		case 62:	// PC-6001mk2
//		case 64:	// PC-6001mk2SR
			switch( p6t->GetBASIC() ){
			case 3:
			case 4:
			case 5:
				if( vm->disk->GetDrives() )	// ??? ºݤ?
					sprintf( buf, "%c%c%c%c", p6t->GetBASIC()+'0', 0x0d, p6t->GetPage()+'0', 0x0d );
				else
					sprintf( buf, "%c%c%c",   p6t->GetBASIC()+'0',       p6t->GetPage()+'0', 0x0d );
				break;
			default:
				sprintf( buf, "%c%c%c", p6t->GetBASIC()+'0', p6t->GetPage()+'0', 0x0d );
			}
			break;
		case 66:	// PC-6601
//		case 68:	// PC-6601SR
			switch( p6t->GetBASIC() ){
			case 3:
			case 4:
			case 5:
//				if( vm->disk->GetDrives() && *vm->disk->GetFile( 0 ) )
				if( vm->disk->IsMount( 0 ) )
					sprintf( buf, "%c%c%c%c", p6t->GetBASIC()+'0', 0x0d, p6t->GetPage()+'0', 0x0d );
				else
					sprintf( buf, "%c%c%c",   p6t->GetBASIC()+'0',       p6t->GetPage()+'0', 0x0d );
				break;
			default:
				sprintf( buf, "%c%c%c", p6t->GetBASIC()+'0', p6t->GetPage()+'0', 0x0d );
			}
		}
		memcpy( &buf[strlen(buf)], p6t->GetAutoStartStr(), p6t->GetAutoStartLen() );
		
		// ư
		if( vm->key->SetAutoKey( buf, strlen(buf) ) );
	}
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
BOOL CMTL::Mount( char *filename )
{
	PRINTD1( TAPE_LOG, "[TAPE][Mount] %s\n", filename  );
	
	// ⤷ޥȺѤߤǤХޥȤ
	if( p6t ) Unmount();
	
	// P6T
	p6t = new cP6T;
	if( !p6t ) return FALSE;
	
	// ե뤫ɹ
	if( !p6t->Readf( filename ) ){
		delete p6t;
		p6t = NULL;
		return FALSE;
	}
	
	// եѥ¸
	strncpy( FilePath, filename, PATH_MAX );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
void CMTL::Unmount( void )
{
	PRINTD( TAPE_LOG, "[TAPE][Unmount]\n" );
	
	if( p6t ){
		delete p6t;
		p6t = NULL;
		*FilePath = '\0';
	}
}


////////////////////////////////////////////////////////////////
// CMT 1ʸɹ
// ̤͡ϥǡ(ԡ,̵,ǡ) ̤ϥǡ
// 졼ON & CMT OPEN 
////////////////////////////////////////////////////////////////
WORD CMTL::CmtRead( void )
{
	PRINTD( TAPE_LOG, "[TAPE][CmtRead] " );
	
	// TAPEޥȤƤʤ̵
	if( !p6t ) return PG_S;
	
	// ̵Ԥ?
	if( p6t->IsSWaiting() ){
		PRINTD( TAPE_LOG, "swait\n" );
		return PG_S;
	}
	
	// ԡԤ?
	if( p6t->IsPWaiting() ){
		PRINTD( TAPE_LOG, "pwait\n" );
		return PG_P;
	}
	
	// ǡɹ
	PRINTD( TAPE_LOG, "read\n" );
	return PG_D | p6t->ReadOne();
}


////////////////////////////////////////////////////////////////
// ޥȺѤ?
////////////////////////////////////////////////////////////////
BOOL CMTL::IsMount( void )
{
	if( p6t ) return TRUE;
	else      return FALSE;
}


////////////////////////////////////////////////////////////////
// ȥ?
////////////////////////////////////////////////////////////////
BOOL CMTL::IsAutoStart( void )
{
	if( p6t ) return p6t->GetStart();
	else      return FALSE;
}


////////////////////////////////////////////////////////////////
// եѥ
////////////////////////////////////////////////////////////////
char *CMTL::GetFile()
{
	return FilePath;
}


////////////////////////////////////////////////////////////////
// TAPE̾
////////////////////////////////////////////////////////////////
char *CMTL::GetName( void )
{
	if( p6t ) return p6t->GetName();
	else      return "";
}


////////////////////////////////////////////////////////////////
// ٥᡼
////////////////////////////////////////////////////////////////
DWORD CMTL::GetSize( void )
{
	if( p6t ) return p6t->GetSize();
	else      return 0;
}


////////////////////////////////////////////////////////////////
// 󥿼
////////////////////////////////////////////////////////////////
int CMTL::GetCount( void )
{
	if( p6t ) return p6t->GetCount();
	else      return 0;
}


////////////////////////////////////////////////////////////////
// 졼ξּ
////////////////////////////////////////////////////////////////
BOOL CMTL::IsRelay( void )
{
	return Relay;
}


////////////////////////////////////////////////////////////////
// ȥ꡼๹
////////////////////////////////////////////////////////////////
WORD CMTL::Update( void )
{
	PRINTD( TAPE_LOG, "[TAPE][Update]\n" );
	
	WORD rd = PG_S;
	
	// TAPE᡼ץ?
	if( p6t ){
		// 1byteʬΥǡ 10ms()
		int length = vm->snd->GetSampleRate() / DEFAULT_CMT_HZ;
		int bdata;
		
		rd = CmtRead();		// CMT 1ʸɹ
		
		switch( rd & 0xff00 ){	// ǡϡ
		case PG_P:	// ԡξ
			// ⲻ˥å
			while( length-- ) SndDev::Buf->Put( GetSinCurve( PG_HI ) );
			
			break;
		case PG_S:	// ̵ξ
			while( length-- ) SndDev::Buf->Put( 0 );
			
			break;
		case PG_D:	// ǡξ
			// ȥӥå 1bit
			// ǡӥå   8bits
			// ȥåץӥå 3bits
			
			bdata = length/12;	// 1bitΥǡ
			// ȥӥå
			for( int i=0; i<bdata; i++ ){
				SndDev::Buf->Put( GetSinCurve( PG_LO ) );
			}
			// ǡӥå
			for( int j=7; j>=0; j-- ){
				int hilo = (rd>>j)&1 ? PG_HI : PG_LO;
				for( int i=0; i<bdata; i++ ){
					SndDev::Buf->Put( GetSinCurve( hilo ) );
				}
			}
			// ȥåץӥå
			for( length -= bdata*9; length > 0; length-- ){
				SndDev::Buf->Put( GetSinCurve( PG_HI ) );
			}
			break;
		}
	}
	
	return rd;
}


////////////////////////////////////////////////////////////////
// sinȼ
////////////////////////////////////////////////////////////////
int CMTL::GetSinCurve( int fq )
{
	static const int sinc[] = {
		     0,   2856,   5690,   8481,  11207,  13848,  16384,  18794,  21062,
		 23170,  25101,  26841,  28377,  29697,  30791,  31650,  32269,  32642,
		 32767,  32642,  32269,  31650,  30791,  29697,  28377,  26841,  25101,
		 23170,  21062,  18794,  16384,  13848,  11207,   8481,   5690,   2856,
		     0,  -2856,  -5690,  -8481, -11207, -13848, -16384, -18794, -21062,
		-23170, -25101, -26841, -28377, -29697, -30791, -31650, -32269, -32642,
		-32767, -32642, -32269, -31650, -30791, -29697, -28377, -26841, -25101,
		-23170, -21062, -18794, -16384, -13848, -11207,  -8481,  -5690,  -2856
	};
	static int n=0;
	
	// ץ󥰥졼ȤȼȿǴְδֳ֤
	// ǡơ֥44100Hz,600ܡο
	// Ȥꤢ1200ܡʤΤ2
	n += (fq == PG_HI ? 2:1 ) * DEFAULT_SAMPLE_RATE / vm->snd->GetSampleRate() * 2;
	
	// ơ֥륵72(sizeof(sinc))
	if( n >= (int)(sizeof(sinc)/sizeof(int)) ) n -= (int)(sizeof(sinc)/sizeof(int));
	
	int ret = ( sinc[n] * SndDev::Volume ) / 100;
	
	// ⲻ㲻ǲ̥٥뤬㤦餷(1.32)
//	if( fq == PG_HI ) ret = (int)((double)ret/(double)1.32);
	if( fq == PG_HI ) ret -= ret / 4;	// ۤ1/1.32
	
	return ret;
}




////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
CMTS::CMTS( VM6 *vm ) : P6DEVENT(vm)
{
	fp   = NULL;
	Baud = 1200;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
CMTS::~CMTS( void )
{
	Unmount();
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL CMTS::Init( void )
{
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
BOOL CMTS::Mount( char *filename )
{
	if( fp ) fclose( fp );
	
	fp = fopen( filename, "wb" );
	
	if( fp ){
		// եѥ¸
		strncpy( FilePath, filename, PATH_MAX );
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
void CMTS::Unmount( void )
{
	if( fp ){
		// եåդ(Ȥꤢ٥)
		fflush( fp );
		int beta = ftell( fp );	// ٥᡼
		
		// [եå]
		fputc( 'P', fp );	// header (2byte) : "P6"
		fputc( '6', fp );
		fputc( 2, fp );		// ver    (1byte) : С
		fputc( 1, fp );		// dbnum  (1byte) : ޤޤDATA֥å(255Ĥޤ)
		fputc( 0, fp );		// start  (1byte) : ȥȥե饰(0:̵ 1:ͭ)
		fputc( 1, fp );		// basic  (1byte) : BASIC⡼(PC-6001ξ̵̣)
		fputc( 1, fp );		// page   (1byte) : ڡ
		fputc( 0, fp );		// askey  (2byte) : ȥȥޥʸ
		fputc( 0, fp );		// ...ޥɤϤθaskeyʬ³
		fputc( 0, fp );		// exhead (2byte) : ĥ󥵥(64KBޤ)
		fputc( 0, fp );		// ...ĥ󤬤Ϥθexheadʬ³
		
		// [DATA֥å]
		fputc( 'T', fp );				// header (2byte) : "TI"
		fputc( 'I', fp );
		fputc( 0, fp );					// id     (1byte) : IDֹ(DATA֥åϢդ)
		for( int i=0; i<16; i++ ) fputc( 0, fp );	// name  (16byte) : ǡ̾(15ʸ+'00H')
		PUTWORD( Baud, fp );			// baud   (2byte) : ܡ졼(600/1200)
		fputc( 0x48, fp );				// stime  (2byte) : ̵λ(ms)
		fputc( 0x0d, fp );
		fputc( 0x48, fp );				// ptime  (2byte) : ԡλ(ms)
		fputc( 0x0d, fp );
		fputc( 0, fp );					// offset (4byte) : ٥᡼ƬΥեå
		fputc( 0, fp );
		fputc( 0, fp );
		fputc( 0, fp );
		PUTDWORD( beta, fp );			// size   (4byte) : ǡ
		
		// [٥᡼]
		PUTDWORD( beta, fp );
		
		fclose( fp );
		fp = NULL;
		*FilePath = '\0';
	}
}


////////////////////////////////////////////////////////////////
// ܡ졼
////////////////////////////////////////////////////////////////
void CMTS::SetBaud( int b )
{
	Baud = b;
}


////////////////////////////////////////////////////////////////
// CMT 1ʸ
////////////////////////////////////////////////////////////////
void CMTS::CmtWrite( BYTE data )
{
	if( fp ) fputc( data, fp );
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL CMTL::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	// TAPEޥȤƤʤв⤷ʤ
	if( !p6t ) return TRUE;
	
	Ini->PutEntry( "TAPE", NULL, "FilePath",	"%s",		FilePath );
	Ini->PutEntry( "TAPE", NULL, "Relay",		"%s",		Relay ? "Yes" : "No" );
	
	return p6t->DokoSave( Ini );
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL CMTL::DokoLoad( cIni *Ini )
{
//	char strva[MAX_PATH];
	
	if( !Ini ) return FALSE;
	
	Ini->GetString( "TAPE", "FilePath", 		FilePath, 	"" );
	if( *FilePath ){
		if( !Mount( FilePath ) ) return FALSE;
		if( !p6t->DokoLoad( Ini ) ) return FALSE;
	}else
		Unmount();
	
	Ini->GetTruth( "TAPE", "Relay",				&Relay,		Relay );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor CMTL::descriptor = {
	CMTL::indef, CMTL::outdef
};

const Device::OutFuncPtr CMTL::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &CMTL::OutB0H )
};

const Device::InFuncPtr CMTL::indef[] = {};
