#ifndef TAPE_H_INCLUDED
#define TAPE_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "p6t2.h"
#include "sound.h"

#include "p6device.h"


// ǡμ
#define PG_P	(0x0000)
#define PG_S	(0x0100)
#define PG_D	(0x0200)


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class CMTL : public P6DEVENT, public Device, public SndDev, public IDoko {
private:
	char FilePath[PATH_MAX];	// TAPEեեѥ
	cP6T *p6t;
	BOOL Relay;					// 졼ξ
	
	BOOL Remote( BOOL );		// ⡼(PLAY,STOP)
	WORD CmtRead();				// CMT 1ʸɹ
	int GetSinCurve( int );		// sinȼ
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int, BYTE data ){ Remote( data&0x08 ? TRUE : FALSE ); }
	
public:
	CMTL( VM6 *, const ID& );		// 󥹥ȥ饯
	virtual ~CMTL();				// ǥȥ饯
	
	void EventCallback( int, int );	// ٥ȥХåؿ
	
	BOOL Init( cRing * );			// 
	void Reset();					// ꥻå
	
	BOOL Mount( char * );			// TAPE ޥ
	void Unmount();					// TAPE ޥ
	
	WORD Update();					// ȥ꡼๹
//	void SoundUpdate( int );		// ǽŪˤϤηˤ
	
	BOOL IsMount();					// ޥȺѤ?
	BOOL IsAutoStart();				// ȥ?
	
	char *GetFile();				// եѥ
	char *GetName();				// TAPE̾
	DWORD GetSize();				// ٥᡼
	int GetCount();					// 󥿼
	BOOL IsRelay();					// 졼ξּ
	
	// ǥХID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );		// ɤǤSAVE
	BOOL DokoLoad( cIni * );		// ɤǤLOAD
	// ------------------------------------------
};


class CMTS : public P6DEVENT {
private:
	char FilePath[PATH_MAX];		// TAPEեեѥ
	
	FILE *fp;						// FILE ݥ
	int Baud;						// ܡ졼
	
public:
	CMTS( VM6 * );					// 󥹥ȥ饯
	~CMTS();						// ǥȥ饯
	
	BOOL Init();					// 
	
	BOOL Mount( char * );			// TAPE ޥ
	void Unmount();					// TAPE ޥ
	
	void SetBaud( int );			// ܡ졼
	
	void CmtWrite( BYTE );			// CMT 1ʸ
};


#endif	// TAPE_H_INCLUDED
