#ifndef VOICE_H_INCLUDED
#define VOICE_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "pd7752.h"
#include "sound.h"

#include "p6device.h"

// [OUT]
//  E0H : ѥ᡼ž
//  E1H : ?
//  E2H : ⡼ɥå : 0 0 0 0 F S1 S0
//			F     : ʬϥե졼 0: 10ms/ե졼
//									 1: 20ms/ե졼
//			S1,S0 : ȯ®BIT     00: NORMAL SPEED
//									01: SLOW SPEED
//									10: FAST SPEED
//									11: ػ

//  E3H : ޥɥå
//		򥳥ޥ : 0  0 P5 P4 P3 P2 P1 P0
//			P5-P0 : ӥå(0-63)
//		ȥåץޥ   : 1  1  1  1  1  1  1  1
//		򥳥ޥ : 1  1  1  1  1  1  1  0
//

// [IN]
//  E0H : ơ쥸 : BSY REQ ~INT/EXT ERR 0 0 0 0
//			BSY      :  1: 0:
//			REQ      : ѥ᡼ 1:׵ 0:ػ
//			~INT/EXT : åǡ 1: 0:
//			ERR      : 顼ե饰 1:顼 0:顼ʤ
//  E1H : ?
//  E2H : PortE2˽?
//  E3H : PortE3˽?


// ߥ󥰤˴ؤư
// [Υڥå]
// ޥȯԤ1ե졼ܤΥѥ᡼ϴλޤ2ms(NORMAL SPEED)
//   ڵۥޥȯԤREQޤǤλ֤?
// ե졼ǺǽREQѥ᡼Ϥޤ3/4ե졼ְ
//   ڹͻϴλȯޤǤ1/4ե졼ְǳμ¤˽?
//   ڵۼREQޤǤλ֤?
//
// [ڥå]
// ޥȯԤ1ե졼ܤΥѥ᡼ϴλޤ1ե졼ְ
// 1ե졼ַвȯ(1ե졼ʬΥץ)ƱREQ=1
// ȯ鼡ե졼Υѥ᡼ϴλޤ1ե졼ְ


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class VCE6 : public P6DEVENT, public Device, public PD7752, public SndDev {
private:
	char FilePath[PATH_MAX];	// WAVEեǼѥ
	
	BYTE io_E0H;
	BYTE io_E2H;
	BYTE io_E3H;
	
	int VStat;					// ơ
	
	// ط
	int IVLen;					// ץ
	int *IVBuf;					// ǡХåե
	int IVPos;					// ɹߥݥ
	
	// ѥ᡼Хåե(1ե졼Υѥ᡼7)
	BYTE ParaBuf[7];			// ѥ᡼Хåե
	int	Pnum;					// ѥ᡼
	int Fnum;					// ֤ե졼
	BOOL PReady;				// ѥ᡼åȴλ
	
	D7752_SAMPLE *Fbuf;			// ե졼Хåեݥ(10kHz 1ե졼)
	
	void VSetMode( BYTE );			// ⡼ɥå
	void VSetCommand( BYTE );		// ޥɥå
	void VSetData( BYTE );			// ѥ᡼ž
	int VGetStatus();				// ơ쥸
	void AbortVoice();				// ȯ
	void UpConvert();				// ץ󥰥졼Ѵ
	BOOL LoadVoice( int );			// WAVɹ
	void FreeVoice();				// WAV
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutE0H( int, BYTE data ){ VSetData( data ); }
	inline void OutE2H( int, BYTE data ){ VSetMode( data ); }
	inline void OutE3H( int, BYTE data ){ VSetCommand( data ); }
	inline BYTE InE0H( int ){ return VGetStatus(); }
	inline BYTE InE2H( int ){ return io_E2H; }
	inline BYTE InE3H( int ){ return io_E3H; }
	
public:
	VCE6( VM6 *, const ID& );		// 󥹥ȥ饯
	~VCE6();						// ǥȥ饯
	
	void EventCallback( int, int );	// ٥ȥХåؿ
	
	BOOL Init( cRing *, char * );	// 
	void Reset( void );				// ꥻå
	
	void SoundUpdate( int );		// ȥ꡼๹
	
	// ǥХID
	enum IDOut{ outE0H=0, outE2H, outE3H };
	enum IDIn {  inE0H=0,  inE2H,  inE3H };
};

#endif	// VOICE_H_INCLUDED
