#ifndef Z80_H_INCLUDED
#define Z80_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"

#include "p6device.h"

// ڥ쥸 ǡ
typedef union {
	struct { BYTE l,h; } B;
			 WORD        W;
} PAIR;

// 쥸 ¤
struct Register {
	PAIR AF, BC, DE, HL;	// ѥ쥸
	PAIR IX, IY, PC, SP;	// ѥ쥸
	PAIR AF1,BC1,DE1,HL1;	//  ΢ 쥸
	BYTE I, R;				// ü쥸
	BYTE R_saved;			// R reg ¸
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// ⡼
	BYTE Halt;				// HALT ե饰
};


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cz80 : public IDoko {
protected:
	typedef signed char	offset;
	
	PAIR AF, BC, DE, HL;	// ѥ쥸
	PAIR IX, IY, PC, SP;	// ѥ쥸
	PAIR AF1,BC1,DE1,HL1;	//  ΢ 쥸
	BYTE I, R;				// ü쥸
	BYTE R_saved;			// R reg ¸
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// ⡼
	BYTE Halt;				// HALT ե饰
	
	int M1Wait;				// M1
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	void PrintfHead( char *, WORD, int );	// ɥ쥹/󥹥ȥ饯󥳡ɤɽ
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// @@@@@ڼ¸ۥꥢ @@@@@
	int mstate;		// ꥢ ơȿ
	// Ȥʤ
	virtual BYTE ReadMem( WORD )         = 0;
	virtual void WriteMem( WORD, BYTE )  = 0;
	// Ȥꥢ
	virtual BYTE ReadMemW( WORD )        = 0;
	virtual void WriteMemW( WORD, BYTE ) = 0;
	
	// I/Oݡȥ
	virtual BYTE ReadIO( int )           = 0;
	virtual void WriteIO( int, BYTE )    = 0;
	
	// ߥ٥
	virtual int GetIntrVector() = 0;
	
public:
	cz80();					// 󥹥ȥ饯
	virtual ~cz80();		// ǥȥ饯
	
	void Reset();			// ꥻå
	int Exec();				// 1̿¹
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХå
	int Disasm( char *, WORD );		// 1饤ե֥
	void GetRegister( Register * );	// 쥸ͼ
	void SetRegister( Register * );	// 쥸
	WORD GetPC(){ return PC.W; }	// PC쥸ͼ
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class CPU6 : public P6DEVICE, public Device, public cz80 {
private:
	// ꥢ(Ȥʤ)
	inline BYTE ReadMem( WORD );
	inline void WriteMem( WORD, BYTE );
	
	// @@@@@ڼ¸ۥꥢ @@@@@
	// ꥢ(Ȥ)
	inline BYTE ReadMemW( WORD );
	inline void WriteMemW( WORD, BYTE );
	
	// I/Oݡȥ
	inline BYTE ReadIO( int );
	inline void WriteIO( int, BYTE );
	
	// ߥ٥
	inline int GetIntrVector();
	
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutF3H( int, BYTE data ){ M1Wait = (data&0x80 ? 1 : 0); }
	
public:
	CPU6( VM6 *, const ID& );	// 󥹥ȥ饯
	~CPU6();					// ǥȥ饯
	
	BOOL Init();				// 
	
	// ǥХID
	enum IDOut{ outF3H=0 };
	enum IDIn {};
};

#endif		// Z80_H_INCLUDED
